package ch.ige.adr.client;

import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Cursor;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;
import javax.swing.table.JTableHeader;

import org.apache.log4j.Logger;

import ch.ige.adr.server.AdresseDelegate;
import ch.ige.adr.vo.AdresseAVO;
import ch.ige.adr.vo.AdresseSelKritVO;
import ch.ige.adrhelp.HelpUtil;
import ch.ige.authz.gui.GUIAuthorizer;
import ch.ige.main.client.GlassComponent;
import ch.ige.main.client.MainController;
import ch.ige.main.client.MainRootPane;
import ch.ige.main.client.SelectionPane;
import ch.ige.main.client.XxMessage;
import ch.ige.util.client.IgeTable;
import ch.ige.util.client.LimitedDocument;
import ch.ige.util.client.SwingWorker;
import ch.ige.util.client.TableSorterView;

/**
 * Auswahl der Versandadressen
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: AdresseAwl.java,v 1.51 2008/04/28 15:32:34 galli Exp $
 */
public class AdresseAwl extends SelectionPane
{
  // Logging
  private static final Logger LOG = Logger.getLogger( AdresseAwl.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  // Detail-Pane
  protected AdresseDtl adresseDtl = null;

  // selektierte Adressnummer
  protected int selAdrNr = 0; // 0 == keine Adresse selektiert

  //Frame konstruieren
  protected JPanel mainPanel = new JPanel(); //  @jve:decl-index=0:visual-constraint="10,72"

  protected JPanel selKrit = new JPanel();

  protected JPanel selTablePanel = new JPanel();

  protected JScrollPane selTableScrollPane = new JScrollPane();

  protected BorderLayout borderLayout22 = new BorderLayout();

  // Adressen Tabelle
  protected AdresseTableModel tableModel = new AdresseTableModel();

  protected TableSorterView tableSorterView = new TableSorterView( tableModel );

  protected IgeTable selTable = new IgeTable( tableSorterView );

  protected JLabel lblAdrNr = new JLabel();

  protected JLabel lblSuchbegr = new JLabel();

  protected JLabel lblName = new JLabel();

  protected JLabel lblPlz = new JLabel();

  protected JTextField txfAdrNr = new JTextField();

  protected JTextField txfSuchbegr = new JTextField();

  protected JTextField txfName = new JTextField();

  protected JTextField txfPlz = new JTextField();

  protected JLabel lblStrasse = new JLabel();

  protected JTextField txfStrasse = new JTextField();

  protected JTextField txfOrt = new JTextField();

  protected JLabel lblOrt = new JLabel();

  protected JTextField txfLandCd = new JTextField();

  protected JLabel lblLandCd = new JLabel();

  protected OrtsabgleichPanel pnlOrtsabgleich = new OrtsabgleichPanel();

  protected SuchmodusPanel pnlSuchmodusName = new SuchmodusPanel();

  protected SuchmodusPanel pnlSuchmodusOrt = new SuchmodusPanel();

  protected LimitedDocument ldoAdrNr = new LimitedDocument();

  protected LimitedDocument ldoSuchbegr = new LimitedDocument();

  protected LimitedDocument ldoName = new LimitedDocument();

  protected LimitedDocument ldoStrasse = new LimitedDocument();

  protected LimitedDocument ldoPlz = new LimitedDocument();

  protected LimitedDocument ldoOrt = new LimitedDocument();

  protected LimitedDocument ldoLand = new LimitedDocument();

  protected JLabel lblGesperrt = new JLabel();

  protected JRadioButton rbnGesperrtAlle = new JRadioButton();

  protected JRadioButton rbnNurGueltige = new JRadioButton();

  protected JRadioButton rbnNurGesperrte = new JRadioButton();

  protected JRadioButton rbnNurMit = new JRadioButton();

  protected JLabel lblDepKto = new JLabel();

  protected JRadioButton rbnDepKtotAlle = new JRadioButton();

  protected JRadioButton rbnNurOhne = new JRadioButton();

  protected ButtonGroup bgrDepKto = new ButtonGroup();

  protected ButtonGroup bgrGesperrt = new ButtonGroup();

  /**
   * Konstuktor
   */
  public AdresseAwl()
  {
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Konstuktor
   * @param mainController Hauptsteuerung
   * @param mode Modus MainRootPane.SEARCH oder MainRootPane.SEARCH_LOOKUP
   */
  public AdresseAwl( MainController mainController, int mode )
  {
    super( mainController, mode );
    focusOwner = txfAdrNr;
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Komponente initialisieren
   * @throws Exception
   */
  void jbInit() throws Exception
  {
    pnlSuchmodusOrt.setPreferredSize( new Dimension( 135, 22 ) );
    txfLandCd.setHorizontalAlignment( JTextField.LEFT );
    txfLandCd.setPreferredSize( new Dimension( 31, 20 ) );
    txfOrt.setHorizontalAlignment( JTextField.LEFT );
    txfOrt.setPreferredSize( new Dimension( 324, 20 ) );
    txfPlz.setHorizontalAlignment( JTextField.LEFT );
    txfPlz.setPreferredSize( new Dimension( 75, 20 ) );
    txfStrasse.setHorizontalAlignment( JTextField.LEFT );
    txfStrasse.setPreferredSize( new Dimension( 324, 20 ) );
    txfStrasse.setComponentOrientation( ComponentOrientation.LEFT_TO_RIGHT );
    txfName.setHorizontalAlignment( JTextField.LEFT );
    txfName.setPreferredSize( new Dimension( 324, 20 ) );
    txfName.setComponentOrientation( ComponentOrientation.LEFT_TO_RIGHT );
    txfSuchbegr.setHorizontalAlignment( JTextField.LEFT );
    txfSuchbegr.setPreferredSize( new Dimension( 107, 20 ) );
    txfAdrNr.setHorizontalAlignment( JTextField.LEFT );
    txfAdrNr.setPreferredSize( new Dimension( 75, 20 ) );
    GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
    gridBagConstraints24.insets = new Insets( 0, 0, 0, 0 );
    gridBagConstraints24.gridy = 2;
    gridBagConstraints24.weightx = 1.0;
    gridBagConstraints24.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints24.fill = GridBagConstraints.NONE;
    gridBagConstraints24.gridx = 4;
    GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
    gridBagConstraints23.insets = new Insets( 3, 0, 1, 5 );
    gridBagConstraints23.gridy = 8;
    gridBagConstraints23.ipadx = 2;
    gridBagConstraints23.anchor = GridBagConstraints.EAST;
    gridBagConstraints23.gridx = 0;
    GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
    gridBagConstraints22.insets = new Insets( 2, 6, 0, 0 );
    gridBagConstraints22.gridx = 3;
    gridBagConstraints22.gridy = 9;
    gridBagConstraints22.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints22.gridheight = 1;
    GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
    gridBagConstraints21.insets = new Insets( 2, 7, 0, 0 );
    gridBagConstraints21.gridx = 2;
    gridBagConstraints21.gridy = 9;
    gridBagConstraints21.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints21.gridheight = 1;
    GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
    gridBagConstraints20.insets = new Insets( 2, 6, 0, 0 );
    gridBagConstraints20.gridx = 1;
    gridBagConstraints20.gridy = 9;
    gridBagConstraints20.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints20.gridheight = 1;
    GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
    gridBagConstraints19.fill = GridBagConstraints.NONE;
    gridBagConstraints19.gridwidth = 3;
    gridBagConstraints19.gridx = 1;
    gridBagConstraints19.gridy = 6;
    gridBagConstraints19.ipadx = 0;
    gridBagConstraints19.weightx = 0.0;
    gridBagConstraints19.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints19.insets = new Insets( 2, 6, 0, 0 );
    GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
    gridBagConstraints18.fill = GridBagConstraints.NONE;
    gridBagConstraints18.gridheight = 2;
    gridBagConstraints18.gridwidth = 2;
    gridBagConstraints18.gridx = 1;
    gridBagConstraints18.gridy = 4;
    gridBagConstraints18.ipadx = 0;
    gridBagConstraints18.weightx = 0.0;
    gridBagConstraints18.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints18.insets = new Insets( 2, 6, 0, 0 );
    GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
    gridBagConstraints17.fill = GridBagConstraints.NONE;
    gridBagConstraints17.gridwidth = 3;
    gridBagConstraints17.gridx = 1;
    gridBagConstraints17.gridy = 3;
    gridBagConstraints17.ipadx = 0;
    gridBagConstraints17.weightx = 0.0;
    gridBagConstraints17.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints17.insets = new Insets( 2, 6, 0, 0 );
    GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
    gridBagConstraints16.fill = GridBagConstraints.NONE;
    gridBagConstraints16.gridwidth = 3;
    gridBagConstraints16.gridx = 1;
    gridBagConstraints16.gridy = 2;
    gridBagConstraints16.ipadx = 0;
    gridBagConstraints16.weightx = 0.0;
    gridBagConstraints16.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints16.insets = new Insets( 2, 6, 0, 0 );
    GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
    gridBagConstraints15.fill = GridBagConstraints.NONE;
    gridBagConstraints15.gridwidth = 2;
    gridBagConstraints15.gridx = 1;
    gridBagConstraints15.gridy = 1;
    gridBagConstraints15.ipadx = 0;
    gridBagConstraints15.weightx = 0.0;
    gridBagConstraints15.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints15.insets = new Insets( 2, 6, 0, 0 );
    GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
    gridBagConstraints14.fill = GridBagConstraints.NONE;
    gridBagConstraints14.gridx = 1;
    gridBagConstraints14.gridy = 7;
    gridBagConstraints14.ipadx = 0;
    gridBagConstraints14.weightx = 0.0;
    gridBagConstraints14.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints14.insets = new Insets( 2, 6, 0, 16 );
    GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
    gridBagConstraints13.fill = GridBagConstraints.NONE;
    gridBagConstraints13.gridwidth = 2;
    gridBagConstraints13.gridx = 1;
    gridBagConstraints13.gridy = 0;
    gridBagConstraints13.ipadx = 0;
    gridBagConstraints13.weightx = 0.0;
    gridBagConstraints13.anchor = GridBagConstraints.WEST;
    gridBagConstraints13.insets = new Insets( 10, 6, 0, 0 );
    GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
    gridBagConstraints12.insets = new Insets( 2, 7, 0, 0 );
    gridBagConstraints12.gridx = 2;
    gridBagConstraints12.gridy = 8;
    gridBagConstraints12.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints12.gridheight = 1;
    GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
    gridBagConstraints11.insets = new Insets( 2, 6, 0, 0 );
    gridBagConstraints11.gridx = 3;
    gridBagConstraints11.gridy = 8;
    gridBagConstraints11.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints11.gridheight = 1;
    GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
    gridBagConstraints10.insets = new Insets( 2, 6, 0, 0 );
    gridBagConstraints10.gridx = 1;
    gridBagConstraints10.gridy = 8;
    gridBagConstraints10.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints10.fill = GridBagConstraints.NONE;
    gridBagConstraints10.ipadx = 0;
    gridBagConstraints10.gridheight = 1;
    GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
    gridBagConstraints9.insets = new Insets( 0, 0, 0, 5 );
    gridBagConstraints9.gridy = 9;
    gridBagConstraints9.ipadx = 49;
    gridBagConstraints9.anchor = GridBagConstraints.EAST;
    gridBagConstraints9.gridx = 0;
    GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
    gridBagConstraints7.insets = new Insets( 5, 0, 1, 5 );
    gridBagConstraints7.gridy = 1;
    gridBagConstraints7.ipadx = 36;
    gridBagConstraints7.anchor = GridBagConstraints.EAST;
    gridBagConstraints7.gridx = 0;
    GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
    gridBagConstraints6.insets = new Insets( 5, 0, 1, 5 );
    gridBagConstraints6.gridy = 0;
    gridBagConstraints6.ipadx = 44;
    gridBagConstraints6.anchor = GridBagConstraints.EAST;
    gridBagConstraints6.gridx = 0;
    GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
    gridBagConstraints5.insets = new Insets( 1, 0, 0, 0 );
    gridBagConstraints5.gridy = 6;
    gridBagConstraints5.weightx = 1.0;
    gridBagConstraints5.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints5.fill = GridBagConstraints.NONE;
    gridBagConstraints5.gridx = 4;
    GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
    gridBagConstraints4.insets = new Insets( 5, 0, 2, 5 );
    gridBagConstraints4.gridy = 7;
    gridBagConstraints4.ipadx = 74;
    gridBagConstraints4.anchor = GridBagConstraints.EAST;
    gridBagConstraints4.gridx = 0;
    GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    gridBagConstraints3.insets = new Insets( 5, 0, 1, 5 );
    gridBagConstraints3.gridy = 6;
    gridBagConstraints3.ipadx = 84;
    gridBagConstraints3.anchor = GridBagConstraints.EAST;
    gridBagConstraints3.gridx = 0;
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    gridBagConstraints2.insets = new Insets( 5, 0, 1, 5 );
    gridBagConstraints2.gridy = 2;
    gridBagConstraints2.ipadx = 69;
    gridBagConstraints2.anchor = GridBagConstraints.EAST;
    gridBagConstraints2.gridx = 0;
    GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
    gridBagConstraints1.insets = new Insets( 5, 0, 0, 5 );
    gridBagConstraints1.gridy = 3;
    gridBagConstraints1.ipadx = 57;
    gridBagConstraints1.anchor = GridBagConstraints.EAST;
    gridBagConstraints1.gridx = 0;
    GridBagConstraints gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.insets = new Insets( 5, 0, 1, 5 );
    gridBagConstraints.gridy = 5;
    gridBagConstraints.ipadx = 80;
    gridBagConstraints.anchor = GridBagConstraints.EAST;
    gridBagConstraints.gridx = 0;
    mainPanel.setLayout( new BorderLayout() );
    mainPanel.setSize( new Dimension( 730, 497 ) );

    selKrit.setMaximumSize( new Dimension( 2147483647, 240 ) );
    selKrit.setMinimumSize( new Dimension( 300, 240 ) );
    selKrit.setPreferredSize( new Dimension( 300, 255 ) );
    selKrit.setLayout( new GridBagLayout() );

    selTable.setPreferredScrollableViewportSize( new Dimension( 450, 50 ) );
    selTablePanel.setLayout( borderLayout22 );
    lblPlz.setHorizontalAlignment( SwingConstants.RIGHT );
    lblPlz.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblPlz.setText( "PLZ:" );
    lblAdrNr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblAdrNr.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblAdrNr.setText( "Adress-Nr:" );
    lblSuchbegr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblSuchbegr.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblSuchbegr.setText( "Suchbegriff:" );
    lblName.setHorizontalAlignment( SwingConstants.RIGHT );
    lblName.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblName.setText( "Name:" );
    lblStrasse.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStrasse.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblStrasse.setText( "Strasse:" );

    lblOrt.setHorizontalAlignment( SwingConstants.RIGHT );
    lblOrt.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblOrt.setText( "Ort:" );
    lblLandCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblLandCd.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblLandCd.setText( "Land:" );
    txfAdrNr.setDocument( ldoAdrNr );
    txfSuchbegr.setDocument( ldoSuchbegr );
    txfName.setDocument( ldoName );
    txfStrasse.setDocument( ldoStrasse );
    txfPlz.setDocument( ldoPlz );
    txfOrt.setDocument( ldoOrt );
    txfLandCd.setDocument( ldoLand );
    lblGesperrt.setHorizontalAlignment( SwingConstants.RIGHT );
    lblGesperrt.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblGesperrt.setText( "Sperrung:" );
    rbnGesperrtAlle.setText( "alle" );
    rbnGesperrtAlle.setPreferredSize( new Dimension( 50, 22 ) );
    rbnGesperrtAlle.setSelected( true );
    rbnGesperrtAlle.setActionCommand( AdresseSelKritVO.ALLE );
    rbnNurGueltige.setText( "nur gültige" );
    rbnNurGueltige.setPreferredSize( new Dimension( 85, 22 ) );
    rbnNurGueltige.setActionCommand( AdresseSelKritVO.NUR_GUELTIGE );
    rbnNurGesperrte.setText( "nur gesperrte" );
    rbnNurGesperrte.setPreferredSize( new Dimension( 103, 22 ) );
    rbnNurGesperrte.setActionCommand( AdresseSelKritVO.NUR_GESPERRTE );
    lblDepKto.setHorizontalAlignment( SwingConstants.RIGHT );
    lblDepKto.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblDepKto.setText( "Deponentenkonto:" );
    rbnDepKtotAlle.setText( "alle" );
    rbnDepKtotAlle.setPreferredSize( new Dimension( 50, 22 ) );
    rbnDepKtotAlle.setSelected( true );
    rbnDepKtotAlle.setActionCommand( AdresseSelKritVO.ALLE );
    rbnNurMit.setText( "nur mit" );
    rbnNurMit.setPreferredSize( new Dimension( 65, 22 ) );
    rbnNurMit.setActionCommand( AdresseSelKritVO.NUR_MIT );
    rbnNurOhne.setText( "nur ohne" );
    rbnNurOhne.setPreferredSize( new Dimension( 75, 22 ) );
    rbnNurOhne.setActionCommand( AdresseSelKritVO.NUR_OHNE );
    pnlSuchmodusName.setMinimumSize( new Dimension( 300, 35 ) );
    pnlSuchmodusName.setPreferredSize( new Dimension( 135, 22 ) );
    bgrGesperrt.add( rbnGesperrtAlle );
    bgrGesperrt.add( rbnNurGueltige );
    bgrGesperrt.add( rbnNurGesperrte );
    bgrDepKto.add( rbnDepKtotAlle );
    bgrDepKto.add( rbnNurMit );
    bgrDepKto.add( rbnNurOhne );
    centerPanel.add( mainPanel, BorderLayout.CENTER );

    mainPanel.add( selKrit, BorderLayout.NORTH );
    mainPanel.add( selTablePanel, BorderLayout.CENTER );

    //   mainPanel.add(selKrit);
    selKrit.setBorder( new TitledBorder( "Selektionskriterien" ) );
    selTablePanel.setBorder( new TitledBorder( "Adressen" ) );

    selTablePanel.add( selTableScrollPane, BorderLayout.CENTER );
    selKrit.add( lblPlz, gridBagConstraints );
    selKrit.add( lblStrasse, gridBagConstraints1 );
    selKrit.add( lblName, gridBagConstraints2 );
    selKrit.add( lblOrt, gridBagConstraints3 );
    selKrit.add( lblLandCd, gridBagConstraints4 );
    selTableScrollPane.getViewport().add( selTable );
    // Tabelle
    tableSorterView.addMouseListenerToHeaderInTable( selTable );

    JTableHeader header = selTable.getTableHeader();
    header.addMouseListener( new MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        header_MouseListener( e );
      }
    } );

    // Spaltenbreite der Tabelle
    selTable.getColumnModel().getColumn( 0 ).setPreferredWidth( 60 );
    selTable.getColumnModel().getColumn( 1 ).setPreferredWidth( 80 );
    selTable.getColumnModel().getColumn( 2 ).setPreferredWidth( 150 );
    selTable.getColumnModel().getColumn( 3 ).setPreferredWidth( 150 );
    selTable.getColumnModel().getColumn( 4 ).setPreferredWidth( 60 );
    selTable.getColumnModel().getColumn( 5 ).setPreferredWidth( 100 );
    selTable.getColumnModel().getColumn( 6 ).setPreferredWidth( 30 );

    selTable.addMouseListener( new MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        selTable_MouseListener( e );
      }
    } );
    selTable.addFocusListener( new java.awt.event.FocusAdapter()
    {
      public void focusGained( FocusEvent e )
      {
        selTable_focusGained( e );
      }
    } );
    selTable.addFocusListener( new java.awt.event.FocusAdapter()
    {
      public void focusLost( FocusEvent e )
      {
        selTable_focusLost( e );
      }
    } );
    selTable.addKeyListener( new java.awt.event.KeyAdapter()
    {
      public void keyPressed( KeyEvent e )
      {
        selTable_keyPressed( e );
      }
    } );

    ldoAdrNr.setMaxLength( 10 );
    ldoAdrNr.setInteger( true );
    ldoSuchbegr.setMaxLength( 10 );
    ldoSuchbegr.setUpperCase( true );
    ldoName.setMaxLength( 50 );
    ldoStrasse.setMaxLength( 50 );
    ldoPlz.setMaxLength( 8 );
    ldoOrt.setMaxLength( 50 );
    ldoLand.setMaxLength( 3 );
    ldoLand.setUpperCase( true );

    selKrit.add( pnlSuchmodusOrt, gridBagConstraints5 );
    selKrit.add( lblAdrNr, gridBagConstraints6 );
    selKrit.add( lblSuchbegr, gridBagConstraints7 );
    selKrit.add( lblGesperrt, gridBagConstraints9 );
    selKrit.add( rbnDepKtotAlle, gridBagConstraints10 );
    selKrit.add( rbnNurOhne, gridBagConstraints11 );
    selKrit.add( rbnNurMit, gridBagConstraints12 );
    selKrit.add( txfAdrNr, gridBagConstraints13 );
    selKrit.add( txfLandCd, gridBagConstraints14 );
    selKrit.add( txfSuchbegr, gridBagConstraints15 );
    selKrit.add( txfName, gridBagConstraints16 );
    selKrit.add( txfStrasse, gridBagConstraints17 );
    selKrit.add( txfPlz, gridBagConstraints18 );
    selKrit.add( txfOrt, gridBagConstraints19 );
    selKrit.add( rbnGesperrtAlle, gridBagConstraints20 );
    selKrit.add( rbnNurGueltige, gridBagConstraints21 );
    selKrit.add( rbnNurGesperrte, gridBagConstraints22 );
    selKrit.add( lblDepKto, gridBagConstraints23 );
    selKrit.add( pnlSuchmodusName, gridBagConstraints24 );
    toolBar.add( pnlOrtsabgleich );
    setGlassPane( new GlassComponent() );
    setStateNotFound();

  } // jbInit

  //********** Öffentliche Standard-Methoden *******************************

  /**
   * Gibt den Titel für das Frame zurück
   * @return Titel
   */
  public String getTitle()
  {
    return "Versandadresse Auswahl";
  }

  //********** Öffentliche, panespezifische Methoden *******************************

  /**
   * Gibt die Adressnummer mit einem modalen Aufruf zurück.
   * Der Modus muss SEARCH_LOOKUP und der MainController muss modal sein.
   * @return Adressnummer
   */
  public int getAdrNrModal()
  {
    mainController.getWindow().setVisible( true );
    return selAdrNr;
  }

  /**
   * Setzt die Selektionskriterien
   * @param selKrit Selektionskriterien
   */
  public void setSelKrit( AdresseSelKritVO selKrit )
  {
    if ( selKrit.adrNr != 0 )
    {
      txfAdrNr.setText( "" + selKrit.adrNr );
    }
    txfName.setText( selKrit.name );
    txfStrasse.setText( selKrit.strasse );
    txfPlz.setText( selKrit.plz );
    txfOrt.setText( selKrit.ort );
    txfLandCd.setText( selKrit.landCd );
  }

  /**
   * Das Neu-Menü wurde gewählt.
   * Erfassungswizard anzeigen.
   * @param e ActionEvent
   */
  protected void mnuNew_actionPerformed( ActionEvent e )
  {
    statusBar.setText( " " );
    Window window = mainController.getWindow();

    AdresseWizard aw;
    if ( window instanceof Frame )
    {
      aw = new AdresseWizard( (Frame) window );
    }
    else
    {
      aw = new AdresseWizard( (Dialog) window );
    }
    Integer adrNr;
    try
    {
      adrNr = aw.newVersadr();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      return;
    }
    if ( adrNr == null )
    {
      // Erfassen wurde abgebrochen
      statusBar.setText( "Erfassen wurde abgebrochen" );
    }
    else
    {
      setForwardEnabled( true );
      adresseDtl = new AdresseDtl( mainController, MainRootPane.DETAIL );
      adresseDtl.setKey( adrNr );
      adresseDtl.read();
      // Datensatz gespeichert.
      String message = xxMessage.getMessage( 1004 );
      adresseDtl.setStatusBar( message );
      mainController.next( adresseDtl );
    }
  }

  /**
   * Das Suchen-Menü wurde gewählt,
   * Daten für Auswahl suchen und anzeigen
   * @param e ActionEvent
   */
  protected void mnuFind_actionPerformed( ActionEvent e )
  {
    tableModel.clear();
    // Bitte warten...
    String message = xxMessage.getMessage( 1 );
    statusBar.setText( message );

    // Selektionskriterien abfüllen
    final AdresseSelKritVO selKrit = new AdresseSelKritVO();
    try
    {
      selKrit.adrNr = Integer.parseInt( txfAdrNr.getText() );
    }
    catch ( NumberFormatException ex )
    {
      selKrit.adrNr = 0;
    }
    selKrit.suchbegr = txfSuchbegr.getText().trim();
    selKrit.name = txfName.getText().trim();
    selKrit.strasse = txfStrasse.getText().trim();
    selKrit.plz = txfPlz.getText().trim();
    selKrit.ort = txfOrt.getText().trim();
    selKrit.landCd = txfLandCd.getText().trim();
    selKrit.nurOrtsabgleich = pnlOrtsabgleich.rbnOrtsabgleich.isSelected();
    // Suchmodus für Name setzen
    selKrit.suchmodusName = pnlSuchmodusName.buttonGroup.getSelection().getActionCommand();
    selKrit.suchmodusOrt = pnlSuchmodusOrt.buttonGroup.getSelection().getActionCommand();
    // Suchmodus für Deponentenkonto setzen
    selKrit.depKto = bgrDepKto.getSelection().getActionCommand();
    // Suchmodus für Sperrung setzen
    selKrit.gesperrt = bgrGesperrt.getSelection().getActionCommand();

    if ( selKrit.adrNr == 0 && selKrit.suchbegr.length() == 0 && selKrit.name.length() == 0 && selKrit.strasse.length() == 0 && selKrit.plz.length() == 0
        && selKrit.ort.length() == 0 && !selKrit.nurOrtsabgleich )
    {
      if ( selKrit.landCd.length() == 0 && !selKrit.nurOrtsabgleich )
      {
        // Es muss mindestens ein Suchkriterium abgefüllt sein.
        message = xxMessage.getMessage( 1112 );
        JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
        statusBar.setText( " " );
        return;
      }
      else
      {
        // Nach 'Land' kann nicht allein gesucht werden. Bitte weitere Suchbegriffe eingeben.
        message = xxMessage.getMessage( 1226 );
        JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
        statusBar.setText( " " );
        return;
      }
    }

    if ( selKrit.suchmodusName == AdresseSelKritVO.SUCHMODUS_VOLLTEXT && !selKrit.name.equals( "" )
        || selKrit.suchmodusOrt == AdresseSelKritVO.SUCHMODUS_VOLLTEXT && !selKrit.ort.equals( "" ) )
    {
      // Die Volltextsuche ist langsam.
      message = xxMessage.getMessage( 1032 );
      Object[] options = { "OK", "Abbrechen" };
      int selectedOption = JOptionPane.showOptionDialog( mainController.getWindow(), message, "Information", JOptionPane.DEFAULT_OPTION,
          JOptionPane.INFORMATION_MESSAGE, null, options, options[1] );
      if ( selectedOption == 1 )
      {
        // Abbrechen
        statusBar.setText( " " );
        return;
      }
    }
    getGlassPane().setVisible( true );
    // Daten lesen
    final SwingWorker worker = new SwingWorker()
    {
      public Object construct()
      {
        ArrayList adresseAL;
        try
        {
          AdresseDelegate ad = AdresseDelegate.getInstance();
          adresseAL = ad.findVersadr( selKrit );
        }
        catch ( Exception ex )
        {
          LOG.error( ex );
          String message = xxMessage.getMessage( ex );
          JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
          return null;
        }
        AdresseAVO[] adresseAVO = new AdresseAVO[adresseAL.size()];
        adresseAL.toArray( adresseAVO );
        tableModel.setData( adresseAVO );
        return null;
      }

      public void finished()
      {
        if ( tableModel.getRowCount() > 0 )
        {
          setStateFound();
          selTable.setRowSelectionInterval( 0, 0 );
          selTable.requestFocus();
          // Es wurden !P1 Datensätze gelesen !
          String message = xxMessage.getMessage( 19, "" + tableModel.getRowCount() );
          statusBar.setText( message );
        }
        else
        {
          setStateNotFound();
          // Keine Datensätze gefunden !
          String message = xxMessage.getMessage( 17 );
          statusBar.setText( message );
        }
        getGlassPane().setVisible( false );
      }
    }; // SwingWorker

    worker.start();

  } // mnuFind_actionPerformed

  /**
   * Das Ok-Menü wurde gewählt.
   * Schlüssel der gewählten Zeile zurückgeben.
   * @param e ActionEvent
   */
  protected void mnuOk_actionPerformed( ActionEvent e )
  {
    setStateSelected();
    // Schlüssel abfüllen
    int row = selTable.getSelectedRows()[0];
    selAdrNr = ( (Integer) tableSorterView.getValueAt( row, 0 ) ).intValue();
    mainController.getWindow().setVisible( false );
    mainController.getWindow().dispose();
  }

  //********* Menu bearbeiten *******************************************

  /**
   * Das Rückgängig-machen-Menü wurde gewählt.
   * Suchfelder löschen
   * @param e ActionEvent
   */
  protected void mnuUndo_actionPerformed( ActionEvent e )
  {
    setStateNotFound();
    txfAdrNr.requestFocus();
    txfAdrNr.setText( "" );
    txfName.setText( "" );
    txfStrasse.setText( "" );
    txfSuchbegr.setText( "" );
    txfPlz.setText( "" );
    txfOrt.setText( "" );
    txfLandCd.setText( "" );
    pnlOrtsabgleich.rbnNormal.setSelected( true );
    pnlSuchmodusName.rbnIndex.setSelected( true );
    pnlSuchmodusOrt.rbnIndex.setSelected( true );
    rbnDepKtotAlle.setSelected( true );
    rbnGesperrtAlle.setSelected( true );
    tableModel.clear();
    statusBar.setText( " " );
  }

  //********** Menu verzweigen *********************************************

  /**
   * Das Detail-Menü wurde gewählt.
   * Daten lesen und Detailseite anzeigen.
   * @param e ActionEvent
   */
  protected void mnuDetail_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    if ( mode == SEARCH )
    {
      setForwardEnabled( true );
      adresseDtl = new AdresseDtl( mainController, MainRootPane.DETAIL );
    }
    else if ( mode == SEARCH_LOOKUP )
    {
      adresseDtl = new AdresseDtl( mainController, MainRootPane.DETAIL_LOOKUP );
    }
    // Schlüssel abfüllen
    int row = selTable.getSelectedRows()[0];
    adresseDtl.setKey( (Integer) tableSorterView.getValueAt( row, 0 ) );
    adresseDtl.read();
    mainController.next( adresseDtl );
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Das Info-Menü wurde gewählt.
   * @param e ActionEvent
   */
  protected void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  //********** Popup-Menu **************************************************

  //********** Pane-spezifische Methoden ***********************************

  /**
   * Klick auf Zeile der Tabelle.
   * Bei Doppelclick weiterverzweigen
   * @param e MouseEvent
   */
  protected void selTable_MouseListener( MouseEvent e )
  {
    setStateFound();
    // bei Doppelclick weiterverzweigen
    if ( e.getClickCount() == 2 )
    {
      if ( mode == SEARCH )
      {
        mnuDetail_actionPerformed( null );
      }
      else if ( mode == SEARCH_LOOKUP )
      {
        mnuOk_actionPerformed( null );
      }
    }
  }

  /**
   * Falls Focus nicht mehr in der Tabelle ist, wird der Suchenknopf der Default.
   * @param e FocusEvent
   */
  protected void selTable_focusLost( FocusEvent e )
  {
    if ( !e.isTemporary() )
    {
      setDefaultButton( btnFind );
    }
  }

  /**
   * Falls der Focus wieder auf der Tabelle ist, wird der Detailknopf der Default.
   * @param e FocusEvent
   */
  protected void selTable_focusGained( FocusEvent e )
  {
    if ( mode == SEARCH )
    {
      setDefaultButton( btnDetail );
    }
    else
    {
      setDefaultButton( btnOk );
    }
  }

  /**
   * Enter-Taste in der Tabelle löst den DefaultButton aus.
   * @param e KeyEvent
   */
  protected void selTable_keyPressed( KeyEvent e )
  {
    if ( e.getKeyCode() == KeyEvent.VK_ENTER )
    {
      getDefaultButton().doClick();
      e.consume();
    }
  }

  /**
   * Setzt Menus und Buttons in den Initialzustand zurück
   * @param e Mousevent
   */
  protected void header_MouseListener( MouseEvent e )
  {
    setStateNotFound();
  }

  //********** Authorization ***************************************************

  /**
   * @return Authorisation Spezifikationen
   */
  public static String[] getAuthzSpecifications()
  {
    return new String[] { "*New    = Schreiben / VersandAdressen", "*Detail = Lesen     / VersandAdressen", };
  }

  /**
  * initializiert JavaHel.p
  */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this.getRootPane(), "adrSuchen" );

    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "adrSuchen" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "adrSuchen" );

    HelpUtil.getInstance().enableHelp( toolBar, "icons" );
    HelpUtil.getInstance().enableHelp( menuBar, "auswahlmenues" );

    HelpUtil.getInstance().enableHelp( txfAdrNr, "adrSuchen.selektionskriterien" );
    HelpUtil.getInstance().enableHelp( txfSuchbegr, "adrSuchen.selektionskriterien" );
    HelpUtil.getInstance().enableHelp( txfName, "adrSuchen.selektionskriterien" );
    HelpUtil.getInstance().enableHelp( txfPlz, "adrSuchen.selektionskriterien" );
    HelpUtil.getInstance().enableHelp( txfStrasse, "adrSuchen.selektionskriterien" );
    HelpUtil.getInstance().enableHelp( txfOrt, "adrSuchen.selektionskriterien" );
    HelpUtil.getInstance().enableHelp( txfLandCd, "adrSuchen.selektionskriterien" );
    HelpUtil.getInstance().enableHelp( selTable, "adrSuchen.ergebnis" );
  }
} // AdresseA
