package ch.ige.adr.client;

import java.security.PrivilegedAction;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import ch.ige.authz.client.AuthMain;
import ch.ige.main.client.MainController;
import ch.ige.main.client.MainRootPane;
import ch.ige.main.client.SplashScreen;
import ch.ige.main.client.XxMessage;
import ch.ige.util.client.ClientLogInitalizer;
import ch.ige.util.client.IgeLookAndFeel;

/**
 * Startpunkt der Adresskomponente
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: Main.java,v 1.16 2009/04/08 14:12:40 bouquet Exp $
 */
public class Main implements PrivilegedAction
{
  // Logging
  private static final Logger LOG = Logger.getLogger( "ch.ige" );

  static
  {
    ClientLogInitalizer.initalizeLogging();
  }

  /**
   * Dies ist die eigentliche Main method welche nach dem SSO ausgeführt wird.
   * @return don't care
   */
  public Object run()
  {
    // Splash screen anzeigen
    SplashScreen splashScreen = new SplashScreen();
    // Applikationsmeldungen laden
    try
    {
      XxMessage.getInstance();
    }
    catch ( Exception ex )
    {
      LOG.error( "exception caught", ex );
      JOptionPane.showMessageDialog( null, ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
      // Applikation im Fehlerfall beenden
      System.exit( 1 );
    }
    // Hauptfenster instanzieren
    MainController mc = new MainController();
    MenuPaneAdr mp = new MenuPaneAdr( mc, MainRootPane.DETAIL );
    // Splash screen entfernen
    splashScreen.setVisible( false );
    splashScreen.dispose();
    // Hauptmenu anzeigen
    mc.first( mp );
    return null;
  }

  /**
   * Main-Methode
   * @param args Parameter
  */
  public static void main( String[] args )
  {
    IgeLookAndFeel.setLF();
    AuthMain.run( new Main() );
  }
} // Main
