package ch.ige.adr.client;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.apache.log4j.Logger;

import ch.ige.adrhelp.HelpUtil;
import ch.ige.authz.gui.GUIAuthorizer;
import ch.ige.main.client.GlassComponent;
import ch.ige.main.client.MainController;
import ch.ige.main.client.XxMessage;

/**
 * Ortsabgleich durchführen und Ortsverzeichnis laden
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: Ortsabgleich.java,v 1.15 2008/04/28 15:32:34 galli Exp $
 */
public class Ortsabgleich extends SimpleMenuPane
{
  // Logging
  private static final Logger LOG = Logger.getLogger( Ortsabgleich.class );

  //Frame konstruieren
  protected JPanel mainPanel = new PnlOrtsabgleich(); //  @jve:decl-index=0:visual-constraint="10,84"

  protected BorderLayout borderLayout22 = new BorderLayout();

  /**
   * Konstuktor
   */
  public Ortsabgleich()
  {
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Konstuktor
   * @param mainController Hauptsteuerung
   * @param mode Modus MainRootPane.SEARCH oder MainRootPane.SEARCH_LOOKUP
   */
  public Ortsabgleich( MainController mainController, int mode )
  {
    super( mainController, mode );
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Komponente initialisieren
   * @throws Exception
   */
  private void jbInit() throws Exception
  {
    mainPanel.setSize( new Dimension( 770, 450 ) );
    mainPanel.setPreferredSize( new Dimension( 770, 450 ) );
    FlowLayout flowLayout = new FlowLayout();
    flowLayout.setAlignment( FlowLayout.LEFT );
    mainPanel.setLayout( flowLayout );
    setGlassPane( new GlassComponent() );

    this.getContentPane().add( mainPanel, BorderLayout.CENTER );
    btnBack.setEnabled( true );
    btnHome.setEnabled( true );
    this.setVisible( true );

  } // jbInit

  //********** Öffentliche Standard-Methoden *******************************

  /**
   * Gibt den Titel für das Frame zurück
   * @return Titel
   */
  public String getTitle()
  {
    return "Ortsabgleich";
  }

  //********** Aktionen *******************************

  /**
   * Das Info-Menü wurde gewählt.
   * @param e ActionEvent
   */
  protected void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  /**
   * Setzt den Text in der Statusbar
   * @param text Text
   */
  public void setStatusBar( String text )
  {
    statusBar.setText( text );
  }

  /**
   * initialisiert javahelp
   */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this.getRootPane(), "ortsabgleich" );

    HelpUtil.getInstance().enableHelp( toolBar, "icons" );
    HelpUtil.getInstance().enableHelp( menuBar, "auswahlmenues" );

    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "ortsabgleich" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "ortsabgleich" );

  }
}
