package ch.ige.adr.client;

import java.awt.Cursor;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.DefaultComboBoxModel;
import javax.swing.InputVerifier;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;

import org.apache.log4j.Logger;

import ch.ige.adr.server.AdresseDelegate;
import ch.ige.adr.vo.PostOrtAVO;
import ch.ige.main.client.PnlWizard;
import ch.ige.main.client.XxMessage;
import ch.ige.util.client.CharsetVerifier;
import ch.ige.util.client.LimitedDocument;
import ch.ige.util.vo.VersadrVO;

/**
 * Erfassen und Mutieren der Versandadresse
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: PnlAdresse.java,v 1.45 2007/12/13 10:13:24 galli Exp $
 */
public class PnlAdresse extends PnlAbstract
{
  // Logging
  private static final Logger LOG = Logger.getLogger( PnlAdresse.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  protected VersadrVO versadrVO = null;

  protected TitledBorder titledBorder1;

  //protected XYLayout xYLayout1 = new XYLayout();
  protected JLabel lblAdrNr = new JLabel();

  protected JTextField txfZeile4 = new JTextField();

  protected JLabel lblSuchbegr = new JLabel();

  protected JTextField txfZeile3 = new JTextField();

  protected JTextField txfLandCd = new JTextField();

  protected JTextField txfZeile2 = new JTextField();

  protected JTextField txfSuchbegr = new JTextField();

  protected JTextField txfZeile1 = new JTextField();

  protected JLabel lblZeile3 = new JLabel();

  protected JLabel lblZeile2 = new JLabel();

  protected JLabel lblZeile1 = new JLabel();

  protected JLabel lblZeile4 = new JLabel();

  protected JComboBox cbxSprachCd = new JComboBox();

  protected JTextField txfName = new JTextField();

  protected JTextField txfOrt = new JTextField();

  protected JTextField txfTelefon = new JTextField();

  protected JLabel lblTelefon = new JLabel();

  protected JTextField txfEMail = new JTextField();

  protected JLabel lblLandCd = new JLabel();

  protected JLabel lblSprachCd = new JLabel();

  protected JTextField txfAdrNr = new JTextField();

  protected JButton btnLandCd = new JButton();

  protected JLabel lblName = new JLabel();

  protected JTextField txfPlz = new JTextField();

  protected JLabel lblPlzOrt = new JLabel();

  protected JLabel lblEMail = new JLabel();

  protected JTextField txfFax = new JTextField();

  protected JLabel lblFax = new JLabel();

  protected DefaultComboBoxModel cbmSprachCd = new DefaultComboBoxModel( new String[] { "D, Deutsch", "F, Französisch", "I, Italienisch" } );

  protected LimitedDocument ldoName = new LimitedDocument();

  protected LimitedDocument ldoZeile1 = new LimitedDocument();

  protected LimitedDocument ldoZeile2 = new LimitedDocument();

  protected LimitedDocument ldoZeile3 = new LimitedDocument();

  protected LimitedDocument ldoZeile4 = new LimitedDocument();

  protected LimitedDocument ldoLandCd = new LimitedDocument();

  protected LimitedDocument ldoPlz = new LimitedDocument();

  protected LimitedDocument ldoOrt = new LimitedDocument();

  protected LimitedDocument ldoEMail = new LimitedDocument();

  protected LimitedDocument ldoSuchbegr = new LimitedDocument();

  protected LimitedDocument ldoTelefon = new LimitedDocument();

  protected LimitedDocument ldoFax = new LimitedDocument();

  protected InputVerifier landCdInputVerifier = new LandCdInputVerifier();

  protected InputVerifier plzInputVerifier = new PlzInputVerifier();

  protected InputVerifier ortInputVerifier = new OrtInputVerifier();

  protected InputVerifier eMailInputVerifier = new EMailInputVerifier();

  protected InputVerifier telefonInputVerifier = new TelefonInputVerifier();

  /**
   * Konstuktor
   */
  public PnlAdresse()
  {
    super();
    focusOwner = txfName;
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( parentWindow, ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Komponente initialisieren
   * @throws Exception
   */
  protected void jbInit() throws Exception
  {
    txfOrt.setPreferredSize( new Dimension( 265, 20 ) );
    txfOrt.setMaximumSize( new Dimension( 265, 20 ) );
    txfOrt.setMinimumSize( new Dimension( 265, 20 ) );
    txfZeile4.setPreferredSize( new Dimension( 334, 20 ) );
    txfZeile4.setMaximumSize( new Dimension( 334, 20 ) );
    txfZeile4.setMinimumSize( new Dimension( 334, 20 ) );
    txfZeile3.setPreferredSize( new Dimension( 334, 20 ) );
    txfZeile3.setMaximumSize( new Dimension( 334, 20 ) );
    txfZeile3.setMinimumSize( new Dimension( 334, 20 ) );
    txfZeile2.setPreferredSize( new Dimension( 334, 20 ) );
    txfZeile2.setMaximumSize( new Dimension( 334, 20 ) );
    txfZeile2.setMinimumSize( new Dimension( 334, 20 ) );
    txfZeile1.setPreferredSize( new Dimension( 334, 20 ) );
    txfZeile1.setMaximumSize( new Dimension( 334, 20 ) );
    txfZeile1.setMinimumSize( new Dimension( 334, 20 ) );
    txfName.setPreferredSize( new Dimension( 334, 20 ) );
    txfName.setMaximumSize( new Dimension( 334, 20 ) );
    txfName.setMinimumSize( new Dimension( 334, 20 ) );
    txfEMail.setPreferredSize( new Dimension( 334, 20 ) );
    txfEMail.setMaximumSize( new Dimension( 334, 20 ) );
    txfEMail.setMinimumSize( new Dimension( 334, 20 ) );
    txfFax.setPreferredSize( new Dimension( 165, 20 ) );
    txfFax.setMaximumSize( new Dimension( 165, 20 ) );
    txfFax.setMinimumSize( new Dimension( 165, 20 ) );
    txfTelefon.setPreferredSize( new Dimension( 165, 20 ) );
    txfTelefon.setMaximumSize( new Dimension( 165, 20 ) );
    txfTelefon.setMinimumSize( new Dimension( 165, 20 ) );
    txfSuchbegr.setPreferredSize( new Dimension( 108, 20 ) );
    txfSuchbegr.setMaximumSize( new Dimension( 108, 20 ) );
    txfSuchbegr.setMinimumSize( new Dimension( 108, 20 ) );
    txfPlz.setPreferredSize( new Dimension( 67, 20 ) );
    txfPlz.setMaximumSize( new Dimension( 67, 20 ) );
    txfPlz.setMinimumSize( new Dimension( 67, 20 ) );
    GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
    gridBagConstraints27.gridy = 11;
    gridBagConstraints27.anchor = GridBagConstraints.EAST;
    gridBagConstraints27.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints27.fill = GridBagConstraints.NONE;
    gridBagConstraints27.gridx = 0;
    GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
    gridBagConstraints26.gridy = 0;
    gridBagConstraints26.anchor = GridBagConstraints.EAST;
    gridBagConstraints26.insets = new Insets( 15, 20, 2, 8 );
    gridBagConstraints26.fill = GridBagConstraints.NONE;
    gridBagConstraints26.gridx = 0;
    GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
    gridBagConstraints25.gridy = 5;
    gridBagConstraints25.anchor = GridBagConstraints.EAST;
    gridBagConstraints25.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints25.fill = GridBagConstraints.NONE;
    gridBagConstraints25.gridx = 0;
    GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
    gridBagConstraints24.fill = GridBagConstraints.NONE;
    gridBagConstraints24.gridwidth = 3;
    gridBagConstraints24.gridx = 1;
    gridBagConstraints24.gridy = 11;
    gridBagConstraints24.ipadx = 0;
    gridBagConstraints24.weightx = 0.0;
    gridBagConstraints24.anchor = GridBagConstraints.WEST;
    gridBagConstraints24.insets = new Insets( 3, 6, 2, 0 );
    GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
    gridBagConstraints23.gridy = 12;
    gridBagConstraints23.anchor = GridBagConstraints.NORTHEAST;
    gridBagConstraints23.insets = new Insets( 3, 20, 0, 8 );
    gridBagConstraints23.fill = GridBagConstraints.NONE;
    gridBagConstraints23.gridx = 0;
    GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
    gridBagConstraints22.fill = GridBagConstraints.NONE;
    gridBagConstraints22.gridwidth = 3;
    gridBagConstraints22.gridx = 1;
    gridBagConstraints22.gridy = 12;
    gridBagConstraints22.ipadx = 0;
    gridBagConstraints22.weightx = 0.0;
    gridBagConstraints22.anchor = GridBagConstraints.WEST;
    gridBagConstraints22.insets = new Insets( 3, 6, 35, 0 );
    GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
    gridBagConstraints21.insets = new Insets( 4, 2, 1, 0 );
    gridBagConstraints21.gridy = 6;
    gridBagConstraints21.ipadx = 0;
    gridBagConstraints21.ipady = 0;
    gridBagConstraints21.anchor = GridBagConstraints.WEST;
    gridBagConstraints21.fill = GridBagConstraints.NONE;
    gridBagConstraints21.gridx = 2;
    GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
    gridBagConstraints20.fill = GridBagConstraints.NONE;
    gridBagConstraints20.gridwidth = 3;
    gridBagConstraints20.gridx = 1;
    gridBagConstraints20.gridy = 0;
    gridBagConstraints20.ipadx = 0;
    gridBagConstraints20.weightx = 0.0;
    gridBagConstraints20.anchor = GridBagConstraints.WEST;
    gridBagConstraints20.insets = new Insets( 15, 5, 2, 4 );
    GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
    gridBagConstraints19.gridy = 7;
    gridBagConstraints19.anchor = GridBagConstraints.EAST;
    gridBagConstraints19.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints19.fill = GridBagConstraints.NONE;
    gridBagConstraints19.gridx = 0;
    GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
    gridBagConstraints18.fill = GridBagConstraints.NONE;
    gridBagConstraints18.gridwidth = 2;
    gridBagConstraints18.gridx = 1;
    gridBagConstraints18.gridy = 7;
    gridBagConstraints18.ipadx = 0;
    gridBagConstraints18.weightx = 0.0;
    gridBagConstraints18.anchor = GridBagConstraints.WEST;
    gridBagConstraints18.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
    gridBagConstraints17.gridy = 1;
    gridBagConstraints17.anchor = GridBagConstraints.EAST;
    gridBagConstraints17.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints17.fill = GridBagConstraints.NONE;
    gridBagConstraints17.gridx = 0;
    GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
    gridBagConstraints16.gridy = 9;
    gridBagConstraints16.anchor = GridBagConstraints.EAST;
    gridBagConstraints16.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints16.fill = GridBagConstraints.NONE;
    gridBagConstraints16.gridx = 0;
    GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
    gridBagConstraints15.gridy = 6;
    gridBagConstraints15.anchor = GridBagConstraints.EAST;
    gridBagConstraints15.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints15.fill = GridBagConstraints.NONE;
    gridBagConstraints15.gridx = 0;
    GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
    gridBagConstraints14.gridy = 10;
    gridBagConstraints14.anchor = GridBagConstraints.EAST;
    gridBagConstraints14.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints14.fill = GridBagConstraints.NONE;
    gridBagConstraints14.gridx = 0;
    GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
    gridBagConstraints13.fill = GridBagConstraints.NONE;
    gridBagConstraints13.gridwidth = 3;
    gridBagConstraints13.gridx = 1;
    gridBagConstraints13.gridy = 10;
    gridBagConstraints13.ipadx = 0;
    gridBagConstraints13.weightx = 0.0;
    gridBagConstraints13.anchor = GridBagConstraints.WEST;
    gridBagConstraints13.insets = new Insets( 1, 6, 2, 0 );
    GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
    gridBagConstraints12.fill = GridBagConstraints.NONE;
    gridBagConstraints12.gridx = 3;
    gridBagConstraints12.gridy = 7;
    gridBagConstraints12.ipadx = 0;
    gridBagConstraints12.weightx = 1.0;
    gridBagConstraints12.anchor = GridBagConstraints.WEST;
    gridBagConstraints12.insets = new Insets( 2, 2, 2, 25 );
    GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
    gridBagConstraints11.fill = GridBagConstraints.NONE;
    gridBagConstraints11.gridwidth = 3;
    gridBagConstraints11.gridx = 1;
    gridBagConstraints11.gridy = 9;
    gridBagConstraints11.ipadx = 0;
    gridBagConstraints11.ipady = 0;
    gridBagConstraints11.weightx = 0.0;
    gridBagConstraints11.anchor = GridBagConstraints.WEST;
    gridBagConstraints11.insets = new Insets( 3, 6, 1, 0 );
    GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
    gridBagConstraints10.gridy = 2;
    gridBagConstraints10.anchor = GridBagConstraints.EAST;
    gridBagConstraints10.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints10.fill = GridBagConstraints.NONE;
    gridBagConstraints10.gridx = 0;
    GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
    gridBagConstraints9.gridy = 3;
    gridBagConstraints9.anchor = GridBagConstraints.EAST;
    gridBagConstraints9.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints9.fill = GridBagConstraints.NONE;
    gridBagConstraints9.gridx = 0;
    GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
    gridBagConstraints8.gridy = 4;
    gridBagConstraints8.anchor = GridBagConstraints.EAST;
    gridBagConstraints8.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints8.fill = GridBagConstraints.NONE;
    gridBagConstraints8.gridx = 0;
    GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
    gridBagConstraints7.fill = GridBagConstraints.NONE;
    gridBagConstraints7.gridwidth = 3;
    gridBagConstraints7.gridx = 1;
    gridBagConstraints7.gridy = 2;
    gridBagConstraints7.ipadx = 0;
    gridBagConstraints7.weightx = 0.0;
    gridBagConstraints7.anchor = GridBagConstraints.WEST;
    gridBagConstraints7.insets = new Insets( 3, 6, 2, 25 );
    GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
    gridBagConstraints6.fill = GridBagConstraints.NONE;
    gridBagConstraints6.gridwidth = 3;
    gridBagConstraints6.gridx = 1;
    gridBagConstraints6.gridy = 8;
    gridBagConstraints6.ipadx = 0;
    gridBagConstraints6.weightx = 0.0;
    gridBagConstraints6.anchor = GridBagConstraints.WEST;
    gridBagConstraints6.insets = new Insets( 3, 6, 2, 0 );
    GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
    gridBagConstraints5.fill = GridBagConstraints.NONE;
    gridBagConstraints5.gridwidth = 3;
    gridBagConstraints5.gridx = 1;
    gridBagConstraints5.gridy = 3;
    gridBagConstraints5.ipadx = 0;
    gridBagConstraints5.weightx = 0.0;
    gridBagConstraints5.anchor = GridBagConstraints.WEST;
    gridBagConstraints5.insets = new Insets( 3, 6, 2, 25 );
    GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
    gridBagConstraints4.fill = GridBagConstraints.NONE;
    gridBagConstraints4.gridx = 1;
    gridBagConstraints4.gridy = 6;
    gridBagConstraints4.ipadx = 33;
    gridBagConstraints4.weightx = 0.0;
    gridBagConstraints4.anchor = GridBagConstraints.WEST;
    gridBagConstraints4.insets = new Insets( 3, 6, 3, 1 );
    GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    gridBagConstraints3.fill = GridBagConstraints.NONE;
    gridBagConstraints3.gridwidth = 3;
    gridBagConstraints3.gridx = 1;
    gridBagConstraints3.gridy = 4;
    gridBagConstraints3.ipadx = 0;
    gridBagConstraints3.weightx = 0.0;
    gridBagConstraints3.anchor = GridBagConstraints.WEST;
    gridBagConstraints3.insets = new Insets( 3, 6, 2, 25 );
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    gridBagConstraints2.gridy = 8;
    gridBagConstraints2.anchor = GridBagConstraints.EAST;
    gridBagConstraints2.insets = new Insets( 0, 20, 0, 8 );
    gridBagConstraints2.fill = GridBagConstraints.NONE;
    gridBagConstraints2.gridx = 0;
    GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
    gridBagConstraints1.fill = GridBagConstraints.NONE;
    gridBagConstraints1.gridwidth = 3;
    gridBagConstraints1.gridx = 1;
    gridBagConstraints1.gridy = 5;
    gridBagConstraints1.ipadx = 0;
    gridBagConstraints1.weightx = 0.0;
    gridBagConstraints1.anchor = GridBagConstraints.WEST;
    gridBagConstraints1.insets = new Insets( 3, 6, 2, 25 );
    GridBagConstraints gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.fill = GridBagConstraints.NONE;
    gridBagConstraints.gridwidth = 3;
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.ipadx = 0;
    gridBagConstraints.weightx = 0.0;
    gridBagConstraints.anchor = GridBagConstraints.WEST;
    gridBagConstraints.insets = new Insets( 3, 6, 2, 24 );
    titledBorder1 = new TitledBorder( "Versandadresse" );
    this.setLayout( new GridBagLayout() );
    this.setSize( new Dimension( 715, 562 ) );
    this.setBorder( titledBorder1 );
    //  xYLayout1.setWidth(480);
    //  xYLayout1.setHeight(370);
    lblAdrNr.setText( "Adress-Nr:" );
    lblSuchbegr.setText( "Suchbegriff:" );
    lblSuchbegr.setToolTipText( "" );
    lblZeile3.setToolTipText( "" );
    lblZeile3.setText( "Strasse:" );
    lblZeile2.setText( "Strasse:" );
    lblZeile1.setToolTipText( "" );
    lblZeile1.setText( "Name:" );
    lblTelefon.setText( "Telefon:" );
    lblTelefon.setToolTipText( "" );
    lblLandCd.setText( "Land:" );
    lblSprachCd.setText( "Sprache:" );
    lblSprachCd.setToolTipText( "" );
    txfAdrNr.setEditable( false );
    txfAdrNr.setMaximumSize( new Dimension( 72, 20 ) );
    txfAdrNr.setMinimumSize( new Dimension( 72, 20 ) );
    txfAdrNr.setPreferredSize( new Dimension( 72, 20 ) );
    btnLandCd.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        btnLandCd_actionPerformed( e );
      }
    } );
    btnLandCd.setRequestFocusEnabled( false );
    btnLandCd.setHorizontalAlignment( SwingConstants.CENTER );
    btnLandCd.setPreferredSize( new Dimension( 20, 20 ) );
    btnLandCd.setText( "..." );
    lblName.setToolTipText( "" );
    lblName.setText( "Name:" );
    lblPlzOrt.setToolTipText( "" );
    lblPlzOrt.setText( "PLZ/Ort:" );
    lblEMail.setText( "E-Mail:" );
    lblEMail.setToolTipText( "" );
    cbxSprachCd.setModel( cbmSprachCd );
    txfName.setDocument( ldoName );
    addCharsetVerifier( txfName );
    txfZeile1.setDocument( ldoZeile1 );
    addCharsetVerifier( txfZeile1 );
    txfZeile2.setDocument( ldoZeile2 );
    addCharsetVerifier( txfZeile2 );
    txfZeile3.setDocument( ldoZeile3 );
    addCharsetVerifier( txfZeile3 );
    txfZeile4.setDocument( ldoZeile4 );
    addCharsetVerifier( txfZeile4 );
    txfLandCd.setDocument( ldoLandCd );
    txfLandCd.setText( "CH" );
    txfLandCd.setMaximumSize( new Dimension( 8, 20 ) );
    txfLandCd.setPreferredSize( new Dimension( 8, 20 ) );
    txfLandCd.setMinimumSize( new Dimension( 8, 20 ) );
    txfLandCd.setInputVerifier( landCdInputVerifier );
    txfPlz.setDocument( ldoPlz );
    txfPlz.setInputVerifier( plzInputVerifier );
    txfOrt.setDocument( ldoOrt );
    txfOrt.setInputVerifier( ortInputVerifier );
    txfSuchbegr.setDocument( ldoSuchbegr );
    addCharsetVerifier( txfSuchbegr );
    txfTelefon.setDocument( ldoTelefon );
    txfTelefon.setInputVerifier( telefonInputVerifier );
    txfEMail.setDocument( ldoEMail );
    txfEMail.setInputVerifier( eMailInputVerifier );
    txfFax.setDocument( ldoFax );
    txfFax.setInputVerifier( telefonInputVerifier );
    lblFax.setText( "Fax:" );
    lblZeile4.setText( "Strasse:" );
    lblZeile4.setToolTipText( "" );
    this.add( txfName, gridBagConstraints );
    this.add( txfZeile4, gridBagConstraints1 );
    this.add( lblSuchbegr, gridBagConstraints2 );
    this.add( txfZeile3, gridBagConstraints3 );
    this.add( txfLandCd, gridBagConstraints4 );
    this.add( txfZeile2, gridBagConstraints5 );
    this.add( txfSuchbegr, gridBagConstraints6 );
    this.add( txfZeile1, gridBagConstraints7 );
    this.add( lblZeile3, gridBagConstraints8 );
    this.add( lblZeile2, gridBagConstraints9 );
    this.add( lblZeile1, gridBagConstraints10 );
    this.add( cbxSprachCd, gridBagConstraints11 );
    this.add( txfOrt, gridBagConstraints12 );
    this.add( txfTelefon, gridBagConstraints13 );
    this.add( lblTelefon, gridBagConstraints14 );
    this.add( lblLandCd, gridBagConstraints15 );
    this.add( lblSprachCd, gridBagConstraints16 );
    this.add( lblName, gridBagConstraints17 );
    this.add( txfPlz, gridBagConstraints18 );
    this.add( lblPlzOrt, gridBagConstraints19 );
    this.add( txfAdrNr, gridBagConstraints20 );
    this.add( btnLandCd, gridBagConstraints21 );
    this.add( txfEMail, gridBagConstraints22 );
    this.add( lblEMail, gridBagConstraints23 );
    this.add( txfFax, gridBagConstraints24 );
    this.add( lblZeile4, gridBagConstraints25 );
    this.add( lblAdrNr, gridBagConstraints26 );
    this.add( lblFax, gridBagConstraints27 );
    ldoName.setMaxLength( 40 );
    ldoZeile1.setMaxLength( 40 );
    ldoZeile2.setMaxLength( 40 );
    ldoZeile3.setMaxLength( 40 );
    ldoZeile4.setMaxLength( 40 );
    ldoOrt.setMaxLength( 40 );
    ldoEMail.setMaxLength( 201 );
    ldoLandCd.setMaxLength( 3 );
    ldoLandCd.setUpperCase( true );
    ldoPlz.setMaxLength( 8 );
    ldoSuchbegr.setMaxLength( 10 );
    ldoSuchbegr.setUpperCase( true );
    ldoTelefon.setMaxLength( 20 );
    ldoFax.setMaxLength( 20 );
  }

  /**
   * Aktivierung des Panes.
   */
  public void activate()
  {
    super.activate();
    if ( txfLandCd.getText().equals( "CH" ) )
    {
      // CH-Adresse
      if ( txfPlz.getText().equals( "" ) )
      {
        // PLZ fehlt, Suche mit Ort und PLZ einfüllen
        ortInputVerifier.verify( txfOrt );
      }
      else
      {
        // PLZ vorhanden
        try
        {
          // Suchen mit PLZ und Ort
          ArrayList al = AdresseDelegate.getInstance().findPostOrt( txfPlz.getText(), txfOrt.getText() );
          if ( al.size() == 1 )
          {
            PostOrtAVO postOrtAVO = (PostOrtAVO) al.get( 0 );
            txfOrt.setText( postOrtAVO.ort );
          }
          else
          {
            // CH-Ortschaft mit PLZ und/oder Ort gibt es nicht oder ist nicht
            // eindeutig, d.h. es gibt mehrere Einträge
            // Suche mit PLZ
            setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
            String[] plzOrt = PlzOrtDialog.showPlzOrt( (Dialog) parentWindow, txfPlz.getText(), null, true );
            setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
            if ( plzOrt == null )
            {
              // Abgebrochen
              return;
            }
            else if ( plzOrt.length == 0 )
            {
              // CH-Ortschaft mit Postleitzahl = !P1 gibt es nicht!"
              String message = xxMessage.getMessage( 7105, txfPlz.getText() );
              JOptionPane.showMessageDialog( parentWindow, message, "", JOptionPane.WARNING_MESSAGE );
              return;
            }
            else
            {
              txfPlz.setText( plzOrt[0] );
              txfOrt.setText( plzOrt[1] );
              return;
            }
          }
        }
        catch ( Exception ex )
        {
          LOG.error( ex );
          String message = xxMessage.getMessage( ex );
          JOptionPane.showMessageDialog( parentWindow, message, "Fehler", JOptionPane.ERROR_MESSAGE );
        }
      }
    }
  }

  /**
   * Gibt die Versandadresse zurück
   * @return VersadrVO
   */
  public VersadrVO getVersadr()
  {
    if ( versadrVO == null )
    {
      versadrVO = new VersadrVO();
    }
    versadrVO.setSuchbegr( txfSuchbegr.getText().trim() );
    versadrVO.setSprachCd( cbxSprachCd.getModel().getSelectedItem().toString().substring( 0, 1 ) );
    versadrVO.setAnrCd( null );
    versadrVO.setName( txfName.getText().trim() );
    versadrVO.setZeile1( txfZeile1.getText().trim() );
    versadrVO.setZeile2( txfZeile2.getText().trim() );
    versadrVO.setZeile3( txfZeile3.getText().trim() );
    versadrVO.setZeile4( txfZeile4.getText().trim() );
    versadrVO.setLandCd( txfLandCd.getText().trim() );
    versadrVO.setPfPlz( null );
    versadrVO.setPlz( txfPlz.getText().trim() );
    versadrVO.setOrt( txfOrt.getText().trim() );
    versadrVO.setTelefon( txfTelefon.getText().trim() );
    versadrVO.setFax( txfFax.getText().trim() );
    versadrVO.setEmailNameDomain( txfEMail.getText().trim() );
    return versadrVO;
  }

  /**
   * Setzt die Versandadresse
   * @param versadrVO Versandadresse
   */
  public void setVersadr( VersadrVO versadrVO )
  {
    this.versadrVO = versadrVO;
    txfAdrNr.setText( "" + versadrVO.getAdrNr() );
    txfSuchbegr.setText( versadrVO.getSuchbegrOrEmptyStr() );
    // Sprache setzen
    for ( int i = 0; i < cbmSprachCd.getSize(); i++ )
    {
      String s = (String) cbmSprachCd.getElementAt( i );
      if ( s.charAt( 0 ) == versadrVO.getSprachCdOrEmptyStr().charAt( 0 ) )
      {
        cbmSprachCd.setSelectedItem( s );
        break;
      }
    }
    txfName.setText( versadrVO.getName() );
    txfZeile1.setText( versadrVO.getZeile1OrEmptyStr() );
    txfZeile2.setText( versadrVO.getZeile2OrEmptyStr() );
    txfZeile3.setText( versadrVO.getZeile3OrEmptyStr() );
    txfZeile4.setText( versadrVO.getZeile4OrEmptyStr() );
    txfLandCd.setText( versadrVO.getLandCdOrEmptyStr() );
    txfPlz.setText( versadrVO.getPlzOrEmptyStr() );
    txfOrt.setText( versadrVO.getOrtOrEmptyStr() );
    txfTelefon.setText( versadrVO.getTelefonOrEmptyStr() );
    txfFax.setText( versadrVO.getFaxOrEmptyStr() );
    txfEMail.setText( versadrVO.getEmailNameDomainOrEmptyStr() );
  }

  /**
   * Validiert die Eingaben auf dem Panel
   * @return true - Validierung war erfolgreich
   */
  public boolean verifyInput()
  {
    // Feld darf nicht leer sein!
    String feldLeer = xxMessage.getMessage( 5033 );
    if ( txfName.getText().length() == 0 )
    {
      JOptionPane.showMessageDialog( parentWindow, feldLeer, "Information", JOptionPane.INFORMATION_MESSAGE );
      txfName.requestFocus();
      return false;
    }
    if ( txfLandCd.getText().length() == 0 )
    {
      JOptionPane.showMessageDialog( parentWindow, feldLeer, "Information", JOptionPane.INFORMATION_MESSAGE );
      txfLandCd.requestFocus();
      return false;
    }
    if ( !txfLandCd.getInputVerifier().verify( txfLandCd ) )
    {
      txfLandCd.requestFocus();
      return false;
    }
    if ( txfLandCd.getText().equals( "CH" ) && txfPlz.getText().length() == 0 )
    {
      JOptionPane.showMessageDialog( parentWindow, feldLeer, "Information", JOptionPane.INFORMATION_MESSAGE );
      txfPlz.requestFocus();
      return false;
    }
    if ( txfOrt.getText().length() == 0 )
    {
      JOptionPane.showMessageDialog( parentWindow, feldLeer, "Information", JOptionPane.INFORMATION_MESSAGE );
      txfOrt.requestFocus();
      return false;
    }
    if ( txfLandCd.getText().equals( "CH" ) )
    {
      try
      {
        // Suchen
        ArrayList al = AdresseDelegate.getInstance().findPostOrt( txfPlz.getText(), txfOrt.getText() );
        if ( al.size() == 0 )
        {
          // CH-Ortschaft mit Postleitzahl= !P1 und/oder Ortsname= !P2 gibt es nicht!
          String message = xxMessage.getMessage( 7107, txfPlz.getText(), txfOrt.getText() );
          JOptionPane.showMessageDialog( parentWindow, message, "Warnung", JOptionPane.WARNING_MESSAGE );
          return false;
        }
      }
      catch ( Exception ex )
      {
        LOG.error( ex );
        String message = xxMessage.getMessage( ex );
        JOptionPane.showMessageDialog( parentWindow, message, "Fehler", JOptionPane.ERROR_MESSAGE );
        return false;
      }
    }
    if ( txfSuchbegr.getText().length() == 0 )
    {
      JOptionPane.showMessageDialog( parentWindow, feldLeer, "Information", JOptionPane.INFORMATION_MESSAGE );
      txfSuchbegr.requestFocus();
      return false;
    }
    if ( !txfTelefon.getInputVerifier().verify( txfTelefon ) )
    {
      txfTelefon.requestFocus();
      return false;
    }
    if ( !txfFax.getInputVerifier().verify( txfFax ) )
    {
      txfFax.requestFocus();
      return false;
    }
    if ( !txfEMail.getInputVerifier().verify( txfEMail ) )
    {
      txfEMail.requestFocus();
      return false;
    }
    if ( !txfName.getInputVerifier().verify( txfName ) )
    {
      txfName.requestFocus();
      return false;
    }
    if ( !txfZeile1.getInputVerifier().verify( txfZeile1 ) )
    {
      txfZeile1.requestFocus();
      return false;
    }
    if ( !txfZeile2.getInputVerifier().verify( txfZeile2 ) )
    {
      txfZeile2.requestFocus(); 
      return false;
    }
    if ( !txfZeile3.getInputVerifier().verify( txfZeile3 ) )
    {
      txfZeile3.requestFocus();
      return false;
    }
    if ( !txfZeile4.getInputVerifier().verify( txfZeile4 ) )
    {
      txfZeile4.requestFocus();
      return false;
    }
    if ( !txfSuchbegr.getInputVerifier().verify( txfSuchbegr ) )
    {
      txfSuchbegr.requestFocus();
      return false;
    }
    return true;
  }

  void btnLandCd_actionPerformed( ActionEvent e )
  {
    if ( verifyInput() )
    {
      String landCd = LandDialog.showLand( (Dialog) parentWindow, txfLandCd.getText() );
      if ( !landCd.equals( "" ) )
      {
        // Land ausgewählt
        txfLandCd.setText( landCd );
      }
    }    
  }

  /**
   * Verifiziert die Eingabe des Ländercodes
   */
  class LandCdInputVerifier extends InputVerifier
  {
    public boolean verify( JComponent input )
    {
      String landCd = ( (JTextField) input ).getText();
      if ( landCd.equals( "" ) )
      {
        return true;
      }
      try
      {
        if ( !AdresseDelegate.getInstance().existsLand( txfLandCd.getText() ) )
        {
          // Landcode "!P1" ist unbekannt
          String message = xxMessage.getMessage( 40, txfLandCd.getText() );
          input.setInputVerifier( null );
          JOptionPane.showMessageDialog( parentWindow, message, "", JOptionPane.WARNING_MESSAGE );
          input.setInputVerifier( landCdInputVerifier );
          return false;
        }
      }
      catch ( Exception ex )
      {
        LOG.error( ex );
        String message = xxMessage.getMessage( ex );
        input.setInputVerifier( null );
        JOptionPane.showMessageDialog( parentWindow, message, "Fehler", JOptionPane.ERROR_MESSAGE );
        input.setInputVerifier( landCdInputVerifier );
        return false;
      }
      return true;
    }
  }

  /**
   * Verifiziert die Eingabe der PLZ
   */
  class PlzInputVerifier extends InputVerifier
  {
    public boolean verify( final JComponent input )
    {
      String plz = ( (JTextField) input ).getText();
      if ( !txfLandCd.getText().equals( "CH" ) )
      {
        return true;
      }
      if ( plz.equals( "" ) )
      {
        return true;
      }
      setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
      input.setInputVerifier( null );
      String[] plzOrt = PlzOrtDialog.showPlzOrt( (Dialog) parentWindow, txfPlz.getText(), null, false );
      final InputVerifier inputVerifier = this;
      Timer timer = new Timer();
      timer.schedule( new TimerTask()
      {
        public void run()
        {
          input.setInputVerifier( inputVerifier );
        }
      }, 200 );
      setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
      if ( plzOrt == null )
      {
        // Abgebrochen
        return false;
      }
      else if ( plzOrt.length == 0 )
      {
        // CH-Ortschaft mit Postleitzahl = !P1 gibt es nicht!"
        String message = xxMessage.getMessage( 7105, txfPlz.getText() );
        input.setInputVerifier( null );
        JOptionPane.showMessageDialog( parentWindow, message, "", JOptionPane.WARNING_MESSAGE );
        input.setInputVerifier( plzInputVerifier );
        return false;
      }
      else
      {
        txfPlz.setText( plzOrt[0] );
        txfOrt.setText( plzOrt[1] );
        return true;
      }
    }
  }

  /**
   * Verifiziert die Eingabe der Ortschaft
   */
  class OrtInputVerifier extends InputVerifier
  {
    public boolean verify( JComponent input )
    {
      String ort = ( (JTextField) input ).getText();
      if ( ort.equals( "" ) )
      {
        return true;
      }
      if ( !txfLandCd.getText().equals( "CH" ) )
      {
        return true;
      }
      setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
      try
      {
        // Suchen mit PLZ und Ort
        ArrayList al = AdresseDelegate.getInstance().findPostOrt( txfPlz.getText(), txfOrt.getText() );
        if ( al.size() == 1 )
        {
          // PLZ und Ort existiert
          PostOrtAVO postOrtAVO = (PostOrtAVO) al.get( 0 );
          txfPlz.setText( postOrtAVO.plz );
          txfOrt.setText( postOrtAVO.ort );
          setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
          return true;
        }
      }
      catch ( Exception ex )
      {
        LOG.error( ex );
        String message = xxMessage.getMessage( ex );
        input.setInputVerifier( null );
        JOptionPane.showMessageDialog( parentWindow, message, "Fehler", JOptionPane.ERROR_MESSAGE );
        input.setInputVerifier( ortInputVerifier );
        setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
        return false;
      }
      String[] plzOrt = PlzOrtDialog.showPlzOrt( (Dialog) parentWindow, null, txfOrt.getText(), false );
      setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
      if ( plzOrt == null )
      {
        // Abgebrochen
        return false;
      }
      else if ( plzOrt.length == 0 )
      {
        // CH-Ortschaft mit Ortsname = !P1 gibt es nicht!
        String message = xxMessage.getMessage( 7106, "" + txfOrt.getText() );
        input.setInputVerifier( null );
        JOptionPane.showMessageDialog( parentWindow, message, "", JOptionPane.WARNING_MESSAGE );
        input.setInputVerifier( ortInputVerifier );
        return false;
      }
      else
      {
        txfPlz.setText( plzOrt[0] );
        txfOrt.setText( plzOrt[1] );
        return true;
      }
    }
  }

  /**
   * Verifiziert die Eingabe der EMail-Adresse
   */
  class EMailInputVerifier extends InputVerifier
  {
    public boolean verify( JComponent input )
    {
      String email = ( (JTextField) input ).getText();
      if ( email.equals( "" ) )
      {
        return true;
      }
      if ( email.indexOf( '@' ) == -1 )
      {
        String message = xxMessage.getMessage( 1036 );
        input.setInputVerifier( null );
        JOptionPane.showMessageDialog( parentWindow, message, "", JOptionPane.WARNING_MESSAGE );
        input.setInputVerifier( eMailInputVerifier );
        return false;
      }
      if( !( new CharsetVerifier().verify( input ) ) )
      {
        //TODO create workaround
        return false;
      }
      //      else
      //      {
      //        return true;
      //      }
      return true;
    }
  }

  /**
   * Verifiziert die Eingabe der Telefon- oder Faxnummer
   * Das '+'-Zeichen darf nur an der ersten Stelle vorkommen
   * Ausser Zahlen sind nur die Sonderzeichen "/", "(", ")", " "
   * zugelassen
   */
  class TelefonInputVerifier extends InputVerifier
  {
    public boolean verify( JComponent input )
    {
      ArrayList al = new ArrayList();
      al.add( "/" );
      al.add( "(" );
      al.add( ")" );
      al.add( " " );
      al.add( "+" );
      for ( int i = 0; i < 10; i++ )
      {
        al.add( "" + i );
      }

      String str = ( (JTextField) input ).getText();

      for ( int i = 0; i < str.length(); i++ )
      {
        if ( !al.contains( new String( str.substring( i, i + 1 ) ) ) )
        {
          String message = xxMessage.getMessage( 1248 );
          input.setInputVerifier( null );
          JOptionPane.showMessageDialog( parentWindow, message, "Ungültige Eingabe", JOptionPane.INFORMATION_MESSAGE );
          input.setInputVerifier( telefonInputVerifier );
          return false;
        }
      }
      // "+" darf höchstens an 1. Stelle vorkommen
      if ( str.indexOf( '+', 1 ) == -1 )
      {
        return true;
      }
      else
      {
        String message = xxMessage.getMessage( 1247 );
        input.setInputVerifier( null );
        JOptionPane.showMessageDialog( parentWindow, message, "Ungültige Eingabe", JOptionPane.INFORMATION_MESSAGE );
        input.setInputVerifier( telefonInputVerifier );
        return false;
      }
    }
  }
} //  @jve:decl-index=0:visual-constraint="10,10"
