package ch.ige.adr.client;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

import ch.ige.adr.vo.PostOrtVO;

/**
 * Liest das Ortsverzeichnis der Post ein.
 * <p>
 * Copyright (c) 2001-2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Michael Zaugg / Stefan Nydegger
 * @version $Id: PostOrt.java,v 1.7 2006/12/11 16:27:00 nydegger Exp $
 */
public class PostOrt
{

  /**
   * Liest das Ortsverzeichnis der Post ein und füllt dieses in das ValueObject (PostOrtVO).
   * @param dateiname
   * @return PostOrtVO
   * @throws Exception
   */
  public PostOrtVO[] readFile(String dateiname) throws Exception
  {
    ArrayList vector = new ArrayList();
    File datei = new File(dateiname);
    BufferedReader reader = new BufferedReader(new FileReader(datei));
    String zeile = "";
    while ((zeile = reader.readLine())!= null)
    {
      StringTokenizer st = new StringTokenizer( zeile, "\t" );

      PostOrtVO dObj = new PostOrtVO();

      dObj.setOrdNrPost(Integer.parseInt( st.nextToken().trim() ));
      dObj.setPlzTyp(st.nextToken().trim());
      dObj.setPlz(st.nextToken().trim());
      dObj.setPlzZusatz(st.nextToken().trim());
      st.nextToken().trim();  // 18-stellige Ortsbezeichnung ignorieren
      dObj.setOrt(st.nextToken().trim());
      dObj.setKanton(st.nextToken().trim());

      vector.add(dObj);
    }
    reader.close();
    PostOrtVO[] postOrtVO = new PostOrtVO[0];
    postOrtVO = (PostOrtVO[])vector.toArray(postOrtVO);
    return postOrtVO;
  }
}
