package ch.ige.adr.client;

import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.ButtonGroup;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

import org.apache.log4j.Logger;

import ch.ige.adr.vo.AdresseSelKritVO;
import ch.ige.adrhelp.HelpUtil;
import ch.ige.main.client.XxMessage;

/**
 * Auswahl Adresse: Suchmodus Index, Soundex oder Volltext
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: SuchmodusPanel.java,v 1.18 2008/04/28 15:32:34 galli Exp $
 */
public class SuchmodusPanel extends JPanel
{
  // Logging
  private static final Logger LOG = Logger.getLogger( SuchmodusPanel.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  protected JRadioButton rbnIndex = new JRadioButton();

  protected ButtonGroup buttonGroup = new ButtonGroup();

  protected JRadioButton rbnVolltext = new JRadioButton();

  /**
   * constructor
   */
  public SuchmodusPanel()
  {
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( SwingUtilities.getWindowAncestor( this ), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  void jbInit() throws Exception
  {
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    gridBagConstraints2.insets = new Insets( 0, 0, 0, 0 );
    gridBagConstraints2.gridy = 0;
    gridBagConstraints2.ipadx = 0;
    gridBagConstraints2.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints2.weightx = 1.0;
    gridBagConstraints2.fill = GridBagConstraints.NONE;
    gridBagConstraints2.gridx = 1;
    GridBagConstraints gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.insets = new Insets( 0, 0, 0, 0 );
    gridBagConstraints.gridy = 0;
    gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints.gridx = 0;
    rbnIndex.setSelected( true );
    rbnIndex.setHorizontalAlignment( SwingConstants.LEADING );
    rbnIndex.setText( "Index" );
    rbnIndex.setActionCommand( AdresseSelKritVO.SUCHMODUS_INDEX );
    rbnIndex.setMaximumSize( new Dimension( 55, 20 ) );
    rbnIndex.setMinimumSize( new Dimension( 55, 20 ) );
    rbnIndex.setPreferredSize( new Dimension( 60, 20 ) );
    rbnVolltext.setText( "Volltext" );
    rbnVolltext.setActionCommand( AdresseSelKritVO.SUCHMODUS_VOLLTEXT );
    rbnVolltext.setMaximumSize( new Dimension( 60, 20 ) );
    rbnVolltext.setMinimumSize( new Dimension( 60, 20 ) );
    rbnVolltext.setPreferredSize( new Dimension( 75, 20 ) );
    this.setMinimumSize( new Dimension( 200, 35 ) );
    this.setPreferredSize( new Dimension( 220, 22 ) );
    buttonGroup.add( rbnIndex );
    buttonGroup.add( rbnVolltext );
    this.setLayout( new GridBagLayout() );
    this.setComponentOrientation( ComponentOrientation.LEFT_TO_RIGHT );
    this.add( rbnIndex, gridBagConstraints );
    this.add( rbnVolltext, gridBagConstraints2 );
  }

  /**
   * initialisiert javahelp
   */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelp( rbnIndex, "adrSuchen.einstellmodi" );
    HelpUtil.getInstance().enableHelp( rbnVolltext, "adrSuchen.einstellmodi" );
  }
}
