/*
 * Generated by XDoclet - Do not edit!
 */
package ch.ige.adr.server;

/**
 * Remote interface for AdresseFacade.
 * @wtp generated
 */
public interface AdresseFacade
   extends javax.ejb.EJBObject
{
   /**
    * Gibt die URL der Bagis-Datenbank zurück.
    * @return URL der Bagis-Datenbank <!-- begin-xdoclet-definition -->
    */
   public java.lang.String getBagisDbURL(  )
      throws java.rmi.RemoteException;

   /**
    * Kreiert eine Versandadresse.
    * @param versadrVO Value Object der Versanddresse
    * @return Adressnummer <!-- begin-xdoclet-definition -->
    */
   public int createVersadr( ch.ige.util.vo.VersadrVO versadrVO )
      throws java.rmi.RemoteException;

   /**
    * Gibt das Value Object der Versanddresse zurück.
    * @param adrNr Adressnummer
    * @return Value Object der Versanddresse <!-- begin-xdoclet-definition -->
    */
   public ch.ige.util.vo.VersadrVO getVersadr( int adrNr )
      throws java.rmi.RemoteException;

   /**
    * Setzt die Versanddresse auf den Wert des Value Objects.
    * @param versadrVO Versanddresse <!-- begin-xdoclet-definition -->
    */
   public void setVersadr( ch.ige.util.vo.VersadrVO versadrVO )
      throws java.rmi.RemoteException;

   /**
    * Löscht die Versandadresse
    * @param adrNr Adressnummer <!-- begin-xdoclet-definition -->
    */
   public void removeVersadr( int adrNr )
      throws java.rmi.RemoteException;

   /**
    * Sperrt die Versandadresse
    * @param adrNr Adressnummer
    * @param gesperrt true - sperren, false - Sperrung aufheben
    * @param geaendBen Kürzel des Benuzter <!-- begin-xdoclet-definition -->
    */
   public void blockVersadr( int adrNr,boolean gesperrt,java.lang.String geaendBen )
      throws java.rmi.RemoteException;

   /**
    * Findet alle Adressen, auf welche die Selektionskriterien zutreffen.
    * @param adresseSelKritVO Value Object mit den Selektionskriterien
    * @return ArrayList mit AdresseAVO-Objekten mit den gefundenen Adressen <!-- begin-xdoclet-definition -->
    */
   public java.util.ArrayList findVersadr( ch.ige.adr.vo.AdresseSelKritVO adresseSelKritVO )
      throws java.rmi.RemoteException;

   /**
    * Liest alle Adr-Nummern aus der Tabelle Adresse
    * @param startAdrNr Anfangs-Adressnummer
    * @return ArrayList mit Integer-Objekten mit den Adressnummern <!-- begin-xdoclet-definition -->
    */
   public java.util.ArrayList getAdrNr( int startAdrNr )
      throws java.rmi.RemoteException;

   /**
    * Prüft die Existenz einer Adresse.
    * @param adrNr Adressnummer
    * @return true - LäAdresse existiert. <!-- begin-xdoclet-definition -->
    */
   public boolean existsVersadr( int adrNr )
      throws java.rmi.RemoteException;

   /**
    * Kreiert eine Registeradresse.
    * @param regadrVO Value Object der Registeradresse
    * @return Registeradressnummer <!-- begin-xdoclet-definition -->
    */
   public int createRegadr( ch.ige.util.vo.RegadrVO regadrVO )
      throws java.rmi.RemoteException;

   /**
    * Kreiert eine Registeradresse und eine Versandadresse.
    * @param regadrVO Value Object der Registeradresse
    * @param versadrVO Value Object der Versandadresse
    * @return Registeradressnummer <!-- begin-xdoclet-definition -->
    */
   public int createRegadr( ch.ige.util.vo.RegadrVO regadrVO,ch.ige.util.vo.VersadrVO versadrVO )
      throws java.rmi.RemoteException;

   /**
    * Gibt das Value Object der Registeradresse zurück.
    * @param regadrNr Registeradressnummer
    * @return Value Object der Registeradresse <!-- begin-xdoclet-definition -->
    */
   public ch.ige.util.vo.RegadrVO getRegadr( int regadrNr )
      throws java.rmi.RemoteException;

   /**
    * Gibt die Registeradressnummer zurück.
    * @param regadrExistsVO Registeradresse
    * @return Registeradressnummer <!-- begin-xdoclet-definition -->
    */
   public int getRegadr( ch.ige.adr.vo.RegadrExistsVO regadrExistsVO )
      throws java.rmi.RemoteException;

   /**
    * Setzt die Registeradresse auf den Wert des Value Objects.
    * @param regadrVO Registeradresse <!-- begin-xdoclet-definition -->
    */
   public void setRegadr( ch.ige.util.vo.RegadrVO regadrVO )
      throws java.rmi.RemoteException;

   /**
    * Erstellt eine Versandadresse und setzt die Adressnummer in der Registeradresse ein und setzt die Registeradresse auf den Wert des Value Objects.
    * @param regadrVO Registeradresse (wird mutiert!)
    * @param versadrVO Versandadresse (wird erstellt!) <!-- begin-xdoclet-definition -->
    */
   public void setRegadr( ch.ige.util.vo.RegadrVO regadrVO,ch.ige.util.vo.VersadrVO versadrVO )
      throws java.rmi.RemoteException;

   /**
    * Löscht die Registeradresse
    * @param regadrNr Registeradressnummer <!-- begin-xdoclet-definition -->
    */
   public void removeRegadr( int regadrNr )
      throws java.rmi.RemoteException;

   /**
    * Findet alle Registeradresse, auf welche die Selektionskriterien zutreffen.
    * @param regadrSelKritVO Value Object mit den Selektionskriterien
    * @return ArrayList mit RegadrAVO-Objekten mit den gefundenen Registeradresse <!-- begin-xdoclet-definition -->
    */
   public java.util.ArrayList findRegadr( ch.ige.adr.vo.RegadrSelKritVO regadrSelKritVO )
      throws java.rmi.RemoteException;

   /**
    * Findet alle Länder, auf welche die Selektionskriterien zutreffen.
    * @param landCd Ländercode als Selektionskriterium
    * @param landBez Länderbezeichnungs als Selektionskriterium
    * @return ArrayList mit LandAVO-Objekten mit den gefundenen Ländern <!-- begin-xdoclet-definition -->
    */
   public java.util.ArrayList findLaender( java.lang.String landCd,java.lang.String landBez )
      throws java.rmi.RemoteException;

   /**
    * Prüft die Existenz eines Ländercodes.
    * @param landCd Ländercode, z.B. CH für Schweiz, F für Frankreich etc.
    * @return true - Ländercode existiert. <!-- begin-xdoclet-definition -->
    */
   public boolean existsLand( java.lang.String landCd )
      throws java.rmi.RemoteException;

   /**
    * Findet alle BLänder, auf welche die Selektionskriterien zutreffen.
    * @param blandCd Ländercode als Selektionskriterium
    * @param landBezD Länderbezeichnungs als Selektionskriterium
    * @return ArrayList mit BlandAVO-Objekten mit den gefundenen Bländern <!-- begin-xdoclet-definition -->
    */
   public java.util.ArrayList findBland( java.lang.String blandCd,java.lang.String landBezD )
      throws java.rmi.RemoteException;

   /**
    * Prüft die Existenz eines BLändercodes.
    * @param blandCd BLändercode, z.B. CH für Schweiz, FR für Frankreich etc.
    * @return true - BLändercode existiert. <!-- begin-xdoclet-definition -->
    */
   public boolean existsBland( java.lang.String blandCd )
      throws java.rmi.RemoteException;

   /**
    * Gibt den Landcode aufgrund des BLandcodes zurück.
    * @param blandCd BLandcode, z.B. CH für Schweiz, FR für Frankreich etc.
    * @return Landcode, z.B. CH für Schweiz, F für Frankreich etc. <!-- begin-xdoclet-definition -->
    */
   public java.lang.String getLandCd( java.lang.String blandCd )
      throws java.rmi.RemoteException;

   /**
    * Findet alle Ortschaften mit plz oder ort. Anfangsziffern bzw. Anfangsbuchstaben sind ausreichend.
    * @param plz Postleitzahl der Ortschaft
    * @param ort Name der Ortschaft
    * @return ArrayList mit PostOrtAVO-Objekten mit allen gefundenen Ortschaften <!-- begin-xdoclet-definition -->
    */
   public java.util.ArrayList findPostOrt( java.lang.String plz,java.lang.String ort )
      throws java.rmi.RemoteException;

   /**
    * Speicherung der Ortschaften in der Datenbank
    * @param postOrtVO Benötigte Daten für die Normalisierung
    */
   public void ladeOrtsverzeichnis( ch.ige.adr.vo.PostOrtVO[] postOrtVO )
      throws java.rmi.RemoteException;

   /**
    * Führt den Ortsabgleich durch. <!-- begin-xdoclet-definition -->
    */
   public void ortsabgleich(  )
      throws java.rmi.RemoteException;

}
