package ch.ige.adr.server;

import java.sql.SQLException;

import javax.ejb.EJBException;

import org.apache.log4j.Logger;

import ch.ige.adr.server.dao.PostOrtDAO;
import ch.ige.adr.vo.PostOrtVO;

/**
 * <p>Überschrift: Adresskomponente</p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Ei</p>
 * @author unbekannt
 * @version 1.0
 */

public class PostOrtBO
{
  private static final Logger LOG = Logger.getLogger(PostOrtBO.class);

  /**
  * Speicherung der Ortschaften in der Datenbank
  *
  * @param postOrtVO Postleitzahlen und Ortschaften
  * @author  Michael Zaugg
  */
  public void ladeOrtsverzeichnis(PostOrtVO[] postOrtVO)
  {
    PostOrtDAO postOrtDAO = new PostOrtDAO();
    int rowCount = 0;

    try
    {
      /* Automatischer Update der Adresse auskommentiert.
      for(int i = 0; i < postOrtVO.length; i++)
      {
        postOrtVO[i].landCd = "CH";
        String kanton = postOrtVO[i].kanton;
        if(kanton.equals("FL")|| kanton.equals("D")||kanton.equals("I"))
        {
          postOrtVO[i].landCd = kanton;
        }
        PostOrtVO postOrt = postOrtDAO.select(postOrtVO[i].ordNrPost);
        if(postOrt != null)
        {
          if(!postOrtVO[i].ort.equals(postOrt.ort) || !postOrtVO[i].plz.equals(postOrt.plz))
          {
            adresseDAO.update(postOrt.ort, postOrt.plz, postOrt.landCd,  postOrtVO[i]);
          }
        }
      }
      */

      rowCount = postOrtDAO.delete();
      LOG.debug("ladeOrtsverzeichnis - " + rowCount + " records deletet from table post_ort" );

      for(int i = 0; i < postOrtVO.length; i++)
      {
        // Landcode setzen, ist kanton = 'D' || 'LI' || 'I' ist die Ortschaft in
        // Deutschland, Lichtenstein oder Italien und der land_cd muss gesetzt werden
        // Die Post hat nicht den gleichen Ländercode wie ISO 3166, darum anderer Ländercode
        postOrtVO[i].setLandCd("CH");
        String kanton = postOrtVO[i].getKanton();

        if(kanton.equals(AdrConstants.LANDPTT_DE))
        {
          postOrtVO[i].setLandCd(AdrConstants.LAND_DE);
        }
        else if(kanton.equals(AdrConstants.LANDPTT_LI))
        {
          postOrtVO[i].setLandCd(AdrConstants.LAND_LI);
        }
        else if(kanton.equals(AdrConstants.LANDPTT_LI))
        {
          postOrtVO[i].setLandCd(AdrConstants.LAND_LI);
        }

        // Normalisierter Ort setzen
        postOrtVO[i].setOrtNorm(PostOrtNorm.getOrtNorm(postOrtVO[i].getOrt()));
        postOrtDAO.insert(postOrtVO[i]);
      }
      LOG.debug("ladeOrtsverzeichnis - " + postOrtVO.length + " records inserted in table post_ort");
    }
    catch (SQLException ex)
    {
      LOG.error(ex.getMessage());
      throw new EJBException(ex);
    }
  }
}
