package ch.ige.adr.server.dao.test;

import java.util.ArrayList;

import junit.framework.TestCase;
import ch.ige.adr.server.dao.BlandDAO;
import ch.ige.util.server.DBHelper;

/**
 * Test der Klasse BLandDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: BlandDAOTest.java,v 1.7 2007/01/11 09:56:37 nydegger Exp $
 */

public class BlandDAOTest extends TestCase
{
  /**
   * @param s
   */
  public BlandDAOTest(String s)
  {
    super(s);
    DBHelper.setRunOnServer( false );
  }

  /**
   */
  public void test01ExistLandAll()
  {
    BlandDAO  dao = new BlandDAO();
    String landCd = "CH";
    try
    {
      boolean res = dao.exists(landCd);
      assertTrue(res);
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  /**
   * test select
   */
  public void test02Select()
 {
   BlandDAO  dao = new BlandDAO();
   String landCd = "CH";
   try
   {
     ArrayList al = dao.select(landCd, null);
     assertTrue(al.size() > 0);
     al = dao.select(null, null);
     assertTrue(al.size() > 200);
     al = dao.select(null, "%Paraguay");
     assertTrue(al.size() == 1);
     al = dao.select(null, "%Paraguay%");
     assertTrue(al.size() == 1);
     al = dao.select(null, "%Paragua");
     assertTrue(al.size() == 1);
     al = dao.select("CH", "%Paraguay");
     assertTrue(al.size() == 0);
   }
   catch(Exception e)
   {
     e.printStackTrace();
     fail(e.toString());
   }
 }
}
