package ch.ige.adr.server.dao.test;

import java.util.ArrayList;

import junit.framework.TestCase;
import ch.ige.adr.server.dao.LandDAO;
import ch.ige.adr.vo.LandAVO;
import ch.ige.util.server.DBHelper;

/**
 * Test der Klasse LandOrtDAO
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: LandDAOTest.java,v 1.8 2007/07/03 15:20:54 nydegger Exp $
 */

public class LandDAOTest extends TestCase
{
  /**
   * @param s
   */
  public LandDAOTest(String s)
  {
    super(s);
    DBHelper.setRunOnServer( false );
  }


  /**
   * 
   * test01ExistLandAll
   */
  public void test01ExistLandAll()
  {
    LandDAO  dao = new LandDAO();
    String landCd = "CH";
    try
    {
      boolean res = dao.exists(landCd);
      assertTrue(res);
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }

  
 
  

  /**
   * test select
   */
  public void test02Select()
 {
   LandDAO  dao = new LandDAO();
   String landCd = "CH";
   try
   {
     ArrayList al = dao.select(landCd, null);
     assertTrue(al.size() > 0);
     al = dao.select(null, null);
     assertTrue(al.size() > 200);
     al = dao.select(null, "Deutschland");
     assertTrue(al.size() == 1);
     al = dao.select(null, "Deutschla%");
     assertTrue(al.size() == 1);
     al = dao.select(null, "Deutschla");
     assertTrue(al.size() == 1);
     al = dao.select("CH", "Deutschland");
     assertTrue(al.size() == 0);
   }
   catch(Exception e)
   {
     e.printStackTrace();
     fail(e.toString());
   }
 }
  
  public void test03Select()
  {
    try
    {
      
    
    LandDAO  dao = new LandDAO();
    ArrayList al = dao.select("F", "");
    assertTrue("1. Test - Länder mit Code F%: ", al.size() > 0);
    for(int i = 0; i < al.size(); i++)
    {
      assertTrue("2. Test - Länder mit Code F%: ", ((LandAVO)al.get(i)).landCd.startsWith("F"));
    }
    al = dao.select(null, "F");
    al = dao.select("", "F");
    assertTrue("3. Test - Länder mit Bezeichnung F%: ", al.size() > 0);
    for(int i = 0; i < al.size(); i++)
    {
      assertTrue("4. Test - Länder mit Bezeichnung F%: ", 
          ((LandAVO)al.get(i)).landBez.startsWith("F") || ((LandAVO)al.get(i)).landBez.substring( 3 ).startsWith("F") );
    }
    al = dao.select("L", "L");
    assertTrue("4. Test - Lichtenstein L% L%: ", al.size() > 0);
    for(int i = 0; i < al.size(); i++)
    {
      assertTrue("5. Test - Lichtenstein L%: ", ((LandAVO)al.get(i)).landCd.startsWith("L"));
      assertTrue("6. Test - Lichtenstein L%: ", ((LandAVO)al.get(i)).landBez.startsWith("L"));
    }
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      fail(ex.getMessage());
    }
  }  
}
