package ch.ige.adr.server.test;

import java.util.ArrayList;

import junit.framework.TestCase;
import ch.ige.adr.server.RegadrEpBO;
import ch.ige.adr.server.dao.AdresseDAO;
import ch.ige.adr.server.dao.RegadrDAO;
import ch.ige.adr.vo.AdresseVO;
import ch.ige.adr.vo.RegadrExistsVO;
import ch.ige.util.vo.VersadrVO;

/**
 * Test der Klasse EPGesperrtTestJunit
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: EPGesperrtTestJunit.java,v 1.11 2007/07/03 15:20:54 nydegger Exp $
 */

public class EPGesperrtTestJunit extends TestCase
{
  /**
   * @param s
   */
  public EPGesperrtTestJunit(String s)
  {
    super(s);
  }

  /**
   * testSelectGesperrtRegadr
   */
  public void testSelectGesperrtRegadr()
  {
    System.out.println("Test Select Gesperrte ");
    RegadrDAO regDao = new RegadrDAO();
    RegadrExistsVO regVo = new RegadrExistsVO();
    try
    {
      regVo.blandCd = "CH";
      regVo.regName = "Imes AG";
      regVo.regOrt = "6330 Cham";
      regVo.regStrasse = "Gewerbestrasse 11";

      ArrayList al = regDao.select(regVo);

      // es hat nur eine zutreffende Registeradresse, die ist aber gesperrt
      // also size = null
      assertEquals(al.size(), 0);

      System.out.println("Anzahl Registeradressen: " + al.size());
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }

  /**
   * testSelectGesperrtVersadr
   */
  public void _testSelectGesperrtVersadr()
  {
    System.out.println("Test Select logisch gelöschte  ");
    RegadrEpBO bo = new RegadrEpBO(null);

    AdresseVO adrVO = new AdresseVO();
    AdresseDAO adrDao = new AdresseDAO();

    try
    {
      // adressen gleich machen
      adrVO = adrDao.select(1000001);
      assertEquals(bo.aehnlich(null, adrVO), false);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }

  /**
   * testSelectBlockedVersadr
   */
  public void _testSelectBlockedVersadr()
  {
    System.out.println("Test Select blocked versadr gelöschte  ");
    AdresseDAO adrDao = new AdresseDAO();
    VersadrVO versadrVO = new VersadrVO();

    try
    {
      AdresseVO adresseVO = adrDao.select(1000291);

      versadrVO.setAdrNr(adresseVO.getAdrNr());
      versadrVO.setSuchbegr(adresseVO.getSuchbegr());
      versadrVO.setSprachCd(adresseVO.getSprachCd());
      versadrVO.setAnrCd(adresseVO.getAnrCd());
      versadrVO.setName(adresseVO.getName());
      versadrVO.setZeile1(adresseVO.getZeile1());
      versadrVO.setZeile2(adresseVO.getZeile2());
      versadrVO.setZeile3(adresseVO.getZeile3());
      versadrVO.setZeile4(adresseVO.getZeile4());
      versadrVO.setLandCd(adresseVO.getLandCd());
      versadrVO.setPfPlz(adresseVO.getPfPlz());
      versadrVO.setPlz(adresseVO.getPlz());
      versadrVO.setOrt(adresseVO.getOrt());
      versadrVO.setTelefon(adresseVO.getTelefon());
      //  telex; wird nicht mehr verwendet
      versadrVO.setFax(adresseVO.getFax());
      versadrVO.setErstDat(adresseVO.getErstDat());
      versadrVO.setErstBen(adresseVO.getErstBen());
      versadrVO.setGeaendDat(adresseVO.getGeaendDat());
      versadrVO.setGeaendBen(adresseVO.getGeaendBen());
      versadrVO.setUVersion(adresseVO.getUVersion());
      versadrVO.setPlzZusatz(adresseVO.getPlzZusatz());
      versadrVO.setGesperrt(adresseVO.getGesperrt());
      versadrVO.setAdrNrNeu(adresseVO.getAdrNrNeu());
      versadrVO.setVersion(adresseVO.getVersion());

      RegadrEpBO bo = new RegadrEpBO(null);
      assertEquals(bo.aehnlich(versadrVO, adresseVO), false);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }
}
