package ch.ige.art.client;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import ch.ige.art.BuildInfo;
import ch.ige.art.server.ArtikelDelegate;
import ch.ige.main.client.DlgInfo;
import ch.ige.util.client.IgeImage;

/**
 * 
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   galli
 * @version  $Id: CustomDlgInfo.java,v 1.2 2007/09/25 08:10:02 galli Exp $
 */
public class CustomDlgInfo extends DlgInfo
{

  private static final Logger LOG = Logger.getLogger( CustomDlgInfo.class );

  /**
   * @param owner the application main frame
   * @param modal true if the dialog is modal
   */
  public CustomDlgInfo( JFrame owner, boolean modal )
  {
    super( owner, modal );
  }

  /**
   * customises the inforamtions shown by the info dialog. automatically called on object creation.
   * For more inforamtions, take a look at @see ch.ige.main.client.DlgInfo
   *  
   */
  protected void dialogInit()
  {
    super.dialogInit();

    this.setFrameTitle( "Info zum ArtikelGui" );
    this.setPanelTitle( "ArtikelGui" );

    this.setCopyright( "Copyright © 2002" );

    ValuePair[] dbUrl = new ValuePair[1];
    try
    {
      dbUrl[0] = new ValuePair( "BAGIS-DB:", ArtikelDelegate.getInstance().getBagisDBURL() );
    }
    catch ( Exception e )
    {
      LOG.error( "Error: " + e.getMessage(), e );
      JOptionPane.showMessageDialog( null, e.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
    this.setDbUrl( dbUrl );

    ValuePair[] version = new ValuePair[2];
    version[0] = new ValuePair( "App. Version:", BuildInfo.CVS_TAG );
    version[1] = new ValuePair( "Build Id:", BuildInfo.BUILD_ID );
    this.setVersion( version );

    this.setImage( IgeImage.imgIgeLogoSmall );

  }

}
