package ch.ige.art.client;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Überschrift: </p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author unbekannt
 * @version 1.0
 */

public class DlgPrint extends JDialog
{
  private JPanel pnlPrint = new JPanel();
  private JCheckBox cbkStammblatt = new JCheckBox();
  private JCheckBox cbkTrefferliste = new JCheckBox();
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private JTextArea txaText = new JTextArea();
  private JLabel jLabel2 = new JLabel();
  private JPanel pnlButton = new JPanel();
  private JButton btnAbbrechen = new JButton();
  private JButton btnOK = new JButton();

  public static final int OK_OPTION = 0;
  public static final int CANCEL_OPTION = 1;
  public static final int CLOSED_OPTION = -1;
  private int optionType = CLOSED_OPTION;


  public DlgPrint()
  {
    try
    {
      jbInit();
    }
    catch ( Exception e )
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    cbkStammblatt.setText( "Stammblatt-Druck" );
    cbkTrefferliste.setText( "Trefferliste-Druck" );
    pnlPrint.setLayout( gridBagLayout1 );
    txaText.setEnabled( true );
    txaText.setMinimumSize( new Dimension( 350, 150 ) );
    txaText.setPreferredSize(new Dimension(330, 50) );
    txaText.setEditable( false );
    txaText.setText( "Wählen Sie die zu Drucken gewünschten Optionen aus " +
                     "\n\n Trefferliste druckt die ersichtlichen Daten als Liste " );
    txaText.setLineWrap( true );
    txaText.setWrapStyleWord( true );
    jLabel2.setPreferredSize( new Dimension( 322, 20 ) );
    jLabel2.setText( "Stammblatt druckt die Detaildaten pro Zeile aus" );
    btnAbbrechen.setPreferredSize( new Dimension( 95, 27 ) );
    btnAbbrechen.setText( "Abbrechen" );
    btnAbbrechen.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        btnAbbrechen_actionPerformed( e );
      }
    } );

    btnOK.setMaximumSize( new Dimension( 53, 27 ) );
    btnOK.setMinimumSize( new Dimension( 95, 27 ) );
    btnOK.setPreferredSize( new Dimension( 95, 27 ) );
    btnOK.setMnemonic( '0' );
    btnOK.setText( "OK" );
    btnOK.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        btnOK_actionPerformed( e );
      }
    } );

    this.getContentPane().add( pnlPrint, BorderLayout.CENTER );
    pnlPrint.add( cbkStammblatt, new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 0, 0, 0 ), 0, 0 ) );
    pnlPrint.add( txaText, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 0, 0, 0 ), 0, 0 ) );
    pnlPrint.add( jLabel2, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 10, 0, 0, 0 ), 0, 0 ) );
    pnlPrint.add( cbkTrefferliste, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 0, 0, 0 ), 0, 0 ) );
    this.getContentPane().add( pnlButton, BorderLayout.SOUTH );
    pnlButton.add( btnOK, null );
    pnlButton.add( btnAbbrechen, null );
  }

  /**
   * Button OK angewählt. Optiontype auf OK setzen
   * Falls es sich um eine gültige Auswahl handelt wird der Dialog geschlossen,
   * andernfalls eine Message angezeigt
   * @param e ActionEvent
   */
  private void btnOK_actionPerformed( ActionEvent e )
  {
    this.optionType = this.OK_OPTION;
    if ( isValidSelection() )
    {
      close();
    }
    else
    {
      JOptionPane.showMessageDialog( this, "Mindestens eine Option muss angewählt werden",
                                     "Ungültige Auswahl", JOptionPane.INFORMATION_MESSAGE );
    }
  }

  /**
   * Button Abbrechen angewählt. Optiontype auf CANCEL setzen
   * Dialog schliessen
   * @param e ActionEvent
   */
  private void btnAbbrechen_actionPerformed( ActionEvent e )
  {
    this.optionType = this.CANCEL_OPTION;
    close();
  }

  /**
   * @return boolean  true falls Stammblatt angewählt
   */
  public boolean isStammblattSelected()
  {
    return this.cbkStammblatt.isSelected();
  }

  /**
   * @return boolean true falls Trefferliste angewählt
   */
  public boolean isListeSelected()
  {
    return this.cbkTrefferliste.isSelected();
  }

  /**
   * Dialog schliessen
   */
  private void close()
  {
    this.setVisible( false );
    this.dispose();
  }

  /**
   * Gibt an ob die gewählte Auswahl gültig ist
   * Stammblatt oder Trefferliste muss angewählt sein
   * @return boolean true falls Auswahl gültig
   */
  private boolean isValidSelection()
  {
    return ( isStammblattSelected() || isListeSelected() );
  }

  /**
   * Zeigt den Druckdialog an
   */
  public int showDialog()
  {
    this.setTitle( "Druckauswahl" );
    this.setSize(360, 200);
    this.setModal(true);

    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = this.getSize();
    this.setLocation((screenSize.width - frameSize.width) / 2,
                             (screenSize.height - frameSize.height) / 2);
    this.setVisible(true);

    // Gibt den gewählten Optiontype zurück OK oder Abbrechen
    return this.optionType;
  }
}
