package ch.ige.art.client;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import ch.ige.arthelp.HelpUtil;
import ch.ige.main.client.MainController;
import ch.ige.main.client.MenuPane;

/**
 * <p>Überschrift: Einstiegsfenster abgeleitet von MenuPane</p>
 * <p>Beschreibung: Applikationsspezifische Eigenschaften setzten bzw. überschreiben</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: MenuPaneArtikel.java,v 1.9 2008/04/29 07:19:53 galli Exp $
 */

public class MenuPaneArtikel extends MenuPane
{

  public MenuPaneArtikel()
  {
    super();
    initHelp();
  }

  /**
   * Komponente erstellen
   * @param mainController Frame
   * @param mode Modus
   */
  public MenuPaneArtikel( MainController mainController, int mode )
  {
    super( mainController, mode );
    initHelp();
  }

  /**
   * gibt den Titel zurück
   * @return Titel
   */
  public String getTitle()
  {
    return "Artikel Hauptmenü";
  }

  /**
   * Info-Fenster anzeigen
   * @param e ActionEvent
   */
  protected void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  private void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this, "intro" );
    HelpUtil.getInstance().enableHelpOnButton( this.btnHelp, "allgemeines" );
    HelpUtil.getInstance().enableHelpOnButton( this.mnuHelp, "intro" );
    HelpUtil.getInstance().enableHelp( this.btnBack, "allgemeines.symbolleiste" );
    HelpUtil.getInstance().enableHelp( this.btnDetail, "allgemeines.symbolleiste" );
    HelpUtil.getInstance().enableHelp( this.btnForward, "allgemeines.symbolleiste" );
    HelpUtil.getInstance().enableHelp( this.btnHome, "allgemeines.symbolleiste" );
    HelpUtil.getInstance().enableHelp( this.btnPrint, "allgemeines.symbolleiste" );
    HelpUtil.getInstance().enableHelp( this.menFile, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.menGo, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.menHelp, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuBack, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuExit, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuForward, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuForwardPopup, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuFunctionPopup, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuHome, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuInfo, "allgemeines.menu" );
    HelpUtil.getInstance().enableHelp( this.mnuPrint, "allgemeines.menu" );
  }
}
