package ch.ige.art.client.art;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import org.apache.log4j.Logger;

import ch.ige.art.client.util.ComboBoxObject;
import ch.ige.art.client.util.PnlArtikelWizard;
import ch.ige.art.client.util.UserMessage;
import ch.ige.art.client.util.renderer.ComboRenderer;
import ch.ige.art.util.PublicationChapter;
import ch.ige.art.util.XxDomain;
import ch.ige.art.util.XxDomainFactory;
import ch.ige.art.vo.ArtikelGuiAVO;
import ch.ige.art.vo.XxDomainVO;
import ch.ige.arthelp.HelpUtil;
import ch.ige.util.client.LimitedDocument;

/**
 * <p>Überschrift: Artikel-Bagisdaten</p>
 * <p>Beschreibung: Panel mit Bagisdaten</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: PnlArtBagis2.java,v 1.28 2008/07/02 11:00:20 heinzer Exp $
 */

public class PnlArtBagis2 extends PnlArtikelWizard
{

  private List<XxDomainVO> listDomain;

  private ArtikelGuiAVO artikelGuiAVO = null;

  private LimitedDocument ldoFristDauer = new LimitedDocument();

  // Logging
  private static final Logger LOG = Logger.getLogger( PnlArtBagis2.class );

  private UserMessage userMessage = new UserMessage();

  private JPanel pnlCenter = new JPanel();

  private BorderLayout borderLayout1 = new BorderLayout();

  private GridBagLayout lytCenter = new GridBagLayout();

  private JLabel lblFristArt = new JLabel();

  private JLabel lblFristDauer = new JLabel();

  private JLabel lblFristEinh = new JLabel();

  private JLabel lblPublPflicht = new JLabel();

  private JLabel lblLageinh = new JLabel();

  private JLabel lblStatcd3 = new JLabel();

  private JLabel lblRegauszGrp = new JLabel();

  private JLabel lblBonusCd = new JLabel();

  private JLabel lblKzMetnot = new JLabel();

  private JTextField txfFristDauer = new JTextField();

  private JComboBox cbxPublPflicht = new JComboBox();

  private JComboBox cbxFristEinh = new JComboBox();

  private JComboBox cbxFristArt = new JComboBox();

  private JComboBox cbxLageinh = new JComboBox();

  private JComboBox cbxBonusCd = new JComboBox();

  private JComboBox cbxKzMetnot = new JComboBox();

  private JComboBox cbxRegauszGrp = new JComboBox();

  private JComboBox cbxStatcd3 = new JComboBox();

  /**
   * holt Instanz von xxDomain um Werte aus xx_domain lesen zu können<br>
   * ruft jbInit() auf
   * @param artikelGuiVO  ValueObject mit allen Daten eines Artikels
   */
  public PnlArtBagis2()
  {
    try
    {
      jbInit();
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.info( ex.getClass() + " " + ex.getMessage() );
      String message = userMessage.getUserMessage( ex );
      JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
    }
  }

  void jbInit() throws Exception
  {
    this.setLayout( borderLayout1 );
    this.setPreferredSize( new Dimension( 400, 300 ) );
    this.setMinimumSize( new Dimension( 300, 200 ) );
    pnlCenter.setPreferredSize( new Dimension( 480, 346 ) );
    cbxFristEinh.setMaximumSize( new Dimension( 300, 20 ) );
    cbxFristEinh.setMinimumSize( new Dimension( 300, 20 ) );
    cbxFristEinh.setPreferredSize( new Dimension( 300, 20 ) );
    txfFristDauer.setMaximumSize( new Dimension( 80, 20 ) );
    txfFristDauer.setMinimumSize( new Dimension( 80, 20 ) );
    txfFristDauer.setPreferredSize( new Dimension( 80, 20 ) );
    cbxFristArt.setMaximumSize( new Dimension( 300, 20 ) );
    cbxFristArt.setMinimumSize( new Dimension( 300, 20 ) );
    cbxFristArt.setPreferredSize( new Dimension( 300, 20 ) );
    cbxLageinh.setMaximumSize( new Dimension( 300, 20 ) );
    cbxLageinh.setMinimumSize( new Dimension( 300, 20 ) );
    cbxLageinh.setPreferredSize( new Dimension( 300, 20 ) );
    cbxPublPflicht.setMaximumSize( new Dimension( 300, 20 ) );
    cbxPublPflicht.setMinimumSize( new Dimension( 300, 20 ) );
    cbxPublPflicht.setPreferredSize( new Dimension( 300, 20 ) );
    cbxRegauszGrp.setMaximumSize( new Dimension( 300, 20 ) );
    cbxRegauszGrp.setMinimumSize( new Dimension( 300, 20 ) );
    cbxRegauszGrp.setPreferredSize( new Dimension( 300, 20 ) );
    cbxBonusCd.setMaximumSize( new Dimension( 300, 20 ) );
    cbxBonusCd.setMinimumSize( new Dimension( 300, 20 ) );
    cbxBonusCd.setPreferredSize( new Dimension( 300, 20 ) );
    cbxKzMetnot.setMaximumSize( new Dimension( 300, 20 ) );
    cbxKzMetnot.setMinimumSize( new Dimension( 300, 20 ) );
    cbxKzMetnot.setPreferredSize( new Dimension( 300, 20 ) );
    cbxStatcd3.setMaximumSize( new Dimension( 300, 20 ) );
    cbxStatcd3.setMinimumSize( new Dimension( 300, 20 ) );
    cbxStatcd3.setPreferredSize( new Dimension( 300, 20 ) );
    this.add( pnlCenter, BorderLayout.CENTER );

    pnlCenter.setLayout( lytCenter );

    lblFristArt.setToolTipText( "frist_art" );
    lblLageinh.setToolTipText( "lageinh" );
    lblStatcd3.setToolTipText( "statcd_3" );
    lblPublPflicht.setToolTipText( "publ_pflicht" );
    lblRegauszGrp.setToolTipText( "regausz_grp" );
    lblBonusCd.setToolTipText( "bonus_cd" );
    lblKzMetnot.setToolTipText( "kz_metnot" );
    lblFristArt.setHorizontalAlignment( SwingConstants.RIGHT );
    lblFristArt.setText( "Frist Art:" );
    lblFristDauer.setToolTipText( "frist_dauer" );
    lblFristDauer.setHorizontalAlignment( SwingConstants.RIGHT );
    lblFristDauer.setText( "Frist Dauer:" );
    lblFristEinh.setText( "Frist Einheit:" );
    lblFristEinh.setHorizontalAlignment( SwingConstants.RIGHT );
    lblFristEinh.setToolTipText( "frist_einh" );
    lblPublPflicht.setHorizontalAlignment( SwingConstants.RIGHT );
    lblPublPflicht.setText( "Publikationspflicht:" );
    lblLageinh.setText( "Lagereinheit:" );
    lblLageinh.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStatcd3.setText( "Unterabschnitt Publikation:" );
    lblStatcd3.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegauszGrp.setText( "Registerauszugsgruppe:" );
    lblRegauszGrp.setHorizontalAlignment( SwingConstants.RIGHT );
    lblBonusCd.setText( "Bonus Code:" );
    lblBonusCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblKzMetnot.setText( "MARNA3-Auftrag:" );
    lblKzMetnot.setHorizontalAlignment( SwingConstants.RIGHT );

    cbxBonusCd.setBackground( SystemColor.controlLtHighlight );
    cbxFristArt.setBackground( SystemColor.controlLtHighlight );
    cbxFristEinh.setBackground( SystemColor.controlLtHighlight );
    cbxKzMetnot.setBackground( SystemColor.controlLtHighlight );
    cbxLageinh.setBackground( SystemColor.controlLtHighlight );
    cbxPublPflicht.setBackground( SystemColor.controlLtHighlight );
    cbxRegauszGrp.setBackground( SystemColor.controlLtHighlight );
    cbxStatcd3.setBackground( SystemColor.controlLtHighlight );

    pnlCenter.add( lblFristEinh, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 6, 0, 0 ),
        124, 5 ) );
    pnlCenter.add( lblFristDauer, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        128, 5 ) );
    pnlCenter.add( lblFristArt, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 148,
        5 ) );
    pnlCenter.add( lblLageinh,
        new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 120, 5 ) );
    pnlCenter
        .add( lblStatcd3, new GridBagConstraints( 0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 45, 5 ) );
    pnlCenter.add( lblRegauszGrp, new GridBagConstraints( 0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 56,
        5 ) );
    pnlCenter.add( lblPublPflicht, new GridBagConstraints( 0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        89, 5 ) );
    pnlCenter.add( cbxFristEinh, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 10, 4, 0 ), 0,
        0 ) );
    pnlCenter.add( txfFristDauer, new GridBagConstraints( 1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0,
        0 ) );
    pnlCenter.add( cbxFristArt,
        new GridBagConstraints( 1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlCenter.add( lblBonusCd,
        new GridBagConstraints( 0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 120, 5 ) );
    pnlCenter.add( lblKzMetnot, new GridBagConstraints( 0, 8, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 6, 0, 0 ),
        99, 5 ) );
    pnlCenter.add( cbxPublPflicht, new GridBagConstraints( 1, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlCenter
        .add( cbxLageinh, new GridBagConstraints( 1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlCenter
        .add( cbxStatcd3, new GridBagConstraints( 1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlCenter
        .add( cbxBonusCd, new GridBagConstraints( 1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlCenter.add( cbxKzMetnot, new GridBagConstraints( 1, 8, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlCenter.add( cbxRegauszGrp, new GridBagConstraints( 1, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0,
        0 ) );

    // Combobox bonus_cd
    cbxBonusCd.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.BONUS_CD );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxBonusCd.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox frist_art
    cbxFristArt.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.FRIST_ART );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxFristArt.addItem( new ComboBoxObject( xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox frist_einh
    cbxFristEinh.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.FRIST_EINH );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxFristEinh.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // ActionListener FristEinheit
    cbxFristEinh.addActionListener( new ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        validateFristen();
      }
    } );

    // Combobox kz_metnot
    cbxKzMetnot.setRenderer( new ComboRenderer() );
    cbxKzMetnot.addItem( new ComboBoxObject() );
    listDomain = XxDomain.getDomains( XxDomainFactory.KZ_METNOT );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxKzMetnot.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox lageinh
    cbxLageinh.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.LAGEINH );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxLageinh.addItem( new ComboBoxObject( xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox publ_pflicht
    cbxPublPflicht.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.PUBL_PFLICHT );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxPublPflicht.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox regausz_grp
    cbxRegauszGrp.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.REGAUSZ_GRP );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxRegauszGrp.addItem( new ComboBoxObject( xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }

    // Combobox statcd3
    // Items depend on artnr, combobox is filled in function setData()
    cbxStatcd3.setRenderer( new ComboRenderer() );

    // Validierungen
    txfFristDauer.setDocument( ldoFristDauer );
    ldoFristDauer.setInteger( true );
    ldoFristDauer.setMaxLength( 4 );
  }

  /**
   * Füllt Controls mit den Werten des artikelGuiAVO<br>
   * Setzt den Index der Comboboxen auf die Werte des artikelGuiAVO
   * @param artikelGuiAVO ValueObject mit den Werten
   */
  public void setData( ArtikelGuiAVO artikelGuiAVO )
  {
    this.artikelGuiAVO = artikelGuiAVO;

    // ComboBoxen auf artikelGuiAVO Werte setzen
    if ( artikelGuiAVO.bonusCd != null && !artikelGuiAVO.bonusCd.equals( "" ) )
    {
      cbxBonusCd.setSelectedItem( new ComboBoxObject( artikelGuiAVO.bonusCd, XxDomain.getKbez( XxDomainFactory.BONUS_CD, new Integer( artikelGuiAVO.bonusCd )
          .intValue() ) ) );
    }
    if ( artikelGuiAVO.fristArt != null && !artikelGuiAVO.fristArt.equals( "" ) )
    {
      cbxFristArt.setSelectedItem( new ComboBoxObject( artikelGuiAVO.fristArt, XxDomain.getBez( artikelGuiAVO.fristArt, XxDomainFactory.FRIST_ART ) ) );
    }
    if ( artikelGuiAVO.fristEinh != null && !artikelGuiAVO.fristEinh.equals( "" ) )
    {
      cbxFristEinh.setSelectedItem( new ComboBoxObject( artikelGuiAVO.fristEinh, XxDomain.getBez( new Integer( artikelGuiAVO.fristEinh ).intValue(),
          XxDomainFactory.FRIST_EINH ) ) );
    }
    if ( artikelGuiAVO.kzMetnot != null && !artikelGuiAVO.kzMetnot.equals( "" ) )
    {
      cbxKzMetnot.setSelectedItem( new ComboBoxObject( artikelGuiAVO.kzMetnot, XxDomain.getBez( new Integer( artikelGuiAVO.kzMetnot ).intValue(),
          XxDomainFactory.KZ_METNOT ) ) );
    }
    if ( artikelGuiAVO.lageinh != null && !artikelGuiAVO.lageinh.equals( "" ) )
    {
      cbxLageinh.setSelectedItem( new ComboBoxObject( artikelGuiAVO.lageinh, XxDomain.getBez( artikelGuiAVO.lageinh ), XxDomainFactory.LAGEINH ) );
    }
    if ( artikelGuiAVO.publPflicht != null && !artikelGuiAVO.publPflicht.equals( "" ) )
    {
      cbxPublPflicht.setSelectedItem( new ComboBoxObject( artikelGuiAVO.publPflicht, XxDomain.getKbez( XxDomainFactory.PUBL_PFLICHT, new Integer(
          artikelGuiAVO.publPflicht ).intValue() ) ) );
    }

    // Combobox statcd3 Items depend on artnr, publication chapter are valid in special ranges 
    cbxStatcd3.removeAllItems();
    cbxStatcd3.addItem( new ComboBoxObject() );

    String domain = PublicationChapter.getCorrespondingDomainValue( artikelGuiAVO.artNr );
    listDomain = XxDomain.getDomains( domain );

    // fill up combobox with valid values
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxStatcd3.addItem( new ComboBoxObject( xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }

    if ( artikelGuiAVO.statcd3 != null && !artikelGuiAVO.statcd3.equals( "" ) )
    {
      ComboBoxObject cbxStat = new ComboBoxObject( artikelGuiAVO.statcd3, XxDomain.getBez( artikelGuiAVO.statcd3, XxDomainFactory.PUBL_KAP ) );

      cbxStatcd3.setSelectedItem( cbxStat );

      //if item not found, add it to combobox and select it
      //user has to change the value by himself
      ComboBoxObject c = (ComboBoxObject) cbxStatcd3.getSelectedItem();
      if ( c.value != artikelGuiAVO.statcd3 )
      {
        cbxStatcd3.insertItemAt( cbxStat, 0 );
        cbxStatcd3.setSelectedItem( cbxStat );
      }
    }

    //cbxRegauszGrp int der in xx_domain in kbez gespeichert wird
    cbxRegauszGrp.setSelectedItem( new ComboBoxObject( Integer.toString( artikelGuiAVO.regauszGrp ), XxDomain.getBez( Integer
        .toString( artikelGuiAVO.regauszGrp ), XxDomainFactory.REGAUSZ_GRP ) ) );

    // Textfelder auf artikelGuiAVO Werte setzen
    txfFristDauer.setText( artikelGuiAVO.fristDauer == null ? "" : artikelGuiAVO.fristDauer.toString() );

    // Fristen validieren
    validateFristen();
  }

  /**
   * ArtikelGuiAVO wird mit den geänderten Werten abgefüllt<br>
   * @return ArtikelGuiAVO mit aktuellen Werten
   */
  public ArtikelGuiAVO getData()
  {
    //Comboboxen
    artikelGuiAVO.bonusCd = getComboValue( cbxBonusCd );
    artikelGuiAVO.fristArt = getComboValue( cbxFristArt );
    artikelGuiAVO.fristEinh = getComboValue( cbxFristEinh );
    artikelGuiAVO.kzMetnot = getComboValue( cbxKzMetnot ).equals( "" ) ? null : getComboValue( cbxKzMetnot );
    artikelGuiAVO.lageinh = getComboValue( cbxLageinh );
    artikelGuiAVO.publPflicht = getComboValue( cbxPublPflicht );
    artikelGuiAVO.regauszGrp = new Integer( getComboValue( cbxRegauszGrp ) ).intValue();
    artikelGuiAVO.statcd3 = getComboValue( cbxStatcd3 ).equals( "" ) ? null : getComboValue( cbxStatcd3 );

    //Textfelder
    artikelGuiAVO.fristDauer = txfFristDauer.getText().equals( "" ) ? null : new Integer( txfFristDauer.getText() );

    return artikelGuiAVO;
  }

  /**
   * Wenn Frist-Einheit gleich 0 (keine Einheit) ist, werden Frist-Dauer und
   * Frist-Art automatisch auf 0 und unbearbeitbar gesetzt
   */
  private void validateFristen()
  {
    if ( getComboValue( cbxFristEinh ).equals( "0" ) )
    {
      txfFristDauer.setText( "0" );
      txfFristDauer.setEditable( false );
      cbxFristArt.setSelectedItem( new String[] { "0", XxDomain.getBez( "0", XxDomainFactory.FRIST_ART ) } );
      cbxFristArt.setEnabled( false );
    }
    else
    {
      txfFristDauer.setEditable( true );
      cbxFristArt.setEnabled( true );
    }
  }

  /**
   * Teilt den Array des ComboBoxItems auf und gibt das erste Element zurück<br>
   * Dies entspricht entweder dem domain_lnr oder der kbez der Tabelle xx_domain
   * @param  cbxCombo JComboBox
   * @return erstes Element des ComboBoxItems
   */
  private String getComboValue( JComboBox cbxCombo )
  {
    ComboBoxObject cbo = (ComboBoxObject) cbxCombo.getSelectedItem();
    if ( cbo.key == null || cbo.key.equals( "" ) )
    {
      return "";
    }
    else
    {
      return cbo.key;
    }
  }

  /**
   * Überprüft Eingaben
   * @return  fehler == null --> keine Fehler Artikel kann gespeicher werden
   *          fehler.equals("") --> Fehler aufgetreten und angezeigt, Panel nicht wechseln
   *          anderenfalls den im fehler enthaltenen String anzeigen
   */
  public String validForward()
  {
    if ( txfFristDauer.getText().equals( "" ) )
    {
      return "Frist Dauer muss eingegeben werden";
    }

    if ( artikelGuiAVO.kzGratis.equals( "0" ) && ( getComboValue( cbxFristEinh ).equals( "0" ) || txfFristDauer.getText().equals( "0" ) ) )
    {
      return "Bei einem kostenpflichtigen Artikel muss eine Frist-Einheit gewählt werden.\n" + "Die Frist-Dauer muss grösser als 0 sein";
    }

    String valueStatcd3 = getComboValue( cbxStatcd3 );
    if ( !valueStatcd3.equals( "" ) )
    {
      String domain = PublicationChapter.getCorrespondingDomainValue( artikelGuiAVO.artNr );
      List listKbez = XxDomain.getDomainKbez( domain );
      if ( !listKbez.contains( valueStatcd3 ) )
      {
        return ( "Das Publikationskapitel " + valueStatcd3 + " ist ungültig für den gewählten Artikel\n"
            + "Kapitel Patente xxx gültig für Artikel 10'000 - 29'999 \n" + "Kapitel Marken Mxx gültig für Artikel 40'000 - 49'999  \n"
            + "Kapitel Design Dxx gültig für Artikel 60'000 - 69'999  \n" + "Kapitel ESZ Exx gültig für Artikel 110'000 - 119'999 " );
      }
    }

    return null;
  }

  public String validBackward()
  {
    return null;
  }

  private void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblBonusCd, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblFristArt, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblFristDauer, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblFristEinh, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblKzMetnot, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblLageinh, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblPublPflicht, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblRegauszGrp, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.lblStatcd3, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.txfFristDauer, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxStatcd3, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxBonusCd, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxFristArt, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxFristEinh, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxKzMetnot, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxLageinh, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxPublPflicht, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.cbxRegauszGrp, "artikelwizard.bagisdaten2" );
    HelpUtil.getInstance().enableHelp( this.pnlCenter, "artikelwizard.bagisdaten2" );
  }

}
