package ch.ige.art.client.art;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigDecimal;
import java.util.List;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.apache.log4j.Logger;

import ch.ige.art.client.resources.BasedataConstants;
import ch.ige.art.client.util.ComboBoxObject;
import ch.ige.art.client.util.PnlArtikelWizard;
import ch.ige.art.client.util.UserMessage;
import ch.ige.art.util.PublicationChapter;
import ch.ige.art.util.XxDomain;
import ch.ige.art.util.XxDomainFactory;
import ch.ige.art.vo.ArtikelGuiAVO;
import ch.ige.art.vo.XxDomainVO;
import ch.ige.arthelp.HelpUtil;
import ch.ige.util.client.LimitedDocument;

/**
 * <p>Überschrift: Artikel-Grunddaten</p>
 * <p>Beschreibung: Panel mit Daten eines Artikels</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: PnlArtGrunddaten.java,v 1.29 2008/07/03 13:19:21 heinzer Exp $
 */

public class PnlArtGrunddaten extends PnlArtikelWizard
{

  private ArtikelGuiAVO artikelGuiAVO = new ArtikelGuiAVO();

  // Logging
  private static final Logger LOG = Logger.getLogger( PnlArtGrunddaten.class );

  private UserMessage userMessage = new UserMessage();

  private JPanel pnlCenter = new JPanel();

  private BorderLayout borderLayout1 = new BorderLayout();

  private GridBagLayout gridBagLayout1 = new GridBagLayout();

  private JComboBox cbxKondartCd = new JComboBox();

  private JCheckBox ckbSperrCd = new JCheckBox();

  private JCheckBox ckbAltNrCd = new JCheckBox();

  private JCheckBox ckbKzGratis = new JCheckBox();

  private JCheckBox ckbKzHistDesign = new JCheckBox();

  private JLabel lblBezArt = new JLabel();

  private JLabel lblArtNr = new JLabel();

  private JLabel lblKondartCd = new JLabel();

  private JLabel lblMinverkMenge = new JLabel();

  private JLabel lblOptBestMenge = new JLabel();

  private JLabel lblSuchbegrArt = new JLabel();

  private JTextField txfArtNr = new JTextField();

  private JTextField txfBezArt = new JTextField();

  private JTextField txfMinverkMenge = new JTextField();

  private JTextField txfOptBestMenge = new JTextField();

  private JTextField txfSuchbegrArt = new JTextField();

  private LimitedDocument ldoArtNr = new LimitedDocument();

  private LimitedDocument ldoSuchbegrArt = new LimitedDocument();

  private LimitedDocument ldoMinverkMenge = new LimitedDocument();

  private LimitedDocument ldoOptBestMenge = new LimitedDocument();

  private LimitedDocument ldoBezArt = new LimitedDocument();

  /**
   * holt Instanz von xxDomain um Werte aus xx_domain lesen zu können<br>
   * ruft jbInit() auf
   */
  public PnlArtGrunddaten()
  {
    try
    {
      jbInit();
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.info( ex.getClass() + " " + ex.getMessage() );
      String message = userMessage.getUserMessage( ex );
      JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
    }
  }

  void jbInit() throws Exception
  {
    this.setLayout( borderLayout1 );
    this.setMinimumSize( new Dimension( 300, 200 ) );
    this.setPreferredSize( new Dimension( 550, 425 ) );
    txfArtNr.setMaximumSize( new Dimension( 80, 20 ) );
    txfArtNr.setMinimumSize( new Dimension( 80, 20 ) );
    txfArtNr.setPreferredSize( new Dimension( 80, 20 ) );

    txfArtNr.addFocusListener( new FocusListener()
    {

      public void focusGained( FocusEvent e )
      {
        // nothing to do
      }

      public void focusLost( FocusEvent e )
      {
        if ( refreshDesignSpecificLayout( XxDomainFactory.PUBL_KAP_DES.equals( PublicationChapter.getCorrespondingDomainValue( txfArtNr.getText() ) ), false ) )
        {
          //make sure the updated panel is shown
          pnlCenter.setVisible( false );
          pnlCenter.setVisible( true );
        }
      }
    } );

    txfBezArt.setMaximumSize( new Dimension( 300, 20 ) );
    txfBezArt.setMinimumSize( new Dimension( 300, 20 ) );
    txfBezArt.setPreferredSize( new Dimension( 300, 20 ) );
    addCharsetVerifier( txfBezArt );
    txfSuchbegrArt.setMaximumSize( new Dimension( 300, 20 ) );
    txfSuchbegrArt.setMinimumSize( new Dimension( 300, 20 ) );
    txfSuchbegrArt.setPreferredSize( new Dimension( 300, 20 ) );
    addCharsetVerifier( txfSuchbegrArt );
    cbxKondartCd.setMaximumSize( new Dimension( 300, 20 ) );
    cbxKondartCd.setMinimumSize( new Dimension( 300, 20 ) );
    cbxKondartCd.setPreferredSize( new Dimension( 300, 20 ) );
    txfMinverkMenge.setMaximumSize( new Dimension( 80, 20 ) );
    txfMinverkMenge.setMinimumSize( new Dimension( 80, 20 ) );
    txfMinverkMenge.setPreferredSize( new Dimension( 80, 20 ) );
    txfOptBestMenge.setMaximumSize( new Dimension( 80, 20 ) );
    txfOptBestMenge.setMinimumSize( new Dimension( 80, 20 ) );
    txfOptBestMenge.setPreferredSize( new Dimension( 80, 20 ) );
    ckbAltNrCd.setMaximumSize( new Dimension( 160, 20 ) );
    ckbAltNrCd.setMinimumSize( new Dimension( 160, 20 ) );
    ckbAltNrCd.setPreferredSize( new Dimension( 160, 20 ) );
    ckbSperrCd.setMaximumSize( new Dimension( 108, 20 ) );
    ckbSperrCd.setMinimumSize( new Dimension( 108, 20 ) );
    ckbSperrCd.setPreferredSize( new Dimension( 108, 20 ) );
    ckbKzGratis.setMaximumSize( new Dimension( 93, 20 ) );
    ckbKzGratis.setMinimumSize( new Dimension( 93, 20 ) );
    ckbKzGratis.setPreferredSize( new Dimension( 93, 20 ) );
    ckbKzHistDesign.setMaximumSize( new Dimension( 193, 20 ) );
    ckbKzHistDesign.setMinimumSize( new Dimension( 193, 20 ) );
    ckbKzHistDesign.setPreferredSize( new Dimension( 193, 20 ) );

    this.add( pnlCenter, BorderLayout.CENTER );

    pnlCenter.setPreferredSize( new Dimension( 400, 300 ) );
    pnlCenter.setLayout( gridBagLayout1 );

    BasedataConstants.SEARCH_TERM.setupComponent( lblSuchbegrArt, true );
    BasedataConstants.NUMBER.setupComponent( lblArtNr, true );
    BasedataConstants.SUPER_GROUP.setupComponent( lblKondartCd, true );
    BasedataConstants.MIN_NUMBER.setupComponent( lblMinverkMenge, true );
    BasedataConstants.MAX_NUMBER.setupComponent( lblOptBestMenge, true );
    BasedataConstants.TERM.setupComponent( lblBezArt, true );

    BasedataConstants.LOCKED.setupComponent( ckbSperrCd );
    BasedataConstants.NOT_LAST.setupComponent( ckbAltNrCd );
    BasedataConstants.FREE.setupComponent( ckbKzGratis );
    BasedataConstants.HISTORY_DESIGN.setupComponent( ckbKzHistDesign );

    cbxKondartCd.setBackground( SystemColor.controlLtHighlight );

    pnlCenter
        .add( lblArtNr, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 6, 0, 0 ), 139, 5 ) );
    pnlCenter.add( txfArtNr, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 10, 4, -1000 ), 0,
        0 ) );
    pnlCenter
        .add( lblBezArt, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 82, 5 ) );
    pnlCenter
        .add( txfBezArt, new GridBagConstraints( 1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlCenter.add( lblSuchbegrArt, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        127, 5 ) );
    pnlCenter.add( txfSuchbegrArt, new GridBagConstraints( 1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlCenter.add( lblKondartCd, new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 33,
        5 ) );
    pnlCenter.add( cbxKondartCd, new GridBagConstraints( 1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0,
        0 ) );
    pnlCenter.add( lblMinverkMenge, new GridBagConstraints( 0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        100, 5 ) );
    pnlCenter.add( txfMinverkMenge, new GridBagConstraints( 1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlCenter.add( lblOptBestMenge, new GridBagConstraints( 0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        98, 5 ) );
    pnlCenter.add( txfOptBestMenge, new GridBagConstraints( 1, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
        0, 0 ) );
    pnlCenter
        .add( ckbSperrCd, new GridBagConstraints( 1, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlCenter
        .add( ckbAltNrCd, new GridBagConstraints( 1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );

    //ComboBox kondart_cd füllen
    List<XxDomainVO> listDomain = XxDomain.getDomains( XxDomainFactory.KONDART_CD );
    cbxKondartCd.addItem( new ComboBoxObject() ); // leerer Eintrag
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxKondartCd.addItem( new ComboBoxObject( xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }

    // Validierungen via Documents
    txfArtNr.setDocument( ldoArtNr );
    txfBezArt.setDocument( ldoBezArt );
    txfSuchbegrArt.setDocument( ldoSuchbegrArt );
    txfMinverkMenge.setDocument( ldoMinverkMenge );
    txfOptBestMenge.setDocument( ldoOptBestMenge );

    ldoArtNr.setMaxLength( 9 );
    ldoArtNr.setInteger( true );
    ldoBezArt.setMaxLength( 40 );
    ldoSuchbegrArt.setMaxLength( 20 );
    ldoSuchbegrArt.setUpperCase( true );
    ldoMinverkMenge.setInteger( true );
    ldoMinverkMenge.setMaxLength( 9 );
    ldoOptBestMenge.setInteger( true );
    ldoOptBestMenge.setMaxLength( 9 );
  }

  /**
   * Certain controls are shown only for design articles (ckbKzHist).
   * @param isDesign <code>true</code> if the current article is a design article, <code>false</code> otherwise
   * @param initial <code>true</code> if this is the initial setup of the layout, <code>false</code> if the panels have already been initialized
   * @return Whether the layout has changed (possible redraw necessary)
   * 
   */
  private boolean refreshDesignSpecificLayout( boolean isDesign, boolean initial )
  {
    boolean changed = false;

    if ( isDesign )
    {
      if ( initial || !ckbKzHistDesign.isDisplayable() )
      {
        changed = true;
        pnlCenter.remove( ckbKzGratis );
        pnlCenter.add( ckbKzGratis, new GridBagConstraints( 1, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ),
            0, 0 ) );

        pnlCenter.add( ckbKzHistDesign, new GridBagConstraints( 1, 9, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 10,
            0, 0 ), 0, 0 ) );
      }
      ckbKzHistDesign.setSelected( artikelGuiAVO.kzHistDesign != null && artikelGuiAVO.kzHistDesign.equals( "1" ) );
    }
    else
    {
      if ( initial || ckbKzHistDesign.isDisplayable() )
      {
        changed = true;
        pnlCenter.remove( ckbKzGratis );
        pnlCenter.remove( ckbKzHistDesign );

        pnlCenter.add( ckbKzGratis, new GridBagConstraints( 1, 8, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 10, 0,
            0 ), 0, 0 ) );
      }
    }
    return changed;
  }

  /**
   * Füllt Controls mit den Werten des artikelGuiAVO<br>
   * Setzt den Index der Comboboxen auf die Werte des artikelGuiAVO
   * @param artikelGuiAVO ValueObject mit den Werten
   */
  @Override
  public void setData( ArtikelGuiAVO artikelGuiAVO )
  {
    this.artikelGuiAVO = artikelGuiAVO;

    //Disablen der artikelnummer wenn am Updaten
    txfArtNr.setEnabled( artikelGuiAVO.status.equals( "U" ) ? false : true );

    // Checkboxen
    ckbSperrCd.setSelected( artikelGuiAVO.sperrCd != null && artikelGuiAVO.sperrCd.equals( "9" ) );
    ckbAltNrCd.setSelected( artikelGuiAVO.altNrCd != null && artikelGuiAVO.altNrCd.equals( "1" ) );
    ckbKzGratis.setSelected( artikelGuiAVO.kzGratis != null && artikelGuiAVO.kzGratis.equals( "1" ) );

    refreshDesignSpecificLayout( XxDomainFactory.PUBL_KAP_DES.equals( PublicationChapter.getCorrespondingDomainValue( artikelGuiAVO.artNr ) ), true );

    //Comboboxen
    if ( artikelGuiAVO.kondartCd != null && !artikelGuiAVO.kondartCd.equals( "" ) )
    {
      String bez = XxDomain.getBez( artikelGuiAVO.kondartCd, XxDomainFactory.KONDART_CD );
      if ( bez != null )
      {
        cbxKondartCd.setSelectedItem( new ComboBoxObject( artikelGuiAVO.kondartCd, bez ) );
      }
    }

    // Auffüllen von Feldern deren Werte als String gespeichert sind
    txfArtNr.setText( artikelGuiAVO.artNr == null ? "" : artikelGuiAVO.artNr );
    txfBezArt.setText( artikelGuiAVO.bezArt == null ? "" : artikelGuiAVO.bezArt );
    txfSuchbegrArt.setText( artikelGuiAVO.suchbegrArt == null ? "" : artikelGuiAVO.suchbegrArt );

    txfMinverkMenge.setText( artikelGuiAVO.minverkMenge == null ? "" : artikelGuiAVO.minverkMenge.toString() );
    txfOptBestMenge.setText( artikelGuiAVO.optBestMenge == null ? "" : artikelGuiAVO.optBestMenge.toString() );

    checkFolgeArtikel();
  }

  /**
   * ArtikelGuiAVO wird mit den geänderten Werten abgefüllt<br>
   * @return ArtikelGuiAVO mit aktuellen Werten
   */
  @Override
  public ArtikelGuiAVO getData()
  {
    //Artikelnummer nur wenn Status = "I"
    if ( artikelGuiAVO.status.equals( "I" ) )
    {
      artikelGuiAVO.artNr = txfArtNr.getText();
    }

    //Comboboxen
    artikelGuiAVO.kondartCd = getComboValue( cbxKondartCd ).equals( "" ) ? null : getComboValue( cbxKondartCd );

    //Checkboxen
    artikelGuiAVO.sperrCd = ckbSperrCd.isSelected() ? "9" : "0";
    artikelGuiAVO.altNrCd = ckbAltNrCd.isSelected() ? "1" : "0";
    artikelGuiAVO.kzGratis = ckbKzGratis.isSelected() ? "1" : "0";
    //design only
    if ( XxDomainFactory.PUBL_KAP_DES.equals( PublicationChapter.getCorrespondingDomainValue( artikelGuiAVO.artNr ) ) )
    {
      artikelGuiAVO.kzHistDesign = ckbKzHistDesign.isSelected() ? "1" : "0";
    }

    //Textfelder
    artikelGuiAVO.minverkMenge = txfMinverkMenge.getText().equals( "" ) ? null : new BigDecimal( txfMinverkMenge.getText() );
    artikelGuiAVO.optBestMenge = txfOptBestMenge.getText().equals( "" ) ? null : new BigDecimal( txfOptBestMenge.getText() );

    artikelGuiAVO.bezArt = txfBezArt.getText();
    artikelGuiAVO.suchbegrArt = txfSuchbegrArt.getText();
    return artikelGuiAVO;
  }

  /**
   * Teilt den Array des ComboBoxItems auf und gibt das erste Element zurück<br>
   * Dies entspricht entweder der domain_lnr oder der kbez der Tabelle xx_domain<br>
   * @param  cbxCombo JComboBox
   * @return erstes Element des ComboBoxItems
   */
  private String getComboValue( JComboBox cbxCombo )
  {
    ComboBoxObject cbo = (ComboBoxObject) cbxCombo.getSelectedItem();
    if ( cbo.key == null || cbo.key.equals( "" ) )
    {
      return "";
    }
    else
    {
      return cbo.key;
    }
  }

  /**
   * Überprüft Eingaben
   * @return  fehler == null --> keine Fehler Artikel kann gespeicher werden
   *          fehler.equals("") --> Fehler aufgetreten und angezeigt, Panel nicht wechseln
   *          anderenfalls den im fehler enthaltenen String anzeigen
   */
  @Override
  public String validForward()
  {
    if ( txfArtNr.getText().equals( "" ) )
      return "Artikel Nr muss eingegeben werden";
    if ( txfBezArt.getText().trim().equals( "" ) )
      return "Artikel Bezeichnung muss eingegeben werden";
    if ( txfSuchbegrArt.getText().trim().equals( "" ) )
      return "Suchbegriff muss eingegeben werden";
    if ( !txfBezArt.getInputVerifier().verify( txfBezArt ) )
      return "";//has an own pop up
    if ( !txfSuchbegrArt.getInputVerifier().verify( txfSuchbegrArt ) )
      return "";//has an own pop up
    return null;
  }

  @Override
  public String validBackward()
  {
    return null;
  }

  /**
   * Überprüft, ob Folgeartikel existieren<br>
   * falls Folgeartikel existieren wird die CheckBox altNrCd disabled
   */
  private void checkFolgeArtikel()
  {
    boolean folgeExists = false; // keine Folgeartikel vorhanden
    if ( artikelGuiAVO.altArtVO != null && artikelGuiAVO.altArtVO.length > 0 )
    {
      for ( int i = 0; i < artikelGuiAVO.altArtVO.length; i++ )
      {
        if ( !artikelGuiAVO.altArtVO[i].status.equals( "D" ) )
        {
          folgeExists = true;
        }
      }
    }
    ckbAltNrCd.setEnabled( !folgeExists );
  }

  private void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.pnlCenter, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.lblArtNr, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.lblBezArt, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.lblKondartCd, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.lblMinverkMenge, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.lblOptBestMenge, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.lblOptBestMenge, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.lblSuchbegrArt, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.txfArtNr, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.txfBezArt, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.txfMinverkMenge, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.txfOptBestMenge, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.txfSuchbegrArt, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.cbxKondartCd, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.ckbAltNrCd, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.ckbKzGratis, "artikelwizard.grunddaten" );
    HelpUtil.getInstance().enableHelp( this.ckbSperrCd, "artikelwizard.grunddaten" );
  }
}
