package ch.ige.art.client.form;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;
import javax.swing.table.TableColumn;

import org.apache.log4j.Logger;

import ch.ige.art.client.util.ComboBoxObject;
import ch.ige.art.client.util.TblArtikelWizard;
import ch.ige.art.client.util.TblNavToolBar;
import ch.ige.art.client.util.UserMessage;
import ch.ige.art.client.util.editoren.BtnEditor;
import ch.ige.art.client.util.renderer.BtnRenderer;
import ch.ige.art.client.util.renderer.ComboRenderer;
import ch.ige.art.client.util.verifier.TextVerifier;
import ch.ige.art.util.XxDomain;
import ch.ige.art.util.XxDomainFactory;
import ch.ige.art.vo.BformDruckVO;
import ch.ige.art.vo.XxDomainVO;
import ch.ige.arthelp.HelpUtil;
import ch.ige.authz.client.AuthMain;
import ch.ige.authz.client.AuthorizationProxy;
import ch.ige.authz.gui.AuthzJComboBox;
import ch.ige.authz.gui.GUIAuthorizer;
import ch.ige.main.client.PnlWizard;
import ch.ige.util.client.CharsetVerifier;
import ch.ige.util.client.LimitedDocument;

/**
 * <p>Überschrift: Formular-Grunddaten</p>
 * <p>Beschreibung: Panel mit Daten eines Formulars</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: PnlFormGrunddaten.java,v 1.30 2008/07/02 11:00:20 heinzer Exp $
 */

public class PnlFormGrunddaten extends PnlWizard
{
  private DtmFormTexte dtmFormTexte;

  private TblArtikelWizard tblTexte;

  private TblNavToolBar tblNavToolBar;

  private BformDruckVO bformDruckVO;

  private List<XxDomainVO> listDomain;

  // Logging
  private static final Logger LOG = Logger.getLogger( PnlFormGrunddaten.class );

  private UserMessage userMessage = new UserMessage();

  private JPanel pnlFormtxt = new JPanel();

  private JPanel pnlFormart = new JPanel();

  private JPanel pnlNav = new JPanel();

  private JScrollPane scpTexte = new JScrollPane();

  private BorderLayout borderLayout1 = new BorderLayout();

  private BorderLayout borderLayout3 = new BorderLayout();

  private BorderLayout lytBorderPnlFormart = new BorderLayout();

  private GridBagLayout gridBagLayout1 = new GridBagLayout();

  private JLabel lblDruckSystem = new JLabel();

  private JTextField txfFormartCd = new JTextField();

  private JLabel lblBez = new JLabel();

  private JLabel lblFormartCd = new JLabel();

  private JTextField txfBez = new JTextField();

  private JComboBox cbxTextartCd = new JComboBox();

  private JComboBox cbxSprache = new JComboBox();

  public JComboBox cbxDruckSystem = new AuthzJComboBox();

  private LimitedDocument ldoFormartCd = new LimitedDocument();

  private LimitedDocument ldoBez = new LimitedDocument();

  private AuthorizationProxy authzationProxy = AuthMain.getAuthzProxy();

  boolean editAllowed = authzationProxy.accessAllowed( "MutierenVoll", "Formular" ); //Artikel & Formular

  /**
   * holt Instanz von xxDomain um Werte aus xx_domain lesen zu können<br>
   * ruft jbInit() auf
   * @param bformDruckVO  ValueObject mit allen Daten eines Artikels
   */
  public PnlFormGrunddaten() //(BformDruckVO bformDruckVO)
  {
    try
    {
      jbInit();
      initHelp();
      GUIAuthorizer.authorizeFieldsIn( this );
    }
    catch ( Exception ex )
    {
      LOG.info( ex.getClass() + " " + ex.getMessage() );
      String message = userMessage.getUserMessage( ex );
      JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
    }
  }

  void jbInit() throws Exception
  {
    dtmFormTexte = new DtmFormTexte();
    tblTexte = new TblArtikelWizard( dtmFormTexte );
    tblNavToolBar = new TblNavToolBar( tblTexte );

    this.setLayout( borderLayout1 );
    this.setMinimumSize( new Dimension( 300, 200 ) );
    this.setPreferredSize( new Dimension( 550, 450 ) );

    pnlFormtxt.setPreferredSize( new Dimension( 300, 150 ) );
    pnlFormtxt.setLayout( gridBagLayout1 );

    lblFormartCd.setText( "Formular:" );
    lblFormartCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblFormartCd.setToolTipText( "formart_cd" );
    lblBez.setText( "Formular-Bezeichnung:" );
    lblBez.setHorizontalAlignment( SwingConstants.RIGHT );
    lblBez.setToolTipText( "bez" );
    lblDruckSystem.setText( "Drucksystem:" );
    lblDruckSystem.setHorizontalAlignment( SwingConstants.RIGHT );
    lblDruckSystem.setToolTipText( "druck_system" );
    cbxDruckSystem.setBackground( SystemColor.controlLtHighlight );
    cbxDruckSystem.setMaximumSize( new Dimension( 300, 20 ) );
    cbxDruckSystem.setMinimumSize( new Dimension( 300, 20 ) );
    cbxDruckSystem.setPreferredSize( new Dimension( 300, 20 ) );
    cbxSprache.setBackground( SystemColor.controlLtHighlight );
    cbxTextartCd.setBackground( SystemColor.controlLtHighlight );
    txfFormartCd.setMaximumSize( new Dimension( 80, 20 ) );
    txfFormartCd.setMinimumSize( new Dimension( 80, 20 ) );
    txfFormartCd.setPreferredSize( new Dimension( 80, 20 ) );
    txfFormartCd.setDocument( ldoFormartCd );
    txfFormartCd.setEditable( editAllowed );
    this.addCharsetVerifier( txfFormartCd );
    txfBez.setDocument( ldoBez );
    txfBez.setEnabled( editAllowed );
    txfBez.setMaximumSize( new Dimension( 300, 20 ) );
    txfBez.setMinimumSize( new Dimension( 300, 20 ) );
    txfBez.setPreferredSize( new Dimension( 300, 20 ) );
    this.addCharsetVerifier( txfBez );
    tblNavToolBar.setEnabled( false );
    tblNavToolBar.setBorderPainted( false );

    pnlNav.setPreferredSize( new Dimension( 237, 40 ) );
    pnlNav.setLayout( borderLayout3 );
    pnlFormart.setLayout( lytBorderPnlFormart );

    pnlFormart.setBorder( new TitledBorder( "Formulartexte" ) );
    pnlFormart.add( scpTexte, BorderLayout.CENTER );
    pnlFormart.add( pnlNav, BorderLayout.NORTH );
    pnlFormtxt.add( lblFormartCd, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE,
        new Insets( 37, 15, 6, 0 ), 87, 0 ) );
    pnlFormtxt.add( txfFormartCd, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 37, 10, 4, 0 ),
        0, 0 ) );
    pnlFormtxt.add( lblBez, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 15, 0, 0 ), 12, 0 ) );
    pnlFormtxt.add( txfBez, new GridBagConstraints( 1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 4, 10, 4, 0 ), 0, 0 ) );
    pnlFormtxt.add( lblDruckSystem, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 6, 15, 0,
        0 ), 65, 0 ) );
    pnlFormtxt.add( cbxDruckSystem, new GridBagConstraints( 1, 2, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 4, 10, 0,
        0 ), 0, 0 ) );

    pnlNav.add( tblNavToolBar, BorderLayout.EAST );
    scpTexte.getViewport().add( tblTexte, null );

    add( pnlFormart, BorderLayout.CENTER );
    add( pnlFormtxt, BorderLayout.NORTH );

    // Validierungen via Documents
    ldoFormartCd.setMaxLength( 3 );
    ldoFormartCd.setUpperCase( true );
    ldoBez.setMaxLength( 40 );

    //Combobox druck_system
    listDomain = XxDomain.getDomains( XxDomainFactory.DRUCK_SYSTEM );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxDruckSystem.addItem( new ComboBoxObject( xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }

    // Combobox textart_cd
    cbxTextartCd.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.TEXTART );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxTextartCd.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }

    // Combobox sprache
    listDomain = XxDomain.getDomains( XxDomainFactory.SPRACHE );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxSprache.addItem( new ComboBoxObject( xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }

    // Eigenschaften der Tabelle & Spalten setzen
    TableColumn textartColumn = tblTexte.getColumnModel().getColumn( 0 );
    TableColumn spracheColumn = tblTexte.getColumnModel().getColumn( 1 );
    TableColumn statusColumn = tblTexte.getColumnModel().getColumn( 3 );
    TableColumn versionColumn = tblTexte.getColumnModel().getColumn( 4 );
    TableColumn buttonColumn = tblTexte.getColumnModel().getColumn( 5 );

    tblTexte.removeColumn( statusColumn );
    tblTexte.removeColumn( versionColumn );

    tblTexte.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
    tblTexte.setCellSelectionEnabled( true );
    tblTexte.setRowHeight( 20 );

    textartColumn.setCellEditor( new DefaultCellEditor( cbxTextartCd ) );

    spracheColumn.setPreferredWidth( 100 );
    spracheColumn.setMaxWidth( 100 );
    spracheColumn.setCellEditor( new DefaultCellEditor( cbxSprache ) );

    buttonColumn.setMaxWidth( 20 );
    buttonColumn.setMinWidth( 20 );
    buttonColumn.setCellRenderer( new BtnRenderer() );
    buttonColumn.setCellEditor( new BtnEditor( new JCheckBox() ) );

    // Table Listener
    tblTexte.addMouseListener( new java.awt.event.MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        tblNavToolBar.enableButtons();
      }
    } );

    tblTexte.addKeyListener( new java.awt.event.KeyAdapter()
    {
      public void keyReleased( KeyEvent e )
      {
        tblNavToolBar.enableButtons();
      }
    } );

    // Buttons der Toolbar enablen und disablen
    tblNavToolBar.enableButtons();
  }

  /**
   * Adds a {@link CharsetVerifier} to the given Component. Shows a message dialog if one or more 
   * chars are not from the ISO-8859-15 encoding and higlights the wrong chars.
   * @param component the component which is checked
   */
  protected void addCharsetVerifier( JComponent component )
  {
    CharsetVerifier cv = new CharsetVerifier();
    cv.showMessageDialog( true );
    cv.enableHighlighting( true );
    component.setInputVerifier( cv );
  }

  /**
   * Füllt Controls mit den Werten des bformDruckVO
   * Setzt den Index der Comboboxen auf die Werte des bformDruckVO<br>
   */
  public void setData( BformDruckVO bformDruckVO )
  {
    this.bformDruckVO = bformDruckVO;

    //Disablen der formarcd wenn am Updaten
    txfFormartCd.setEnabled( bformDruckVO.bformartVO.status.equals( "U" ) ? false : true );

    // Auffüllen von Feldern deren Werte als String gespeichert sind
    txfFormartCd.setText( bformDruckVO.bformartVO.formartCd == null ? "" : bformDruckVO.bformartVO.formartCd );
    txfBez.setText( bformDruckVO.bformartVO.bez == null ? "" : bformDruckVO.bformartVO.bez );

    //Combobox
    if ( bformDruckVO.bformartVO.druckSystem != null && !bformDruckVO.bformartVO.druckSystem.equals( "" ) )
    {
      cbxDruckSystem.setSelectedItem( new ComboBoxObject( bformDruckVO.bformartVO.druckSystem, XxDomain.getBez( bformDruckVO.bformartVO.druckSystem,
          XxDomainFactory.DRUCK_SYSTEM ) ) );
    }

    // wenn neuer Datensatz, ist Drucksystem Crescendo nicht möglich
    if ( bformDruckVO.bformartVO.status.equals( "I" ) )
    {
      cbxDruckSystem.removeItem( new ComboBoxObject( "CRESC", XxDomain.getBez( "CRESC", XxDomainFactory.DRUCK_SYSTEM ) ) );
    }

    // TableModel auffüllen
    dtmFormTexte.setData( bformDruckVO.bformtxtDruckVO );
    tblNavToolBar.enableButtons();
  }

  /**
   * Abfüllen der ComboBox Selektionen und der Textwerte in das bformDruckVO<br>
   * @return BformDruckVO mit den neuen Werten
   */
  public BformDruckVO getData()
  {
    //Formart Code nur wenn Status = "I"
    if ( bformDruckVO.bformartVO.status.equals( "I" ) )
    {
      bformDruckVO.bformartVO.formartCd = txfFormartCd.getText();
    }

    //Comboboxen
    ComboBoxObject cbo = (ComboBoxObject) cbxDruckSystem.getSelectedItem();
    bformDruckVO.bformartVO.druckSystem = ( cbo.key == null ? "" : cbo.key );
    bformDruckVO.bformartVO.bez = txfBez.getText();

    bformDruckVO.bformtxtDruckVO = dtmFormTexte.getData();
    return bformDruckVO;
  }

  /**
   * Überprüft ob Eingaben in Ordnung sind
   * @return - null Erfassung korrekt<br>
   *         - String mit Fehlermeldung zum Anzeigen
   *         - "" wenn Fehler aufgetreten und Message schon angezeigt
   */
  public String valid()
  {
    DefaultCellEditor editor = (DefaultCellEditor) tblTexte.getCellEditor();

    // Werte im Editiermodus werden übernommen
    if ( editor != null )
    {
      if ( !editor.stopCellEditing() )
      {
        return "";
      }
    }

    // Überprüfung ob Muss-Felder gefüllt sind
    if ( txfFormartCd.getText().equals( "" ) )
      return "Formular muss eingegeben werden";
    if ( txfBez.getText().equals( "" ) )
      return "Formular Bezeichnung muss eingegeben werden";
    if ( !txfFormartCd.getInputVerifier().verify( txfFormartCd ) )
      return "";//has an own pop up
    if ( !txfBez.getInputVerifier().verify( txfBez ) )
      return "";//has an own pop up

    // Text auf Länge, Platzhalter, Escape-Sequenzen und Textarten überprüfen
    TextVerifier textVerifier = new TextVerifier();
    Vector data = dtmFormTexte.getDataVector();
    Vector textarten = new Vector();
    Vector sprache = new Vector();
    ArrayList spracheTextart = new ArrayList();
    String[] lang = { "D", "F", "I", "E" };

    for ( int i = 0; i < data.size(); i++ )
    {
      int pos = 0;
      Vector row = (Vector) data.get( i );

      ComboBoxObject cboTx = (ComboBoxObject) row.get( 0 );
      ComboBoxObject cboSp = (ComboBoxObject) row.get( 1 );
      textarten.add( cboTx.key ); // Textart
      sprache.add( cboSp.key ); // Sprache
      spracheTextart.add( cboSp.key + cboTx.key ); //Sprache + Textart z.B. "D1"

      // Text der Textart 0 darf nicht mehr als 40 Zeichen enthalten
      if ( cboTx.key.equals( "0" ) && row.get( 2 ).toString().length() > 40 )
      {
        return "Text der Textart 0 darf nicht mehr als 40 Zeichen enthalten";
      }

      try
      {
        pos = textVerifier.verifyPlatzhalter( row.get( 2 ).toString() );
        if ( pos != -1 )
        {
          return "Ungültiger Platzhalter Zeile: " + ( i + 1 ) + " Spalte: Text Position: " + ( pos + 1 )
              + "\nEs sind nur die in den Leitlinien definierten Platzhalter erlaubt";
        }

        pos = textVerifier.verifyEscapeSequenzen( row.get( 2 ).toString() );
        if ( pos != -1 )
        {
          return "Ungültiges Zeichen Zeile: " + ( i + 1 ) + " Spalte: Text Position: " + ( pos + 1 ) + "\nFolgende Zeichen sind im Text nicht erlaubt:"
              + "\n  Zeilenumbruch(Enter), Tabulator," + "\n  Carriage Return, Rückschritt," + "\n  Zeilenvorschub";
        }
      }
      catch ( Exception ex )
      {
        return "Domainwerte können nicht geladen werden";
      }
    }
    //sind weniger als 2 Formulartexte erfasst, kann es nicht gültig sein
    if ( spracheTextart.size() < 2 )
    {
      return "Textart 1 sowie Textart 3 oder 4 müssen zwingend \n" + "in mindestens einer Sprache erfasst werden";
    }
    // für alle Sprachen
    for ( int i = 0; i < lang.length; i++ )
    {
      //ein Eintrag der Sprache vorhanden ?
      if ( sprache.contains( lang[i] ) )
      {
        // Textart 1 AND 3 OR 4 muss vorhanden seinn
        if ( !( spracheTextart.contains( lang[i] + "1" ) && ( spracheTextart.contains( lang[i] + "3" ) || spracheTextart.contains( lang[i] + "4" ) ) ) )
        {
          return "Textart 1 sowie Textart 3 oder 4 müssen \n" + "in der gleichen Sprache erfasst werden";
        }
      }
    }
    return null; // Erfassung korrekt
  }

  //********** Authorization ***************************************************

  public static String[] getAuthzSpecifications()
  {
    return new String[] { "*DruckSystem    = MutierenVoll/Formular" };
  }

  private void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this, "formularwizard" );
    HelpUtil.getInstance().enableHelp( this.pnlFormart, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.pnlFormtxt, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.pnlNav, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.lblBez, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.lblDruckSystem, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.lblFormartCd, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.txfBez, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.txfFormartCd, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.cbxDruckSystem, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.cbxSprache, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.cbxTextartCd, "formularwizard.formulardaten" );
    HelpUtil.getInstance().enableHelp( this.tblTexte, "formularwizard.formulardaten" );
  }

}
