package ch.ige.art.vo;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Überschrift:   ArtikelVO
 * Beschreibung:  Value Object der Tabelle artikel
 * Copyright:     Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * Organisation:  IGE
 * @author:       Stefan Nydegger
 * @version $Id: ArtikelVO.java,v 1.10 2008/07/02 07:19:10 heinzer Exp $
 */
public class ArtikelVO implements Serializable
{
  public String artNr = null;

  public String altNrCd = "0"; //alt_nr_cd

  public String artgrpCd = null; //artgrp_cd

  public String bonusCd = "1"; //bonus_cd

  public String kondartCd = null; //kondart_cd

  public String kzGratis = "0"; //kz_gratis

  public String kzHistDesign = null; //kz_hist_design

  public String kzMetnot = null; //kz_metnot

  public String lageinh = "ANZ"; //lageinh

  public BigDecimal minverkMenge = new BigDecimal( 1 ); //minverk_menge

  public BigDecimal optBestMenge = new BigDecimal( 1 ); //opt_best_menge

  public String provCd = "1"; // prov_cd

  public String sperrCd = "0"; //sperr_cd

  public String statcd1 = null; //statcd_1

  public String statcd2 = null; //statcd_2

  public String statcd3 = null; //statcd_3

  public String suchbegrArt = null; //suchbegr_art

  public String erstBen = null;

  public Date erstDat = null;

  public String geaendBen = null; //geaend_ben

  public Date geaendDat = null; //geaend_dat

  public String uVersion = "!"; //u_version

  public String status = "";

  // werden im Programm nicht angesprochen default überprüfen
  // alle sind nullable default = null
  public String abcCd = null;

  public Integer abcRangnr = null;

  public String artCd = "0";

  public String artgrp1 = null;

  public String artgrp2 = null;

  public String artgrp3 = null;

  public String artgrp4 = null;

  public String beschaffart = "0";

  public Date datDschnEp = null;

  public Date datStandpreis = null;

  public BigDecimal dschnEpSfr = null;

  public String eanCd = null;

  public String etikettenCd = "0";

  public String ekeinh = null;

  public String fakteinh = null;

  public BigDecimal gewicht = null;

  public BigDecimal gewichtNetto = null;

  public BigDecimal invpreis = null;

  public String kennzAuslArt = "0";

  public String kennzCharge = "0";

  public String kennzLagFueh = "0";

  public String kennzSerieNr = "0";

  public String kzFerart = "0";

  public String kzMinverk = "0";

  public String kzNettoArt = "0";

  public String kzSktoBer = "1";

  public BigDecimal lagkost = null;

  public String landCd = null;

  public BigDecimal letzEpFw = null;

  public BigDecimal letzEpSfr = null;

  public BigDecimal loskosten = null;

  public Integer margeMin = null;

  public Integer margeSoll = null;

  public String markenCd = null;

  public String preisgruppe = null;

  public String provgrpCd = null;

  public String sachbCd = "BAGIS";

  public String sammelartCd = "0";

  public Integer spesensatz = null;

  public BigDecimal standpreis = new BigDecimal( 0 );

  public String steuZeilCd = "G1";

  public String stueliCd = "0";

  public Integer umrFaktEk = null;

  public Integer umrFaktVk = null;

  public String waehrCd = null;

  public Integer wbeschZeit = null;

  public String zolltarif = null;

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  artNr           = <" + this.artNr + ">\n" );
    buf.append( "  abcCd           = <" + this.abcCd + ">\n" );
    buf.append( "  abcRangnr       = <" + this.abcRangnr + ">\n" );
    buf.append( "  altNrCd         = <" + this.altNrCd + ">\n" );
    buf.append( "  artCd           = <" + this.artCd + ">\n" );
    buf.append( "  artgrp1         = <" + this.artgrp1 + ">\n" );
    buf.append( "  artgrp2         = <" + this.artgrp2 + ">\n" );
    buf.append( "  artgrp3         = <" + this.artgrp3 + ">\n" );
    buf.append( "  artgrp4         = <" + this.artgrp4 + ">\n" );
    buf.append( "  artgrpCd        = <" + this.artgrpCd + ">\n" );
    buf.append( "  beschaffart     = <" + this.beschaffart + ">\n" );
    buf.append( "  bonusCd         = <" + this.bonusCd + ">\n" );
    buf.append( "  datDschnEp      = <" + this.datDschnEp + ">\n" );
    buf.append( "  datStandpreis   = <" + this.datStandpreis + ">\n" );
    buf.append( "  dschnEpSfr      = <" + this.dschnEpSfr + ">\n" );
    buf.append( "  eanCd           = <" + this.eanCd + ">\n" );
    buf.append( "  etikettenCd     = <" + this.etikettenCd + ">\n" );
    buf.append( "  ekeinh          = <" + this.ekeinh + ">\n" );
    buf.append( "  fakteinh        = <" + this.fakteinh + ">\n" );
    buf.append( "  gewicht         = <" + this.gewicht + ">\n" );
    buf.append( "  gewichtNetto    = <" + this.gewichtNetto + ">\n" );
    buf.append( "  invpreis        = <" + this.invpreis + ">\n" );
    buf.append( "  kennzAuslArt    = <" + this.kennzAuslArt + ">\n" );
    buf.append( "  kennzCharge     = <" + this.kennzCharge + ">\n" );
    buf.append( "  kennzLagFueh    = <" + this.kennzLagFueh + ">\n" );
    buf.append( "  kennzSerieNr    = <" + this.kennzSerieNr + ">\n" );
    buf.append( "  kondartCd       = <" + this.kondartCd + ">\n" );
    buf.append( "  kzFerart        = <" + this.kzFerart + ">\n" );
    buf.append( "  kzGratis        = <" + this.kzGratis + ">\n" );
    buf.append( "  kzHistDesign    = <" + this.kzHistDesign + ">\n" );
    buf.append( "  kzMetnot        = <" + this.kzMetnot + ">\n" );
    buf.append( "  kzMinverk       = <" + this.kzMinverk + ">\n" );
    buf.append( "  kzNettoArt      = <" + this.kzNettoArt + ">\n" );
    buf.append( "  kzSktoBer       = <" + this.kzSktoBer + ">\n" );
    buf.append( "  lageinh         = <" + this.lageinh + ">\n" );
    buf.append( "  lagkost         = <" + this.lagkost + ">\n" );
    buf.append( "  landCd          = <" + this.landCd + ">\n" );
    buf.append( "  letzEpFw        = <" + this.letzEpFw + ">\n" );
    buf.append( "  letzEpSfr       = <" + this.letzEpSfr + ">\n" );
    buf.append( "  loskosten       = <" + this.loskosten + ">\n" );
    buf.append( "  margeMin        = <" + this.margeMin + ">\n" );
    buf.append( "  margeSoll       = <" + this.margeSoll + ">\n" );
    buf.append( "  markenCd        = <" + this.markenCd + ">\n" );
    buf.append( "  minverkMenge    = <" + this.minverkMenge + ">\n" );
    buf.append( "  optBestMenge    = <" + this.optBestMenge + ">\n" );
    buf.append( "  preisgruppe     = <" + this.preisgruppe + ">\n" );
    buf.append( "  provCd          = <" + this.provCd + ">\n" );
    buf.append( "  provgrpCd       = <" + this.provgrpCd + ">\n" );
    buf.append( "  sachbCd         = <" + this.sachbCd + ">\n" );
    buf.append( "  sammelartCd     = <" + this.sammelartCd + ">\n" );
    buf.append( "  sperrCd         = <" + this.sperrCd + ">\n" );
    buf.append( "  spesensatz      = <" + this.spesensatz + ">\n" );
    buf.append( "  standpreis      = <" + this.standpreis + ">\n" );
    buf.append( "  statcd1         = <" + this.statcd1 + ">\n" );
    buf.append( "  statcd2         = <" + this.statcd2 + ">\n" );
    buf.append( "  statcd3         = <" + this.statcd3 + ">\n" );
    buf.append( "  steuZeilCd      = <" + this.steuZeilCd + ">\n" );
    buf.append( "  stueliCd        = <" + this.stueliCd + ">\n" );
    buf.append( "  suchbegrArt     = <" + this.suchbegrArt + ">\n" );
    buf.append( "  umrFaktEk       = <" + this.umrFaktEk + ">\n" );
    buf.append( "  umrFaktVk       = <" + this.umrFaktVk + ">\n" );
    buf.append( "  waehrCd         = <" + this.waehrCd + ">\n" );
    buf.append( "  wbeschZeit      = <" + this.wbeschZeit + ">\n" );
    buf.append( "  zolltarif       = <" + this.zolltarif + ">\n" );
    buf.append( "  erstBen         = <" + this.erstBen + ">\n" );
    buf.append( "  erstDat         = <" + this.erstDat + ">\n" );
    buf.append( "  geaendBen       = <" + this.geaendBen + ">\n" );
    buf.append( "  geaendDat       = <" + this.geaendDat + ">\n" );
    buf.append( "  uVersion        = <" + this.uVersion + ">\n" );
    buf.append( "  status          = <" + this.status + ">\n" );

    return buf.toString();
  }
}
