package ch.ige.art.xml.test;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

import ch.ige.art.server.dao.ArtikelSucheDAO;
import ch.ige.art.util.XxDomain;
import ch.ige.art.vo.ArtikelAVO;
import ch.ige.art.vo.ArtikelGuiAVO;
import ch.ige.art.vo.ArtikelSelKritVO;
import ch.ige.art.vo.test.Testdata;
import ch.ige.art.xml.ArtStammblatt;
import ch.ige.util.server.DBHelper;

/**
 * Beschreibung: Junit-Test der Klasse ArtStammblatt
 * Copyright (c) 2005, Institut für Geistiges Eigentum
 * @author A. Rüegsegger
 * @version $Id: ArtStammblattTest.java,v 1.16 2008/07/03 09:51:15 heinzer Exp $
 */

public class ArtStammblattTest extends TestCase
{
  /**
   * The log
   */
  private static final Logger LOG = Logger.getLogger( ArtStammblattTest.class );

  static
  {
    // init log4j
    BasicConfigurator.configure();

    // init print client
    System.setProperty( "jippsclient.port", "5000" );

    // user name
    System.setProperty( "user.name", "ruegsegger" );

    //init singleton
    try
    {
      XxDomain.init();
    }
    catch ( Exception e )
    {
      LOG.error( "Error: could not initialize XxDomain " + e.getMessage(), e );
    }

  }

  public ArtStammblattTest( String s )
  {
    super( s );
  }

  public void test01Print()
  {
    System.out.println( "Test PRINT" );
    ArtStammblatt artStammblatt;

    List listArtikel = new ArrayList();
    ArtikelGuiAVO artikelGuiAVO = Testdata.createArtikelGuiAVO();

    try
    {
      artStammblatt = new ArtStammblatt();

      listArtikel.add( artikelGuiAVO );
      String xml = artStammblatt.getXMLString( listArtikel );

      if ( xml == null || xml.equals( "" ) )
      {
        fail( "Kein Inhalt" );
      }

      assertTrue( xml.length() > 0 );
      System.out.println( xml );

      artStammblatt.saveToUTF8File( xml, new File( "c:\\temp\\artikel.xml" ) );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }

  public void printAllText()
  {
    System.out.println( "Test PRINT" );
    DBHelper.setRunOnServer( false );

    ArtStammblatt artStammblatt;
    ArtikelAVO vo;
    ArtikelSelKritVO selKritVO = new ArtikelSelKritVO();
    ArtikelSucheDAO artikelDAO = new ArtikelSucheDAO();
    List listArtikel = new ArrayList();

    selKritVO.bezArt = "%";

    try
    {
      artStammblatt = new ArtStammblatt();

      List list = artikelDAO.select( selKritVO );
      for ( int i = 0; i < list.size(); i++ )
      {
        vo = (ArtikelAVO) list.get( i );
        listArtikel.add( vo.artNr );
      }

      artStammblatt.print( listArtikel );
      this.assertTrue( true );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.toString() );
    }
  }
}
