package ch.ige.epband.server.dao.test;

import ch.ige.epband.server.dao.PatDAO;
import ch.ige.epband.server.dao.SchutitDAO;
import ch.ige.epband.vo.PatVO;
import ch.ige.epband.vo.SchutitVO;
import ch.ige.epband.vo.test.Testdata;

/**
 * Junit-Test der Klasse PatDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: PatDAOTest.java,v 1.7 2008/05/22 15:54:32 ruegsegger Exp $
 */
public class PatDAOTest extends DAOTestCase
{
  private PatDAO patDAO = new PatDAO();

  private PatVO patVO = null;

  private SchutitDAO schutitDAO = new SchutitDAO();

  private SchutitVO schutitVO;

  public PatDAOTest( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      schutitDAO.insert( schutitVO );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  @Override
  protected void tearDown()
  {
    try
    {
      schutitDAO.deleteSchutit( schutitVO.schutitKey );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  public void test00Insert()
  {
    try
    {
      patVO = Testdata.createPat();
      int result = patDAO.insert( patVO );
      assertEquals( 1, result );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }
}
