package ch.ige.epband.util.test;

import junit.framework.TestCase;

import org.apache.commons.lang.StringEscapeUtils;

/**
 * <p>Beschreibung: Testklasse für das Ersetzen von HTML-Sonderzeichen. 
 * Bisher war das mit der Klasse EntityRef gelöst, neu mach wird es über die 
 * Commons-Lang Methode escapeXml gelöst.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author A.Rueegsegger
 * @version $id: $
 */
public class EntityRefTest extends TestCase
{

  /**
   * Default Konstruktor
   * @param s
   */
  public EntityRefTest( String s )
  {
    super( s );
  }

  /**
   * Sonderzeichen ersetzen mit HTML-Code
   */
  public void testReplaceEntity()
  {
    String str1 = " < und > und & ";
    String stringRet = StringEscapeUtils.escapeXml( str1 );
    assertEquals( " &lt; und &gt; und &amp; ", stringRet );
  }
}
