package ch.ige.epband.vo;

import java.io.Serializable;

/**
 * <p>Überschrift:  EreigTxtVO</p>
 * <p>Beschreibung: EreigTxtVO ist das VO der Tabelle ereig_txt</p>
 * <p>Copyright:    Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: IGE</p>
 * @author          M. Trachsel
 * @version         $Id: EreigTxtVO.java,v 1.9 2008/05/22 15:53:18 ruegsegger Exp $
 */

public class EreigTxtVO implements Serializable
{
  /**
   * Defaultwert für die serialVersionUID
   */
  private static final long serialVersionUID = 1L;

  public int schutitKey = 0;

  public int ereigIdat = 0;

  public int ereigTxtCd = 0;

  public String ereigTxt = null;

  public int version = 0;

  /**
   * Gibt den Inhalt des ValueObject EreigTxtVO zurück
   * @return Inhalt von EreigTxtVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  ereigIdat        = <" + this.ereigIdat + ">\n" );
    buf.append( "  ereigTxtCd       = <" + this.ereigTxtCd + ">\n" );
    buf.append( "  ereigTxt         = <" + this.ereigTxt + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );

    return buf.toString();
  }
}
