package ch.ige.epband.vo;

/**
 *
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: IpcrClassificationVO.java,v 1.5 2006/12/05 17:20:01 wild Exp $
 */
public class IpcrClassificationVO
{

  public String section;
  public String ipcclass;
  public String subclass;
  public String maingroup;
  public String subgroup;
  public String ipcVersionIndicator;
  public String classificationLevel;
  public String symbolPosition;
  public String classificationValue;
  public String actionDate;
  public String classificationStatus;
  public String classificationDataSource;
  public String generatingOffice;

  public IpcrClassificationVO()
  {
  }


  /**
   * new IPC as one fixed length field of 50 positions (WIPO ST.8)
   * @param text String
   * @throws Exception
   */
  public IpcrClassificationVO( String text ) throws Exception
  {
    if( text.length() == 50 )
    {
      this.section = text.substring( 0, 1 ).trim();
      this.ipcclass = text.substring( 1, 3 ).trim();
      this.subclass = text.substring( 3, 4 ).trim();
      this.maingroup = text.substring( 4, 8 ).trim();
      this.subgroup = text.substring( 9, 15 ).trim();
      this.ipcVersionIndicator = text.substring( 19, 27 ).trim();
      this.classificationLevel = text.substring( 27, 28 ).trim();
      this.symbolPosition = text.substring( 28, 29 ).trim();
      this.classificationValue = text.substring( 29, 30 ).trim();
      this.actionDate = text.substring( 30, 38 ).trim();
      this.classificationStatus = text.substring( 38, 39 ).trim();
      this.classificationDataSource = text.substring( 39, 40 ).trim();
      this.generatingOffice = text.substring( 40, 42 ).trim();
    }
    else
    {
      throw new Exception( "field text doesn't consist of 50 positions" );
    }
  }
}
