package ch.ige.epband.vo;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>Überschrift:  SchutitEmpfadr</p>
 * <p>Beschreibung: SchutitEmpfadr ist das VO der Tabelle schutit_empfadr</p>
 * <p>Copyright:    Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: IGE</p>
 * @author          M. Trachsel
 * @version         $Id: SchutitEmpfadrVO.java,v 1.13 2008/05/22 15:53:17 ruegsegger Exp $
 */

public class SchutitEmpfadrVO implements Serializable
{
  /**
   *  Defaultwert für die serialVersionUID
   */
  private static final long serialVersionUID = 1L;

  public int schutitKey = 0;

  public int adrNr = 0;

  public int empfTyp = 0;

  public Integer erfassMa = new Integer( EpbandVO.MA_NR );

  public Date erfassDat = null;

  /**
   * Gibt den Inhalt des ValueObject SchutitEmpfadrVO zurück
   * @return Inhalt von SchutitEmpfadrVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  adrNr            = <" + this.adrNr + ">\n" );
    buf.append( "  empfTyp          = <" + this.empfTyp + ">\n" );
    buf.append( "  erfassMa         = <" + this.erfassMa + ">\n" );
    buf.append( "  erfassDat        = <" + this.erfassDat + ">\n" );

    return buf.toString();
  }
}
