package ch.ige.epband.vo;

import java.io.Serializable;

/**
 * <p>Überschrift:  SchutitRegadr</p>
 * <p>Beschreibung: Schutitregadr ist das VO der Tabelle schutit_regadr</p>
 * <p>Copyright:    Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: IGE</p>
 * @author          M. Trachsel
 * @version         $Id: SchutitRegadrVO.java,v 1.10 2008/05/22 15:53:18 ruegsegger Exp $
 */

public class SchutitRegadrVO implements Serializable
{
  /**
   *  Defaultwert für die serialVersionUID
   */
  private static final long serialVersionUID = 1L;

  public static final int INHABER = 1; // Inhaber/Hinterleger(alle Schutztitel: pro

  // Schutztitel sind mehrere möglich)
  public static final int HAUPTINHABER = 2; // Hauptinhaber/Hinterl.(alle Schutztiteln:

  // pro Schutztitel ist nur einer möglich
  public static final int VERTRETER = 3; // Vertreter(alle Schutztitel: pro Schutztitel

  // ist nur einer möglich,Ausnahme: bei Marken sind
  // mehrere möglich)
  public static final int ERFINDER = 4; // Erfinder(Patente: pro Schutztitel sind mehrere

  // möglich)
  public static final int URHEBER = 5; // Urheber(Muster & Modellel: pro Schutztitel

  // sind mehrere möglich)
  public static final int LIZENZNEHMER = 6; // Lizenznehmer alle Schutztitel

  // pro Schutztitel mehrere möglich

  public int schutitKey = 0;

  public int schutadrLnr = 0;

  public int regadrNr = 0;

  public int schutitTyp = 0;

  public int adrRolleCd = 0;

  public int vonEreigIdat = 0;

  public int regStat = 0;

  /**
   * Gibt den Inhalt des ValueObject SchutitRegadrVO zurück
   * @return Inhalt von SchutitRegadrVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  schutadrLnr      = <" + this.schutadrLnr + ">\n" );
    buf.append( "  regadrNr         = <" + this.regadrNr + ">\n" );
    buf.append( "  schutitTyp       = <" + this.schutitTyp + ">\n" );
    buf.append( "  adrRolleCd       = <" + this.adrRolleCd + ">\n" );
    buf.append( "  vonEreigIdat     = <" + this.vonEreigIdat + ">\n" );
    buf.append( "  regStat          = <" + this.regStat + ">\n" );

    return buf.toString();
  }
}
