package ch.ige.imagehandler.batch;

import java.util.Collection;

/**
 * Description of a batch job.
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   Michael Locher
 * @version  $Id: JobDescription.java,v 1.1 2008/06/24 14:12:54 locher Exp $
 */
public class JobDescription
{
  private final ImageSource source;

  private final Consumer consumer;

  private final Collection<String> requestedConversions;

  public JobDescription( Collection<String> requestedConversions, ImageSource source, Consumer consumer )
  {
    super();
    this.source = source;
    this.consumer = consumer;
    this.requestedConversions = requestedConversions;
  }

  /**
   * Gets the source.
   * @return the source
   */
  protected ImageSource getSource()
  {
    return this.source;
  }

  /**
   * Gets the consumer.
   * @return the consumer
   */
  protected Consumer getConsumer()
  {
    return this.consumer;
  }

  /**
   * Gets the requestedConversions.
   * @return the requestedConversions
   */
  protected Collection<String> getRequestedConversions()
  {
    return this.requestedConversions;
  }

}
