package ch.ige.imagehandler.rule;

import ch.ige.image.Image;

/**
 * A Rule for Checking Images.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * @author    Michael Locher
 * @version   $Id: Checker.java,v 1.7 2009/04/14 11:38:03 locher Exp $
 */
public interface Checker<I extends Image> extends Rule<I>
{

  /**
   * Checks if the image conforms to this rule.
   * @param image the image to check
   * @throws RuleException if the image does not conform
   */
  public void checkImage( I image ) throws RuleException;

}
