package ch.ige.imagehandler.rule;

import ch.ige.image.Image;

/**
 * Always fail.
 * 
 * <p>
 * <em>Example</em>
 * <pre>
 *    &lt;rule class=&quot;ch.ige.imagehandler.rule.FailChecker&quot;/&gt;
 * </pre>
 * 
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * 
 * @author Michael Locher
 * @version $Id: FailChecker.java,v 1.5 2009/04/14 11:38:02 locher Exp $
 */
public class FailChecker<I extends Image> extends AbstractRule<I> implements Checker<I>
{

  /* @see ch.ige.imagehandler.rule.AbstractRule#getRuleName() */
  @Override
  protected String getRuleName()
  {
    return "Fail Checker";
  }

  // --------------------------------------------------------------------------------------------
  // Check

  /* @see ch.ige.imagehandler.rule.Checker#checkImage(ch.ige.image.Image) */
  public void checkImage( I image ) throws RuleException
  {
    this.logCheck();
    throw new RuleException( "fail" );
  }

}
