package ch.ige.imagehandler.rule;


/**
 * Rule Visitor.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * 
 * @see "GOF Visitor Pattern"
 * 
 * @author Michael Locher
 * @version $Id: RuleVisitor.java,v 1.4 2009/04/14 11:38:03 locher Exp $
 */
public interface RuleVisitor
{

  /**
   * Does the required work on the given rule.
   * 
   * @param rule
   *          the visited rule.
   */
  public void handleRule( Rule<?> rule ) throws RuleException;

}
