package ch.ige.imagehandler.rule.parameter;

import java.util.ArrayList;
import java.util.List;

/**
 * A "mulitvalued" parameter.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * 
 * @author Michael Locher
 * @version $Id: ListBinding.java,v 1.6 2009/03/19 13:26:23 locher Exp $
 */
public class ListBinding implements Parameter
{

  private String name;

  private List<String> values;

  public ListBinding()
  {
    this.values = new ArrayList<String>();
  }

  /*
   * @see ch.ige.imagehandler.rule.parameter.Parameter#getName()
   */
  public String getName()
  {
    return name;
  }

  /**
   * Sets the name of this parameter.
   * 
   * @param name the name
   */
  public void setName( String name )
  {
    this.name = name;
  }

  /**
   * Adds a value to this parameter.
   * 
   * @param value the value
   */
  public void addValue( String value )
  {
    this.values.add( value );
  }

  /**
   * Gives all values of this parameter.
   * 
   * @return the values
   */
  public List<String> getValues()
  {
    return values;
  }

  @Override
  public String toString()
  {
    return this.name + " = " + this.values;
  }

}
