package ch.ige.ipcloadscheme.server.dao.test;

import junit.framework.TestCase;
import ch.ige.ipcloadscheme.server.dao.*;
import ch.ige.ipcloadscheme.vo.*;
import junit.framework.*;
import ch.ige.ipcloadscheme.vo.test.*;

/**
 * Testklasse für IpcBildKlasseDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: IpcBildKlasseDAOTest.java,v 1.4 2007/01/11 18:11:57 ruegsegger Exp $
 */
public class IpcBildKlasseDAOTest extends DAOTestCase
{
  private IpcBildDAO ipcBildDAO = new IpcBildDAO();
  private IpcBildKlasseDAO ipcBildKlasseDAO = new IpcBildKlasseDAO();
  private IpcKlasseDAO ipcKlasseDAO = new IpcKlasseDAO();

  private IpcBildVO ipcBildVO;
  private IpcKlasseVO ipcKlasseVO;
  private IpcBildKlasseVO ipcBildKlasseVO;

  public IpcBildKlasseDAOTest( String s )
  {
    super( s );
  }

  public void setUp()
  {
    try
    {
      ipcKlasseVO = Testdata.getIpcKlasseVO();
      ipcBildVO = Testdata.getBildVO();

      ipcBildKlasseVO = new IpcBildKlasseVO();
      ipcBildKlasseVO.ipcKlasse = ipcKlasseVO.ipcKlasse;
      ipcBildKlasseVO.bildname = ipcBildVO.bildname;
    }
    catch ( Exception ex )
    {
      fail(ex.getMessage());
    }
  }


  public void test01Insert()
  {
    System.out.println( "Test INSERT " );

    try
    {
      ipcKlasseDAO.insert(ipcKlasseVO);
      ipcBildDAO.insert( ipcBildVO );

      int anz = ipcBildKlasseDAO.insert( ipcBildKlasseVO );
      this.assertEquals( 1, anz );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void test02Exists()
  {
    System.out.println( "Test EXIST " );

    try
    {
      boolean exists = ipcBildKlasseDAO.exists( ipcBildKlasseVO );
      assertTrue( exists );

      IpcBildKlasseVO vo = new IpcBildKlasseVO();
      vo.ipcKlasse = ipcBildKlasseVO.ipcKlasse;
      ipcBildKlasseVO.bildname = "XXX";

      exists = ipcBildKlasseDAO.exists( vo );
      assertTrue( !exists );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void test04Delete()
  {
    System.out.println( "Test DELETE " );

    try
    {
      int anz = ipcBildKlasseDAO.delete( ipcBildKlasseVO.bildname );
      assertEquals( 1, anz );

      ipcKlasseDAO.delete( ipcKlasseVO.ipcKlasse );
      ipcBildDAO.delete( ipcBildVO.bildname );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }
}

