package ch.ige.ipcloadvalidity.client.batch;

import java.net.URL;
import java.util.Properties;

import org.apache.log4j.Logger;

import ch.ige.ipcloadvalidity.util.ValidityProperties;


/**
 * Aufbereitung einer Nachricht zum Versenden via smtp
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version Id:
 */

public class MailMessage
{
  //
  // const
  //
  private static final Logger LOG = Logger.getLogger( MailMessage.class );

  public static final String CONFIG = "ipcloadvalidity.config";
  public static final String HOST   = "mail.smtp.host" ;
  public static final String TO     = "mail.send.to";
  public static final String CC     = "mail.send.cc";
  public static final String FROM   = "mail.send.from";

  //
  // fields
  //
  private String smptServer = null;

  private String to = null;
  private String cc = null;
  private String from = null;

  private String subject = null;
  private String body = null;
  private String attachment = null;


  public MailMessage( String subject ) throws Exception
  {
    this(subject, "", null);
  }


  public MailMessage(String subject, String body, String attachment)
  {
    this.subject = subject;
    this.body = body;
    this.attachment = attachment;
  }



  /**
   * MailMessage senden
   */
  public void send( ) throws Exception
  {
      MailSender.sendMail( smptServer, to, cc, from, subject, body, attachment );
  }


  /**
   * Gibt die System Properties zurück
   * @return String System Properties
   */
  private String getSystemProperties()
   {
     StringBuffer buf = new StringBuffer();
     String       key = null;
     String       val = null;

     String[] SYS_PROPERTIES= { CONFIG, HOST, TO, CC, FROM };

     for (int i = 0; i < SYS_PROPERTIES.length; i++)
     {
       key = SYS_PROPERTIES[i];
       val = ValidityProperties.getInstance().getProperty(key);
       buf.append("  " + key + " = " + val + "\n");
     }

     return buf.toString();
   }


   public String toString()
   {
     StringBuffer buf = new StringBuffer();

     buf.append("\n");
     buf.append( "  subject      = <" + this.subject + ">\n" );
     buf.append( "  body         = <" + this.body + ">\n" );
     buf.append( "  attachment   = <" + this.attachment + ">\n" );

     buf.append( getSystemProperties() );

     return buf.toString();
   }
}
