package ch.ige.ipcloadvalidity.client.batch.test;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ipcloadvalidity.client.batch.IpcLoadValidity;
import ch.ige.ipcloadvalidity.util.ValidityProperties;
import ch.ige.ipcloadvalidity.util.test.BasicTestCase;
import ch.ige.util.client.batch.BatchReportMail;

/**
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * 
 * @author A. Rueegsegger
 * @version $Id: TestIpcLoadValidity.java,v 1.19 2008/07/01 06:34:17 kuenzli Exp $
 */
public class TestIpcLoadValidity extends BasicTestCase
{
  String filename = "test_ipcr_validity_20061001_core_2006";

  static
  {
    System.setProperty( ValidityProperties.MAIL_SMTP_HOST, "mailrelay.ipi.ch" );
    System.setProperty( ValidityProperties.MAIL_SEND_TO, "michael.kuenzli@ipi.ch" );
    System.setProperty( ValidityProperties.MAIL_SEND_CC, "michael.kuenzli@ipi.ch" );
    System.setProperty( ValidityProperties.MAIL_SEND_FROM, "ServerMail_JavaBatch@ipi.ch" );

    System.setProperty( ValidityProperties.DOWNLOAD_URL, "http://www.wipo.int/classifications/ipc/en/download_area/20080101/xml/" );
    System.setProperty( ValidityProperties.ZIPFILE_TARGET, "c:/data/validity" );
    System.setProperty( ValidityProperties.UNZIP_DIRECTORY, "c:/data/validity/unzip" );

    System.setProperty( BatchReportMail.TEST_MAIL_FILE, "c:/temp/validitymail.txt" );
  }

  public TestIpcLoadValidity( String s )
  {
    super( s );
    BasicConfigurator.configure();
  }

  public void test()
  {
    paramTestProcess();
  }

  public void paramTestDownload()
  {
    String[] args = { "-f", filename, "-m", "download" };
    IpcLoadValidity.main( args );
  }

  public void paramTestProcess()
  {
    String[] args = { "-f", filename, "-m", "process" };
    IpcLoadValidity.main( args );
  }

  public void paramTestAll()
  {
    String[] args = { "-f", filename };
    IpcLoadValidity.main( args );
  }

}
