package ch.ige.ipcloadvalidity.client.download;


import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;

import org.apache.log4j.Logger;

import ch.ige.ipcloadvalidity.client.ValidityZipFile;


/**
 * Download eines Zip-Archivs via http vom IBIS-Server
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: Download.java,v 1.6 2007/01/24 14:44:30 ruegsegger Exp $
 */
public class Download
{
  private static final Logger LOG = Logger.getLogger( Download.class );

  private HTTPConnection con = new HTTPConnection();


  public Download()
  {
  }


   public void download(ValidityZipFile file) throws Exception
  {
    try
    {
      con.connect( file.getUrl() + file.getName() );
      LOG.info( "connected to " + file.getUrl() + file.getName() );

      con.checkResponseCode();
      file.checkContentType( con.getContentType() );

      copyToFile( con.getInputStream(), file );
    }
    finally
    {
      con.disconnect();
    }
  }


  public void copyToFile( InputStream in, File file ) throws Exception
  {
    BufferedOutputStream out = new BufferedOutputStream( new FileOutputStream( file ) );

    int size = 0;
    byte[] buf = new byte[1024];

    while ( ( size = in.read( buf, 0, buf.length ) ) != -1 )
    {
      out.write( buf, 0, size );
    }

    in.close();
    out.close();
  }




  private void createDirectory( String directory)
  {
    File dir = new File( directory );
    if ( !dir.exists())
    {
      dir.mkdirs();
    }
  }
}
