package ch.ige.ipcloadvalidity.vo.test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import ch.ige.ipcloadvalidity.vo.IpcVO;

/**
 * Erstellt Testdaten zu Testzwecken
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rüegsegger
 * @version $Id: Testdata.java,v 1.8 2007/01/09 10:30:32 ruegsegger Exp $
 */

public class Testdata
{
  private static SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");


  public Testdata()
  {
  }



  /**
   * Erstellt ein IpcVO
   * @return IpcVO
   */
  public static IpcVO createIpcVO()
  {
    IpcVO ipcVO = new IpcVO();

    try
    {
      ipcVO.ipcSymb = "Z01A";
      ipcVO.zusatz = IpcVO.CLASSIFICATION;
      ipcVO.gueltigVon = sdf.parse("20090101");
      ipcVO.gueltigBis = null;
      ipcVO.classLevel = null;
      ipcVO.corePred = null;
    }
    catch( ParseException ex )
    {
      System.out.println(ex);
    }

    return ipcVO;
  }

  /**
   * Erstellt eine Liste von IpcVOs
   * @return List of IpcVO
   */
  public static List createIpcVOs() throws Exception
  {
    List listIpcVO = new ArrayList();
    IpcVO ipcVO = new IpcVO();

    // neues symbol
    ipcVO.ipcSymb = "Z01B000100";
    ipcVO.zusatz = IpcVO.CLASSIFICATION;
    ipcVO.gueltigVon = sdf.parse( "20061001" );
    listIpcVO.add( ipcVO );

    ipcVO = new IpcVO();
    ipcVO.ipcSymb = "Z01B0001117";
    ipcVO.gueltigVon = sdf.parse( "20061001" );
    ipcVO.gueltigBis = sdf.parse( "20081231" );
    ipcVO.zusatz = IpcVO.INDEXING;
    listIpcVO.add( ipcVO );

    return listIpcVO;
  }

}
