package ch.ige.jipps.constants;

import ch.ige.util.server.replace.P2d2;

/**
 * Contains all P2D2 tags which are replaced while assembling a report.
 *
 * <p>Copyright (c) 2006, Swiss Federal Institute of Intellectual Property</p>
 * @author    Eric Lewis
 * @version   $Id: TagConstants.java,v 1.2 2006/05/04 08:42:29 lewis_lee Exp $
 * @see ch.ige.util.server.replace.P2d2
 */
public interface TagConstants
{
  /**
   * The tag for the publication number
   */
  public static final String PUBLICATION_NUMBER = P2d2.TAG_PREFIX + "publ_nr";

  /**
   * The tag for the publication date
   */
  public static final String PUBLICATION_DATE = P2d2.TAG_PREFIX + "publ_dat";

  /**
   * The tag for the publication year
   */
  public static final String PUBLICATION_YEAR = P2d2.TAG_PREFIX + "publ_jahr";
}
