package ch.ige.jipps.constants;

/**
 * Contains constants to determine what stylesheet is taken for a print job.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: XslConstants.java,v 1.2 2007/12/13 09:59:59 lewis_lee Exp $
 */
public interface XslConstants
{
  /**
   * The code for an IP which corresponds
   * to the status {@link ch.ige.util.constants.IpRegisterStateConstants#APPLICATION_STATE}.
   * This is used for {@link ch.ige.jipps.vo.PrintJobVO#AUSZUG}, within the XSL.
   */
  public final static String REPORT_FOR_APPLICATION = "Ges";
  
  /**
   * The code for an IP which corresponds
   * to the status {@link ch.ige.util.constants.IpRegisterStateConstants#REGISTRATION_STATE}.
   * This is used for {@link ch.ige.jipps.vo.PrintJobVO#AUSZUG}, within the XSL.
   */
  public final static String REPORT_FOR_REGISTRATION = "Reg";

  /**
   * The XSL filename for a design image list.
   * This is used for {@link ch.ige.jipps.vo.PrintJobVO#DESIGN_BILDER}.
   */
  public static final String BILDER_LISTE = "bilderListe";

  /**
   * The XSL filename for a form (letter template).
   * This is used for {@link ch.ige.jipps.vo.PrintJobVO#FORMULAR}.
   */
  public static final String FORMULAR = "formular";

  /**
   * The XSL filename for a base sheet for an article (event template).
   * This is used for {@link ch.ige.jipps.vo.PrintJobVO#STAMMBLATT}.
   */
  public static final String STAMMBLATT = "stammblatt";

  /**
   * One of the possible XSL filenames for a letter.
   * This is used for {@link ch.ige.jipps.vo.PrintJobVO#LETTER}.
   */
  public static final String HINTERLEGUNG = "hinterlegung";

  /**
   * One of the possible XSL filenames for a letter.
   * This is used for {@link ch.ige.jipps.vo.PrintJobVO#LETTER}.
   */
  public static final String LETTER = "letter";
    
  /**
   * The XSL filename for the report showing European Patent applications
   * ordered by numbers.
   */
  public static final String EP_001 = "ep_001";
  
  /**
   * The XSL filename for the report showing European Patent registrations
   * ordered by numbers.
   */
  public static final String EP_002 = "ep_002";
  
  /**
   * The XSL filename for the report showing European Patent changes.
   */
  public static final String EP_003 = "ep_003";
}
