package ch.ige.jipps.dao.test;

import ch.ige.dbutils.util.ClientInitializer;
import ch.ige.jipps.dao.InfoDAO;
import ch.ige.util.client.ClientLogInitalizer;
import junit.framework.TestCase;

/**
 * Tests {@link ch.ige.jipps.dao.InfoDAO}. 
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: InfoDAOTest.java,v 1.5 2007/07/25 09:12:56 lang Exp $
 */
public class InfoDAOTest extends TestCase
{

  static
  {
    ClientLogInitalizer.initializeLoggingForTests( true, true );
    ClientInitializer.initStandaloneClient();
  }

  /**
   * The only constructor
   * @param name The test's name
   */
  public InfoDAOTest( String name )
  {
    super( name );
  }

  /**
   * Tests {@link ch.ige.jipps.dao.InfoDAO#getJippsDbURL()}.
   */
  public void testGetJippsDbURL()
  {
    String url = InfoDAO.getJippsDbURL();
    assertEquals( "Checking URL", "jdbc:oracle:thin:@ipiesa1030.ipie.ch:1521/EIGE.ipie.ch", url );
    assertSame( "Checking that URL is cached", url, InfoDAO.getJippsDbURL() );
  }

  /**
   * Tests {@link ch.ige.jipps.dao.InfoDAO#getBagisDbURL()}.
   */
  public void testGetBagisDbURL()
  {
    String url = InfoDAO.getBagisDbURL();
    assertEquals( "Checking URL", "jdbc:oracle:thin:@ipiesa1030.ipie.ch:1521/EBAGE.ipie.ch", url );
    assertSame( "Checking that URL is cached", url, InfoDAO.getBagisDbURL() );
  }
}
