package ch.ige.jipps.ftp.web.util;

import java.sql.SQLException;

import org.apache.log4j.Logger;

import ch.ige.dbutils.dao.AbstractBagisDAO;

/**
 * DAO for selecting the configuration of the FTPServlet
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   fabrizioli
 * @version  $Id: FTPServletConfigDAO.java,v 1.6 2008/05/22 13:42:58 fabrizioli Exp $
 */
public class FTPServletConfigDAO extends AbstractBagisDAO
{
  public static class INTRANET {};
  
  public static class EPA{};
  
  public static class CLIENT{};
  
  public static class SERVLET{};
  
  private static final Logger LOG = Logger.getLogger( FTPServletConfigDAO.class );

  private static final String TABLE_NAME = "PATDOCFEEDERCONFIG";

  private static final String KEY_COLUMN = "KEY";

  private static final String VALUE_COLUMN = "VALUE";

  private static final String DESC_COLUMN = "DESCRIPTION";

  private static final String CAT_COLUMN = "CATEGORY";

  /**
   * Selects the FTPServletConfig info for the FTPservlet
   * 
   * @return A <code>FTPServletConfigVO</code> containing all the data for the FTPservlet
   */
  public FTPAccessConfigVO selectIntranetConfig() throws SQLException
  {
    return FTPAccessConfigVO.fromConfiguration( this.getConfigurationTable( TABLE_NAME, CAT_COLUMN, KEY_COLUMN, VALUE_COLUMN, DESC_COLUMN ).getConfiguration(
        INTRANET.class, true ) );
  }

  public FTPAccessConfigVO selectEPAConfig() throws SQLException
  {
    return FTPAccessConfigVO.fromConfiguration( this.getConfigurationTable( TABLE_NAME, CAT_COLUMN, KEY_COLUMN, VALUE_COLUMN, DESC_COLUMN ).getConfiguration(
        EPA.class, true ) );
  }
  
  public FTPServletConfigVO selectServletConfig() throws SQLException
  {
    return FTPServletConfigVO.fromConfiguration( this.getConfigurationTable( TABLE_NAME, CAT_COLUMN, KEY_COLUMN, VALUE_COLUMN, DESC_COLUMN ).getConfiguration(
        SERVLET.class, true ) );
  }
  
  public EPAUploadClientConfigWrapper selectClientConfig() throws SQLException
  {
    return  EPAUploadClientConfigWrapper.fromConfiguration( this.getConfigurationTable( TABLE_NAME, CAT_COLUMN, KEY_COLUMN, VALUE_COLUMN, DESC_COLUMN ).getConfiguration(
        CLIENT.class, true ) );
  }
}
