package ch.ige.jipps.header;

/**
 * Contains the data for the print header in the report.
 * <p>
 * Copyright (c) 2006, Eidgenössisches Institut für Geistiges Eigentum
 * </p>
 * 
 * @author Eric Lewis
 * @version $Id: PrintHeader.java,v 1.4 2006/12/19 08:03:42 bandschapp Exp $
 */
public interface PrintHeader
{
  /**
   * Gets the formatted print date.
   * 
   * @return The formatted print date
   */
  public String getPrintDate();

  /**
   * Gets the page label, for instance <code>Seite: </code>.
   * 
   * @return The page label
   */
  public String getPageLabel();

  /**
   * Gets the label for {@link #getFormattedIpNumber()}, for instance <code>Eintragungsnummer: </code>.
   * 
   * @return The ip number label
   */
  public String getIpNumberLabel();

  /**
   * Gets the formatted version of {@link ch.ige.jipps.header.IpHeader#getIpNumber()}, which loses the checksum and may
   * be formatted with slashes etc.
   * 
   * @return The formatted ip number
   */
  public String getFormattedIpNumber();
}
