package ch.ige.jipps.history.detail;

import java.util.List;
import java.util.Locale;

import ch.ige.ipobjects.address.Address;
import ch.ige.ipobjects.common.GenericIP;
import ch.ige.ipobjects.event.Event;
import ch.ige.ipobjects.model.IPType;
import ch.ige.ipobjects.report.history.HistoryDescription;
import ch.ige.ipobjects.time.TimePeriodCollection;
import ch.ige.jipps.vo.HistoryItemVO;

/**
 * Creates the detail lines for address, where both valid and invalid addresses of one role are shown.
 * <p>
 * Copyright (c) 2006, Swiss Federal Institute of Intellectual Property
 * </p>
 * @author Eric Lewis
 * @version $Id: ValidAndInvalidAddressDetail.java,v 1.2 2007/12/19 08:57:02 lewis_lee Exp $
 */
public class ValidAndInvalidAddressDetail extends InvalidAddressDetail
{
  /**
   * Creates this with all the data
   * @param ip The IP
   * @param addresses The addresses to format
   * @param ipType The IP type
   * @param language The language
   */
  public ValidAndInvalidAddressDetail( GenericIP ip, TimePeriodCollection<Address> addresses, IPType ipType, Locale language )
  {
    super( ip, addresses, ipType, language );
  }

  // See interface
  @Override
  protected TimePeriodCollection<Address> findMatchingDetailDataForSpecialCase( HistoryDescription<List<HistoryItemVO>, HistoryItemVO> historyDescription,
      Event event )
  {
    TimePeriodCollection<Address> reasonableAddresses = super.findMatchingDetailDataForSpecialCase( historyDescription, event );
    return this.addressRoleCollator.getAddressesWithSameRoles( reasonableAddresses ).getPeriodsContainingTime( event );
  }
}
