package ch.ige.jipps.signature.stamp;

import ch.ige.jipps.configuration.PathConfiguration;
import ch.ige.jipps.constants.PropertyConstants;

/**
 * Data for a black stamp of the IGE.
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   Esther Bandschapp
 * @version  $Id: IgeBlackStamp.java,v 1.1 2008/05/21 08:27:41 bandschapp Exp $
 */
public class IgeBlackStamp implements Stamp
{
  /**
   * The path where the stamp is found. Same directory as all the xsl's.
   */
  private static String stampPath = PathConfiguration.getVerifiedPathAsUrl( PropertyConstants.JIPPS_PATH_XSL, false );

  /**
   * The file name of the stamp image.
   */
  private static String stampFileName = "Stempel_schwarz.JPG";

  /**
   * The height of the stamp image.
   */
  private static String stampHeight = "3.4cm";

  /**
   * The width of the stamp image.
   */
  private static String stampWidth = stampHeight;

  // @see ch.ige.jipps.signature.stamp.Stamp#getImageHeight()
  public String getImageHeight()
  {
    return stampHeight;
  }

  // @see ch.ige.jipps.signature.stamp.Stamp#getImageWidth()
  public String getImageWidth()
  {
    return stampWidth;
  }

  // @see ch.ige.jipps.signature.stamp.Stamp#getImageScr()
  public String getImageScr()
  {
    return stampPath + stampFileName;
  }
}
