package ch.ige.jipps.vo;

import java.sql.Date;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.ipobjects.time.vo.EreigIDat;

/**
 * For an invoice (or letter), this contains a line item.
 * <p>Copyright (c) 2002-2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author Marc Bouquet
 * @author Eric Lewis
 * @version $Id: BfaktPosVO.java,v 1.18 2008/07/23 13:16:52 lewis_lee Exp $
 */
public class BfaktPosVO extends AbstractVO
{
  /**
   * The unique ID of the invoice.
   */
  public int invoiceId = 0;

  /**
   * The line item number, which is normally incremented in steps of 10.
   * Together with {@link #invoiceId}, it's unique.
   */
  public int lineItemNumber = 0;

  /**
   * The date of the event belonging to this.
   */
  public EreigIDat eventDate;

  /**
   * The number of the text to show for the item.
   */
  public int textNumber = 0;

  /**
   * Number of &quot;articles&quot; per item.
   */
  public int numberOfArticles = 0;

  /**
   * The deadline for the item.
   */
  public Date deadline = null;

  /**
   * The IP's number.
   */
  //TODO Make this an Integer
  public String ipNumber = "";

  /**
   * An optional publication text for this.
   */
  public String publicationText;
}
