package ch.ige.jipps.vo;

import java.io.Serializable;
import org.apache.commons.lang.builder.ReflectionToStringBuilder;

/**
 * ValueObject für DirectControl. Im DirectControl wird der erhaltene byte[] des PdfRenderServlet,
 * den ListenTyp welches an das PdfRenderServlet übergeben wird sowie den Datei-Namen unter dem das
 * FileServlet die Datei abspeichert in das Value-Object geschrieben. Dieses Value-Object wird
 * danach dem FileServlet übergeben.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Marc Bouquet
 * @version $Id: ByteArrayVO.java,v 1.7 2006/12/19 14:30:20 lewis_lee Exp $
 */
public class ByteArrayVO implements Serializable
{
  public byte[] file = null;
  public String fileName = "";
  public String listenTyp = "";
  public String ladeDatum = "";
  /**
   * If this is <code>true</code>, the file name in {@link #fileName} is a
   * fully specified file name including a valid path.
   */
  public boolean containsFullPath = false;

  // See superclass
  public String toString()
  {
    return ReflectionToStringBuilder.toString( this );
  }
}
