package ch.ige.jipps.vo;

import java.sql.Timestamp;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.dbutils.vo.IdentifiableVO;

/**
 * A run of cancellations, normally patent cancellations.
 * 
 * <p>Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author Marc Bouquet
 * @author Eric Lewis
 * @version $Id: LoeschungLaufVO.java,v 1.11 2007/04/27 07:20:11 lewis_lee Exp $
 */
public class LoeschungLaufVO extends AbstractVO implements IdentifiableVO<Integer>
{
  // @see ch.ige.dbutils.vo.IdentifiableVO#getIdentifier()
  public Integer getIdentifier()
  {
    return this.loeschungLaufId;
  }

  // @see ch.ige.dbutils.vo.IdentifiableVO#setIdentifier(java.io.Serializable)
  public void setIdentifier( Integer id )
  {
    this.loeschungLaufId = id;
  }

  /**
   * The unique ID for the cancellation run
   */
  public int loeschungLaufId = 0;

  /**
   * The processing start
   */
  public Timestamp verarbStart = null;

  /**
   * The processing end
   */
  public Timestamp verarbEnde = null;

  /**
   * The state of the cancellation run
   */
  //TODO Create constants
  public int jippsStat = 0;

  /**
   * Number of invoices that were read during processing
   */
  public int anzBfaktGel = 0;

  /**
   * Number of generated cancellations
   */
  public int anzLoeschGen = 0;

  /**
   * The date when the cancellation run was created
   */
  public Timestamp createdDate = null;

  /**
   * The date when the cancellation run was changed
   */
  public Timestamp changedDate = null;

  /**
   * The type of cancellation run, one of {@link ch.ige.util.constants.CancellationConstants}
   */
  public Integer druckArt;
}
