package ch.ige.jipps.vo;

import java.util.ArrayList;
import java.util.List;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.jipps.currentstate.CurrentStateElement;

/**
 * Contains the current state of an IP.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 *
 * @author Priska Steiner
 * @author Elmar Isler
 * @author Eric Lewis
 * @version   $Id: StandDatVO.java,v 1.12 2007/04/20 13:42:28 lewis_lee Exp $
 */

public class StandDatVO extends AbstractVO implements CurrentStateElement
{
  /**
   * The title
   */
  private String title;
  /**
   * The report text number
   */
  private Integer reportTextNumber;
  /**
   * The text lines
   */
  private List<String> textLines;

  /**
   * Creates this
   */
  public StandDatVO()
  {
    this.textLines = new ArrayList<String>();
  }

  // See interface
  public String getTitle()
  {
    return this.title;
  }

  // See interface
  public void setTitle( String title )
  {
    this.title = title;
  }

  // See interface
  public String getReportText()
  {
    return getTitle();
  }

  // See interface
  public void setReportText( String title )
  {
    setTitle( title );
  }

  // See interface
  public List<String> getTextLines()
  {
    return this.textLines;
  }

  // See interface
  public void setTextLines( List<String> textLines )
  {
    this.textLines = textLines;
  }

  // See interface
  public Integer getReportTextNumber()
  {
    return this.reportTextNumber;
  }

  // See interface
  public void setReportTextNumber( Integer reportTextNumber )
  {
    this.reportTextNumber = reportTextNumber;
  }

  // See interface
  public void setReportTextNumber( int reportTextNumber )
  {
    this.reportTextNumber = new Integer( reportTextNumber );
  }
}
