package ch.ige.jipps.vo.comparator;

import java.util.Comparator;

import ch.ige.jipps.text.ReportTextContainer;
import ch.ige.util.constants.ReportTextConstants;

/**
 * Makes sure that for two {@link ch.ige.jipps.text.ReportTextContainer} objects,
 * the cancellation event is shown first. Using this means that in a <code>Collection</code>,
 * at the end the cancellation event will be the first element.
 *
 * <p>Copyright (c) 2006, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author    Eric Lewis
 * @version   $Id: EventCancellationComparator.java,v 1.8 2007/05/04 08:56:36 lewis_lee Exp $
 */
public class EventCancellationComparator implements Comparator<ReportTextContainer>
{
  
  // @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
  public int compare( ReportTextContainer reportTextContainer1, ReportTextContainer reportTextContainer2 )
  {
    int textNumber1 = reportTextContainer1.getReportTextNumber().intValue();
    int textNumber2 = reportTextContainer2.getReportTextNumber().intValue();

    if ( textNumber1 == ReportTextConstants.DESIGN_CANCELLATION )
    {
      return -1;
    }
    else if ( textNumber2 == ReportTextConstants.DESIGN_CANCELLATION )
    {
      return 1;
    }
    else
    {
      return 0;
    }
  }
}
