package ch.ige.jipps.vo.comparator.test;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import junit.framework.TestCase;
import ch.ige.jipps.text.ReportTextContainer;
import ch.ige.jipps.vo.StandDatVO;
import ch.ige.jipps.vo.comparator.EventCancellationComparator;

/**
 * Tests {@link ch.ige.jipps.vo.comparator.EventCancellationComparator}.
 *
 * <p>Copyright (c) 2006, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author    Eric Lewis
 * @version   $Id: EventCancellationComparatorTest.java,v 1.8 2007/05/04 08:56:36 lewis_lee Exp $
 */
public class EventCancellationComparatorTest extends TestCase
{
  /**
   * The default constructor
   * @param args Any arguments
   */
  public EventCancellationComparatorTest( String args )
  {
    super( args );
  }
  /**
   * Tests how the Comparator compares with report text containers.
   */
  public void testCompareWithReportTextContainers()
  {
    List<ReportTextContainer> reportTextContainers = new ArrayList<ReportTextContainer>();
    reportTextContainers.add( createReportTextContainer( 1, "hello" ) );
    reportTextContainers.add( createReportTextContainer( 602, "world" ) );
    reportTextContainers.add( createReportTextContainer( 2, "world" ) );
    Collections.sort( reportTextContainers, new EventCancellationComparator() );

    assertEquals( "Checking number of events", 3, reportTextContainers.size() );

    ReportTextContainer container = reportTextContainers.get( 0 );
    assertEquals( "Checking new first report text number", 602, container.getReportTextNumber().intValue() );

    container = reportTextContainers.get( 1 );
    assertEquals( "Checking new second report text number", 1, container.getReportTextNumber().intValue() );

    container = reportTextContainers.get( 2 );
    assertEquals( "Checking new third report text number", 2, container.getReportTextNumber().intValue() );
  }

  /**
   * Creates a report text container.
   * @param reportTextNumber The report text number
   * @param reportText The report text
   * @return A report text container
   */
  private ReportTextContainer createReportTextContainer( int reportTextNumber, String reportText )
  {
    ReportTextContainer state = new StandDatVO();
    state.setReportTextNumber( new Integer( reportTextNumber ) );
    state.setReportText( reportText );
    return state;
  }
}
