package ch.ige.pctedi.client;

import java.io.File;
import java.io.FilenameFilter;

/**
 * Filter für Pctedi-File
 * Werte werden anhand Config-Datei pct.properties ermittelt
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: PctFileFilter.java,v 1.2 2008/07/01 07:08:10 kuenzli Exp $
 */
public class PctFileFilter implements FilenameFilter
{
  private File unzipDir = null;
  private String regexPctZipFilename = null;
  
  public PctFileFilter()
  {  
    unzipDir = new File(PctProperties.getInstance().getProperty(PctProperties.ZIPFILE_TARGET ));
    regexPctZipFilename = PctProperties.getInstance().getProperty( PctProperties.ZIPFILE_NAME);
  }
  
  /**
   * Überprüft ob es sich bei der Datei um ein Pct-File handelt
   * @param dir File Datei
   * @param name String Dateiname
   * @return boolean true falls akzeptiert
   */  
  public boolean accept( File dir, String name )
  {
    return  dir != null &&
    dir.getAbsolutePath().equals( unzipDir.getAbsolutePath() ) &&
    name.matches( regexPctZipFilename );
  }
}


