package ch.ige.pctedi.client.batch.test;

import junit.framework.TestCase;
import ch.ige.pctedi.client.batch.Pctedi;
import ch.ige.util.client.batch.BatchReportMail;
import ch.ige.util.client.batch.NewAbstractBatch;

/**
 * junit test to start programm pctedi
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: TestPctedi.java,v 1.7 2008/07/01 07:46:41 kuenzli Exp $
 */
public class TestPctedi extends TestCase
{
  static
  {
    String configfile = "file:///C:/jp/projects/pctedi/install/programme/ige/pctedi/config/pctedi_log_config.xml";
    System.setProperty( "log4j.configuration", configfile );

    String props = "file:///C:/jp/projects/pctedi/install/programme/ige/pctedi/config/pct.properties";
    System.setProperty( "pct.properties", props );
  }

  public TestPctedi( String s )
  {
    super( s );
  }

  public void test()
  {

    System.setProperty( BatchReportMail.TEST_MAIL_FILE, "c:/temp/pctmail.txt" );

//       startWithoutParam();
    startWithParamWpa();
//   startWithParamGazette();
  }

  public void startWithoutParam()
  {
    String[] args = null;
    PctediExt.main( args );
  }

  public void startWithParamWpa()
  {
    String[] args = { "-m", "wpa" };
    PctediExt.main( args );
  }

  public void startWithParamGazette()
  {
    String[] args = { "-m", "gazette" };
    PctediExt.main( args );
  }

  /**
   * Internal class that overwrites constructor and main().
   */
  private static class PctediExt extends Pctedi
  {
    public PctediExt()
    {
      super( APPLICATION_NAME, OPTIONS, false );
    }

    public static void main( String[] args )
    {
      PctediExt pctedi = new PctediExt();
      NewAbstractBatch.start( pctedi, args );
    }

  }
}
