package ch.ige.pctedi.client.gazette;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;
import ch.ige.pctedi.client.*;

/**
 * <p>Überschrift: </p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: </p>
 * @author A. Rueegsegger
 * @version $Id: GazetteLogFile.java,v 1.7 2008/07/01 07:47:15 kuenzli Exp $
 */

public class GazetteLogFile extends PctLogFile
{
  private SimpleDateFormat sdf = new SimpleDateFormat( "dd.MM.yyyy" );
  private static GazetteLogFile logFile;

  private GazetteLogFile()
  {
    sdf.setLenient( false );
  }

  /**
   * Gibt die einzige Instanz zurück (Singleton)
   */
  public static GazetteLogFile getInstance()
  {
    if ( logFile == null )
    {
      logFile = new GazetteLogFile();
    }
    return logFile;
  }

  /**
   * File öffnen, bzw erstellen
   * File-Pointer ans Ende der Datei setzte, damit geschriebene Daten nicht ueberschrieben werden
   * @param pathname Fielpfad des Files
   */
  public void setLogFile( String publWeek )
  {
    File file = new File( PctProperties.getInstance().getProperty( PctProperties.LOGFILE_PATH ),
                          ( "PCT_Gazette_" + publWeek + ".log" ) );
    super.setLogFile( file );
  }

  public void writeHeader( Date publDat, String pathname, String week )
  {
    write( "Version: " + version + "\r\n" );
    write( "PCT Gazette Section II " + sdf.format( publDat ) + "\r\n" );
    write( "Gestartet am      : " + new Date() );
    write( "Verarbeiten von   : " + pathname );
    write( "Woche             : " + week );
    write( "=======================================================\r\n" );
  }

  public void writeFooter()
  {
    write( "\r\n" );
    write( "Beendet am        : " + new Date() );
    write( "=======================================================" );
    write( "\r\n" );
  }
}
