package ch.ige.pctedi.client.test;

import java.util.Map;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.pctedi.client.MappingUnicode;
import ch.ige.pctedi.server.PctDelegate;

/**
 * testcase for class MappingUnicode
 *
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author A.Rueegsegger
 * @version $Id: MappingUnicodeTest.java,v 1.8 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class MappingUnicodeTest extends TestCase
{

  public MappingUnicodeTest( String s )
  {
    super( s );
    BasicConfigurator.configure();
  }

  public void testMapping()
  {
    try
    {
      String str = " Test [’] replacement [’] ";
      String replaceStr = MappingUnicode.getInstance().replaceUnicodeValues( str );

      assertEquals( " Test ['] replacement ['] ", replaceStr );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void testMappingUnicodeDAO()
  {
    try
    {
      Map<String, String> map = PctDelegate.getInstance().getAllMappingUnicode();

      for ( Map.Entry<String, String> entry: map.entrySet() )
      {
        String key = entry.getKey();
        String value = entry.getValue();

        System.out.println( " key: " + key + " value: " + value );
      }

      assertTrue( "\u2019 nicht enthalten in Tabelle mapping_unicode ", map.containsKey( "\u2019" ) );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.getMessage() );
    }
  }
}
