package ch.ige.pctedi.client.test;

import ch.ige.pctedi.client.PctFile;
import ch.ige.pctedi.client.PctZipFile;

/**
 * junit-test for class PctFile 
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: PctFileTest.java,v 1.5 2008/07/01 07:47:27 kuenzli Exp $
 */
public class PctFileTest extends ClientTestCase
{

  public PctFileTest( String s )
  {
    super( s );
  }


  public void test()
  {
    PctFile pctFile = new PctFile();

    assertTrue( "Directory does not exist: " + pctFile.getName(), pctFile.exists() );
    assertTrue( "Directory can not be read: " + pctFile.getName(), pctFile.canRead() );
    assertTrue( pctFile.getName() + " is not a directory", pctFile.isDirectory() );

    PctZipFile[] files = pctFile.listPctZipFiles();
    if ( files != null )
    {
      for ( int i = 0; i < files.length; i++ )
      {
        System.out.println( "file: " + files[i].getName() );
        System.out.println( "process week: " + files[i].extractProcessWeek() );

        try
        {
          //files[i].unzip();

          files[i].packAndMoveToDone();
        }
        catch ( Exception e )
        {
          e.printStackTrace();
          fail( e.getMessage() );
        }
      }
    }
    else
    {
      fail( "no files found" );
    }
  }

}
