package ch.ige.pctedi.client.test;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;

import junit.framework.TestCase;
import ch.ige.pctedi.client.XMLDoc;

/**
 * Test der Klasse WPAXml
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version Id:
 */
public class TestXMLDoc extends TestCase
{
  XMLDoc xml;

  String filename = "C:\\jp\\projects\\pctedi\\testfiles\\wpa\\CH2005000342_05012006\\wo-published-application.xml";

  public TestXMLDoc( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      FileInputStream fi = new FileInputStream( filename );
      xml = new XMLDoc( fi );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

  public void test00String()
  {
    StringBuffer xmlString = new StringBuffer();
    String line;

    try
    {
      BufferedReader in = new BufferedReader( new FileReader( filename ) );
      while ( ( line = in.readLine() ) != null )
      {
        xmlString.append( line );
      }
      in.close();

      xml = new XMLDoc( xmlString.toString() );

      String value = xml.getAttribute( "wo-published-application", "date-produced" );
      assertEquals( "20060105", value );

      value = xml.getAttribute( "lkddsklj", "alkkfjdl" );
      assertEquals( "", value );

      value = xml.getValueOf( "fkafdakjl" );
      assertEquals( "", value );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
    }
  }

}
