package ch.ige.pctedi.vo;

import java.io.Serializable;
import java.util.Date;

/**
 * value object for table SCHUTIT
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: SchutitVO.java,v 1.10 2008/07/01 07:43:05 kuenzli Exp $
 */
public class SchutitVO implements Serializable
{
  /**
   * Default id.
   */
  private static final long serialVersionUID = 1L;
  public static final int GESUCH = 0; //Gesuchsstadium (default)

  public static final int REGISTER = 1; //im schweizerischen Schutztitel-Register eingetragen

  public static final int SCHUTIT_TYP_CH = 1;

  public static final int SCHUTIT_TYP_EP = 2;

  public static final int SCHUTIT_TYP_PCT = 3;

  public int schutitKey = 0;

  public Integer maNr = new Integer( PctVO.MA_NR );

  public int schutitTyp = SCHUTIT_TYP_PCT;

  public int sprache = 0;

  public String gesuchNr = null;

  public String schutitNr = null;

  public int registerKz = 0;

  public Date schutzBegin = null;

  public Date schutzEnde = null;

  public Date loeschDat = null;

  public String beschreibung = null;

  public String uppBeschreibung = null;

  public String ihrZeichen = null;

  public int dossierBeachten = 0;

  public String internBem = null;

  public int kzUeberwach = 0;

  public int erfassMa = PctVO.MA_NR;

  public Date erfassDat = null;

  public Integer mutMa = null;

  public Date mutDat = null;

  public Date erstEreigDat = null;

  public int faelligJahr = 0;

  public int version = 0;

  /**
   * Gibt den Inhalt des ValueObject SchutitVO zurück
   * @return Inhalt von SchutitVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  maNr             = <" + this.maNr + ">\n" );
    buf.append( "  schutitTyp       = <" + this.schutitTyp + ">\n" );
    buf.append( "  sprache          = <" + this.sprache + ">\n" );
    buf.append( "  gesuchNr         = <" + this.gesuchNr + ">\n" );
    buf.append( "  schutitNr        = <" + this.schutitNr + ">\n" );
    buf.append( "  registerKz       = <" + this.registerKz + ">\n" );
    buf.append( "  schutzBegin      = <" + this.schutzBegin + ">\n" );
    buf.append( "  schutzEnde       = <" + this.schutzEnde + ">\n" );
    buf.append( "  loeschDat        = <" + this.loeschDat + ">\n" );
    buf.append( "  beschreibung     = <" + this.beschreibung + ">\n" );
    buf.append( "  uppBeschreibung  = <" + this.uppBeschreibung + ">\n" );
    buf.append( "  ihrZeichen       = <" + this.ihrZeichen + ">\n" );
    buf.append( "  dossierBeachten  = <" + this.dossierBeachten + ">\n" );
    buf.append( "  internBem        = <" + this.internBem + ">\n" );
    buf.append( "  kzUeberwach      = <" + this.kzUeberwach + ">\n" );
    buf.append( "  erfassMa         = <" + this.erfassMa + ">\n" );
    buf.append( "  erfassDat        = <" + this.erfassDat + ">\n" );
    buf.append( "  mutMa            = <" + this.mutMa + ">\n" );
    buf.append( "  mutDat           = <" + this.mutDat + ">\n" );
    buf.append( "  erstEreigDat     = <" + this.erstEreigDat + ">\n" );
    buf.append( "  faelligJahr      = <" + this.faelligJahr + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );

    return buf.toString();
  }

}
