package ch.ige.rbbagisexport.server.config.test;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

import ch.ige.rbbagisexport.common.RBBagisExportConfiguration;
import ch.ige.rbbagisexport.server.config.RBBagisExportConfigReader;

public class RBBagisExportConfigurationTest extends TestCase
{

  //----------------------------------------------------------------------------
  // Private Members
  //----------------------------------------------------------------------------
  // Logger
  private static final Logger LOG = Logger.getLogger( RBBagisExportConfigurationTest.class );

  private RBBagisExportConfigReader configReader = null;
  //----------------------------------------------------------------------------
  // Constructor
  //----------------------------------------------------------------------------
  public RBBagisExportConfigurationTest( String arg0 )
  {
    super( arg0 );
  }

  //----------------------------------------------------------------------------
  // Public Methods
  //----------------------------------------------------------------------------

  //----------------------------------------------------------------------------
  // Test Methods
  //----------------------------------------------------------------------------
  // ***** Test 1 *****
  public void testReadConfigurationFromDB()
  {
    configReader = RBBagisExportConfigReader.instance();
    try
    {
      configReader.readConfigurationFromDb();
      RBBagisExportConfiguration configuration = configReader.getConfiguration();
      LOG.info( "Configuration: "+configuration);
    }
    catch ( Exception e )
    {
      fail( "Failed reading configuration." );
      return;
    }
    assertTrue( true );
  }

  //----------------------------------------------------------------------------
  // Protected Methods
  //----------------------------------------------------------------------------
  protected void setUp()
  {
    // setup logger with the appropriate configuration
    BasicConfigurator.configure();
    
    System.setProperty( "java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory" );
    System.setProperty( "java.naming.provider.url", "jnp://ipiebgs010.ipie.ch:1099" );
  }
}
