package ch.ige.rbbagisexport.server.dao.test;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

import ch.ige.rbbagisexport.server.dao.RBExportDAO;
import ch.ige.rbbagisexport.server.datacontainer.ExportContainerFactory;
import ch.ige.rbbagisexport.server.datacontainer.ExportDataContainer;
import ch.ige.rbbagisexport.server.filetransfer.ExportFileHelper;
import ch.ige.rbbagisexport.server.vo.RBExportVO;
import ch.ige.rbbagisexport.server.xml.ChSearchReportXMLConverter;

public class TestRBExportDAO
{
  // Logger
  private static final Logger LOG = Logger.getLogger( RBExportDAO.class );

  //----------------------------------------------------------------------------
  // Test
  //----------------------------------------------------------------------------
  public static void main( String[] args ) throws Exception
  {
    BasicConfigurator.configure();
    LOG.debug( "Start" );
    RBExportDAO rbExpDAO = new RBExportDAO();
    //----------------------------------------
    //    RBExportVO rbExportData = rbExpDAO.selectRBExportData( new Integer( 1201967799 ) );
    RBExportVO rbExportData = rbExpDAO.selectRBExportData( new Integer( 1201844221 ) );

    ChSearchReportXMLConverter conv = new ChSearchReportXMLConverter();
    String xml = conv.convertToXml( rbExportData );
    LOG.debug( xml );

    ExportContainerFactory exportContainerFactory = new ExportContainerFactory();
    ExportDataContainer expDataContainer = exportContainerFactory.createContainer( rbExportData );
    ExportFileHelper fileHelper = new ExportFileHelper();
    fileHelper.writeFile( expDataContainer );
    LOG.debug( "End" );
  }

}
