package ch.ige.rbbagisexport.server.datacontainer;

import java.io.Serializable;

import javax.xml.bind.JAXBException;

import org.apache.log4j.Logger;

import ch.ige.rbbagisexport.server.ejb.RBBagisExportBean;
import ch.ige.rbbagisexport.server.vo.RBExportVO;
import ch.ige.rbbagisexport.server.xml.ChSearchReportXMLConverter;

/**
 * Factory for ExportDataContainer. Includes the conversion of a RBExportVO into
 * a XML (ch-search-report).
 * <p>
 * Copyright (c) 2007, Eidgenössisches Institut für Geistiges Eigentum
 * @author M. Künzli
 * @version $Id: ExportContainerFactory.java,v 1.4 2008/04/28 07:42:53 kuenzli Exp $
 */
public class ExportContainerFactory implements Serializable
{
  //----------------------------------------------------------------------------
  // const
  //----------------------------------------------------------------------------
  private static final Logger LOG = Logger.getLogger(RBBagisExportBean.class );
  private static final long serialVersionUID = 1L;
  
  //----------------------------------------------------------------------------
  // Public Methods
  //----------------------------------------------------------------------------
  /**
   * Create a new ExportDataContainer that includes the XML data.
   * @param exportVO
   * @return The created ExportDataContainer.
   * @throws JAXBException
   */
  public ExportDataContainer createContainer( RBExportVO exportVO ) throws JAXBException
  {
    ChSearchReportXMLConverter conv = new ChSearchReportXMLConverter();
    String xml;
    try
    {
      xml = conv.convertToXml( exportVO );
    }
    catch ( JAXBException e )
    {
      LOG.error( "createExportFile(): JAXBException" );
      throw e;
    }

    ExportDataContainer file = new ExportDataContainer(xml, exportVO.getAppNr());

    return file;
  }
}
