package ch.ige.rbbagisexport.server.util;

import java.util.StringTokenizer;

import org.apache.log4j.Logger;

public class EreignisseContainer
{
  //---------------------------------------------------------------------------- 
  // Privat Members
  //---------------------------------------------------------------------------- 
  private static final Logger LOG = Logger.getLogger( EreignisseContainer.class );

  private String sqlNotation="";

  private static final String DELIMITERS = ",; ";

  private static final String SQL_DELIMITER = ",";

  //---------------------------------------------------------------------------- 
  // Public Methods
  //---------------------------------------------------------------------------- 
  public EreignisseContainer( String ereignisse ) throws InvalidEreignisseList
  {
    StringTokenizer tizer = new StringTokenizer( ereignisse, DELIMITERS );

    String token = null;
    int counter = 0;
    while ( tizer.hasMoreTokens() )
    {
      counter++;
      try
      {
        token = tizer.nextToken();
        Integer.parseInt( token ); // check whether token is an integer
        if ( counter > 1 )
        {
          this.sqlNotation = this.sqlNotation + SQL_DELIMITER;
        }
        this.sqlNotation = this.sqlNotation + token;
      }
      catch ( Exception e )
      {
        LOG.error( "Could not transform: " + token );
        throw new InvalidEreignisseList( "Ereignisse List could not be parsed. Invalid Integer "+token, e );
      }
    }
  }

  public String getSqlNotation()
  {
    return this.sqlNotation;
  }
}
