package ch.ige.rbbagisimport.common.vo;

import java.io.Serializable;

/**
 * Represents a SearchReport File
 * 
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   bolzli
 * @version  $Id: SearchReportFileVO.java,v 1.6 2008/06/10 13:52:17 wild Exp $
 */
@SuppressWarnings( "serial" )
public class SearchReportFileVO implements Serializable
{
  public static final int PROCESS_STATE_NOT_PROCESSED = 0;

  public static final int PROCESS_STATE_IN_PROCESS = 1;

  public static final int PROCESS_STATE_SUCCEEDED = 2;

  public static final int PROCESS_STATE_FAILED = 3;

  public static final int SR_TYPE_DRAFT = 0;

  public static final int SR_TYPE_FINAL = 1;

  // error messages
  public static final String MSG_NOT_VALID = "Das XML ist nicht valid!";

  public static final String MSG_SCHUTIT_NOT_FOUND = "Schutztitel konnte nicht gefunden werden! Gesuchs_nr: ";

  public static final String MSG_SCHUTIT_NOT_EXIST = "Der Schutztitel existiert nicht in BAGIS!";

  public static final String MSG_IPC_CLASSES_NOT_ADDED = "Die IPC-Klassen aus BAGIS konnten nicht hinzu gefügt werden!";

  public static final String MSG_NO_MAIN_CLASS = "Es existiert keine gültige Hauptklasse!";

  public static final String MSG_NO_INSERT = "Der Recherchebericht konnte nicht in BAGIS geschrieben werden!";

  private int srType;

  private int processState;

  private String xml;

  private String filePath;

  private String filePathProessed;

  private String errorMsg;

  public SearchReportFileVO()
  {
    this.errorMsg = "";
  }

  public SearchReportFileVO( String xml, int srType, int procesState, String filePath )
  {
    this();
    this.xml = xml;
    this.srType = srType;
    this.processState = procesState;
    this.filePath = filePath;
  }

  /**
   * Gets the process_state.
   * @return the process_state
   */
  public int getProcessState()
  {
    return this.processState;
  }

  /**
   * Sets the process_state.
   * @param processState The processState to set
   */
  public void setProcessState( int processState )
  {
    this.processState = processState;
  }

  /**
   * Gets the srType.
   * @return the srType
   */
  public int getSrType()
  {
    return this.srType;
  }

  /**
   * Sets the srType.
   * @param srType The srType to set
   */
  public void setSrType( int srType )
  {
    this.srType = srType;
  }

  /**
   * Gets the xml.
   * @return the xml
   */
  public String getXml()
  {
    return this.xml;
  }

  /**
   * Sets the xml.
   * @param xml The xml to set
   */
  public void setXml( String xml )
  {
    this.xml = xml;
  }

  /**
   * Gets the filePath.
   * @return the filePath
   */
  public String getFilePath()
  {
    return this.filePath;
  }

  /**
   * Gets the Path for the processed Files.
   * @return the filePath
   */
  public String getFilePathProcessed()
  {
    return this.filePathProessed;
  }

  /**
   * Sets the Path for the processed Files.
   * @param path Filepath of the report.
   */
  public void setFilePathProcessed( String path )
  {
    this.filePathProessed = path;
  }

  /**
   * Gets the errorMsg.
   * @return the errorMsg
   */
  public String getErrorMsg()
  {
    return this.errorMsg;
  }

  /**
   * Sets the errorMsg.
   * @param errorMsg The errorMsg to set
   */
  public void setErrorMsg( String errorMsg )
  {
    if ( !errorMsg.equals( "" ) )
    {
      this.processState = PROCESS_STATE_FAILED;
    }
    this.errorMsg = errorMsg;
  }

} // end class
