package ch.ige.ses.client.batch;

/**
 * Klasse für Batch Exception Handling.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: BatchException.java,v 1.5 2006/12/11 12:43:34 iten Exp $
 */
public class BatchException extends Exception
{
  private String fErrorNr  = null;
  private String fErrorMsg = null;


  public BatchException(String errorNr, String errorMsg)
  {
    super();
    fErrorNr  = errorNr;
    fErrorMsg = errorMsg;
  }


  /**
   * extend super function with error number nad error message
   *
   * @return String   error information and original message
   */
  public String getMessage()
  {
    return (getErrorNr() + "\n" + getErrorMsg() + "\n" + super.getMessage());
  }


  public String getErrorNr()
  {
    return fErrorNr;
  }


  public String getErrorMsg()
  {
    return fErrorMsg;
  }

} // end class


