package ch.ige.ses.client.sapinbound;

import com.sap.mw.jco.*;

/**
 * SAP Remote Function Module RFC_SYSTEM_INFO
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: RFM_RFC_SYSTEM_INFO.java,v 1.6 2006/12/11 12:43:32 iten Exp $
 */
public class RFM_RFC_SYSTEM_INFO extends RFM
{

  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------
  public RFM_RFC_SYSTEM_INFO(IRepository repository)
  {
    super("RFC_SYSTEM_INFO",repository);
  }


  //---------------------------------------------------------------------------
  // methods
  //---------------------------------------------------------------------------
  public String toStringExport()
  {
    JCO.ParameterList output = this.fJCoFunc.getExportParameterList();
    StringBuffer      buf    = new StringBuffer();

    for (int i = 0; i < output.getFieldCount(); i++)
      buf.append ( output.getName(i) + "\t = " + output.getString(i) + "\n");

    return buf.toString();
  }


  public String toStringRFCSI()
  {
    JCO.Structure s   = this.fJCoFunc.getExportParameterList().getStructure("RFCSI_EXPORT");
    StringBuffer  buf = new StringBuffer();

    for (JCO.FieldIterator e = s.fields(); e.hasMoreElements(); )
    {
      JCO.Field field = e.nextField();
      buf.append(field.getName() + "\t = " + field.getString() + "\n");
    }

    return buf.toString();
  }


} // end class


