package ch.ige.ses.client.sapinbound;

import org.apache.log4j.*;
import ch.ige.ses.client.saputil.*;
import com.sap.mw.jco.*;

/**
 * SAP Remote Function Module Z_BAPI_ZVL_COMMIT_TM_EXTENSION
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: RFM_Z_BAPI_ZVL_COMMIT_TM_EXTENSION.java,v 1.4 2006/12/11 12:43:32 iten Exp $
 */

public class RFM_Z_BAPI_ZVL_COMMIT_TM_EXTENSION extends RFM
{
  //
  // const
  //
  private static final Logger LOG = Logger.getLogger(RFM_Z_BAPI_ZVL_COMMIT_TM_EXTENSION.class);

  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  public RFM_Z_BAPI_ZVL_COMMIT_TM_EXTENSION(IRepository repository)
  {
    super("Z_BAPI_ZVL_COMMIT_TM_EXTENSION",repository);
  }

  //---------------------------------------------------------------------------
  // public methods
  //---------------------------------------------------------------------------

  public void addSeqNumber(String amvLaufNr)
  {
    try
    {
      this.setImportParam(amvLaufNr);

    }
    catch (Exception ex)
    {
      LOG.error("exception: " + ex.toString());
      throw new RfmException(ex.toString());
    }
  }


  public String toStringSeqNumber()
  {
    JCO.ParameterList in  = this.fJCoFunc.getImportParameterList();
    StringBuffer      buf = new StringBuffer();

    // import params
    buf.append(in.toString());

    return buf.toString();
  }

  //---------------------------------------------------------------------------
  // private methods
  //---------------------------------------------------------------------------

  private void setImportParam(String amvLaufNr)
  {
    JCO.ParameterList input = this.fJCoFunc.getImportParameterList();

    input.setValue(amvLaufNr,"TM_EXT_SEQ_NO");
  }


} // end class

