package ch.ige.ses.client.saputil.test;

import junit.framework.*;

import ch.ige.ses.client.saputil.ConvertCountry;

/**
 * Test der Klasse BfaktposSESDAO
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: ConvertCountryTest.java,v 1.6 2006/12/11 12:43:36 iten Exp $
 */
public class ConvertCountryTest extends TestCase
{

  public ConvertCountryTest(String s)
  {
    super(s);
  }

  public void testCH()
  {
    assertEquals(ConvertCountry.testConversion("CH"), "CH");
  }

  public void testDtoDE()
  {
    assertEquals(ConvertCountry.testConversion("D"), "DE");
  }

  public void testEtoES()
  {
    assertEquals(ConvertCountry.testConversion("E"), "ES");
  }

  public void testFRtoFO()
  {
    assertEquals(ConvertCountry.testConversion("FR"), "FO");
  }

  public void testItoIT()
  {
    assertEquals(ConvertCountry.testConversion("I"), "IT");
  }

  public void testUSAtoUS()
  {
    String country   = "USA";
    String stringRet = ConvertCountry.testConversion(country);
    assertEquals("'USA' in Bagis entspricht 'US' in SAP", "US", stringRet);
  }

  public void testXUtoCZ()
  {
    assertEquals(ConvertCountry.testConversion("XU"), "CZ");
  }

  public void testYDtoYE()
  {
    assertEquals(ConvertCountry.testConversion("YD"), "YE");
  }

  public void testRHtoZW()
  {
    assertEquals(ConvertCountry.testConversion("RH"), "ZW");
  }

  public void testJtoJP()
  {
    assertEquals(ConvertCountry.testConversion("J"), "JP");
  }


} // end class

