package ch.ige.ses.server.dao.ses;

import java.sql.*;
import ch.ige.ses.*;
import ch.ige.ses.server.dao.bagis.*;
import ch.ige.util.server.*;

/**
 * Data Access Objekt für DB-Meta-Daten.
 *
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Marc Bouquet; Johannes Lang
 * @version $Id: InfoDAO.java,v 1.6 2006/12/13 14:54:56 iten Exp $
 */
public class InfoDAO
{
  /**
   * Standard-Konstruktor
   */
  public InfoDAO()
  {
    // lazy bone
  }

  /**
   * Holt die Meta-Daten der SES-Datenbank.
   *
   * @return url URL der SES-Datenbank
   * @throws SQLException Unerwarteter SQL-Fehler
   */
  public String getSESDbURL() throws SQLException
  {
    Connection  con = null;
    String      url = "undefined";

    try
    {
      con = DBHelper.getConnection(DBHelper.SES);
      url = con.getMetaData().getURL();

      return url;
    }
    finally
    {
      DBHelper.close(con);
    }
  }

  /**
   * Gibt die Server-Version SES bekannt.
   *
   * @return String Versions-Nummer
   */
   public String getSESVersion()
   {
     return BuildInfo.CVS_TAG + " - " + BuildInfo.BUILD_ID;
   }
}

