/*
 * Generated by XDoclet - Do not edit!
 */
package ch.ige.ses.server.monitor;

/**
 * Remote interface for MonitorCtrl.
 * @wtp generated
 */
public interface MonitorCtrl
   extends javax.ejb.EJBObject
{
   /**
    * Gibt die Meta-Daten von der SES-DB zurück.
    * @return String URL
    */
   public java.lang.String getSESDbUrl(  )
      throws java.rmi.RemoteException;

   /**
    * Gibt die Version zurück (muss von Hand nachgetragen werden)
    * @return String Version
    */
   public java.lang.String getSESVersion(  )
      throws java.rmi.RemoteException;

   /**
    * Gibt das Value Object der Rechnung zurück.
    * @param bfaktId Rechnungsnummer
    * @param jgbLaufId Id des Jahresgebührenlaufs
    * @return ValueObject der Rechnung
    */
   public ch.ige.ses.vo.bagis.SAPRechnungVO getRechnung( int bfaktId,int jgbLaufId )
      throws java.rmi.RemoteException;

   /**
    * Selektiert diverse Attribute der Rechnungen die den Selektionskriterien entsprechen. Rechnuungen werden in der Sortierreihenfolge der Jahresgebühren zurückgegeben
    * @param sapRechnungVO Value Object mit Selektionskriterien Rechnungs-Daten & Rechnungsempfänger
    * @return ArrayList von SAPRechnungVOs mit integrierten Rechnungempfänger(SAPJGBParamVO)
    */
   public java.util.ArrayList findSESRechnungen( ch.ige.ses.vo.bagis.SAPRechnungVO sapRechnungVO )
      throws java.rmi.RemoteException;

   /**
    * Selektiert alle Rechnungen aus der Tabelle bfaktur_ses die den Selektionskriterien entsprechen
    * @param sapRechnungVO Value Object mit Selektionskriterien
    * @return ArrayList von SAPRechnungVOs
    */
   public java.util.ArrayList findBfakturen( ch.ige.ses.vo.bagis.SAPRechnungVO sapRechnungVO )
      throws java.rmi.RemoteException;

   /**
    * Selektiert die grösste bfakt_id des gewünschtes Laufes aus der Tabelle bfaktur_ses
    * @param jgbLaufId lauf_id eines Jahresgebühren Laufes
    * @return grösste bfakt_id des ensprechenden Laufes
    */
   public int getMaxBfaktId( int jgbLaufId )
      throws java.rmi.RemoteException;

   /**
    * Selektiert die kleinste bfakt_id des gewünschten Laufes aus der Tabelle bfaktur_ses
    * @param jgbLaufId lauf_id eines Jahresgebühren Laufes
    * @return kleinste bfakt_id des entsprechenden Laufes
    */
   public int getMinBfaktId( int jgbLaufId )
      throws java.rmi.RemoteException;

   /**
    * Selektiert alle Datensätze eines JGB-Laufes aus der Tabelle bfaktur_ses mit einem bestimmten Verarbeitungsstatus
    * @param jgbLaufId Lauf-Id des JGB-Laufes
    * @param statusVerarbeitung Verarbeitungsstatus
    * @return Liste von SapRechnungV0s
    */
   public java.util.ArrayList findStatusVerarbList( int jgbLaufId,java.lang.String statusVerarbeitung )
      throws java.rmi.RemoteException;

   /**
    * Gibt die Anzahl Bfakturen pro Verarbeitungsstatus eines JGB - Laufes zurück
    * @param jgbLaufId Jahresgebühren - Lauf
    * @return Anzahl Datensätze pro Verarbeitungsstatus
    */
   public java.util.HashMap countStatusVerarbeitung( int jgbLaufId )
      throws java.rmi.RemoteException;

   /**
    * Gibt eine ArrayList von BfaktIds mit einem bestimmten Verarbeitungsstatus eines Jahresgebühren - Laufes zurück
    * @param jgbLaufId JGB-Lauf
    * @param statusVerarbeitung Verarbeitungsstatus
    * @return ArrayList von bfaktIds
    */
   public java.util.ArrayList findBfaktIds( int jgbLaufId,java.lang.String statusVerarbeitung )
      throws java.rmi.RemoteException;

   /**
    * Verarbeitungstatus wird zurückgesetzt von 'E' auf '0' Die Zähler des JGB-Laufes werden pro Update wie folgt aktualisiert anzahl_bfaktur_an_sap: -1 anzahl_bfaktur_an_sap_nok: -1 anzahl_bfaktur_an_sap_ok: nichts anzahl_bfaktjgb_an_sap_ok: -anzahl Rechnungsempfänger
    * @param sapRechnungVO Array von SAPREechnungVO's
    * @return Anzahl upgedatete Datensätze
    */
   public int updateStatusVerarbeitung( ch.ige.ses.vo.bagis.SAPRechnungVO[] sapRechnungVO )
      throws java.rmi.RemoteException;

   /**
    * Neuen Datensatz in Tabelle Property einfügen
    * @param propertyVO Value Object mit den Property-Daten
    */
   public void createProperty( ch.ige.ses.vo.ses.PropertyVO propertyVO )
      throws java.rmi.RemoteException;

   /**
    * Datensatz der Tabelle Property via key selektieren
    * @param key PK
    * @return Value Object mit den Property-Daten
    */
   public ch.ige.ses.vo.ses.PropertyVO getProperty( java.lang.String key )
      throws java.rmi.RemoteException;

   /**
    * Alle Datensätze der Tabelle Property selektieren
    * @return ArrayList von PropertyVOs
    */
   public java.util.ArrayList findProperties(  )
      throws java.rmi.RemoteException;

   /**
    * Datensatz der Tabelle Property updaten
    * @param propertyVO Value Object mit den Property-Daten
    */
   public void setProperty( ch.ige.ses.vo.ses.PropertyVO propertyVO )
      throws java.rmi.RemoteException;

   /**
    * Datensatz der Tabelle Property löschen
    * @param key PK
    */
   public void deleteProperty( java.lang.String key )
      throws java.rmi.RemoteException;

   /**
    * Alle Datensätze der Tabelle Error selektieren die den Selektionskriterien entsprechen
    * @param errorSelKritVO enthält Selektionskriterien
    * @return ArrayList von ErrorVOs
    */
   public java.util.ArrayList findErrors( ch.ige.ses.vo.ses.ErrorSelKritVO errorSelKritVO )
      throws java.rmi.RemoteException;

   /**
    * Datensatz der Tabelle Error via key selektieren
    * @param errorId PK
    * @return Value Object mit den Error-Daten
    */
   public ch.ige.ses.vo.ses.ErrorVO getError( int errorId )
      throws java.rmi.RemoteException;

   /**
    * Datensatz der Tabelle Error updaten
    * @param errorVO Value Object mit den Property-Daten
    */
   public void setError( ch.ige.ses.vo.ses.ErrorVO errorVO )
      throws java.rmi.RemoteException;

   /**
    * Alle Datensätze der Tabelle JGB_Lauf selektieren
    * @return ArrayList von JGBLaufVOs
    */
   public java.util.ArrayList findJGBLauf(  )
      throws java.rmi.RemoteException;

   /**
    * Einen Datensätze der Tabelle JGB_Lauf selektieren
    * @param jgbLaufNr Lauf-Nummer
    * @return JGBLaufVO
    */
   public ch.ige.ses.vo.ses.JGBLaufVO getJGBLauf( java.lang.String jgbLaufNr )
      throws java.rmi.RemoteException;

   /**
    * Einen Datensätze der Tabelle JGB_Lauf updaten
    * @param jgbLaufVO Daten des Laufes
    * @return Anzahl veränderter Datensätze
    */
   public int setJGBLauf( ch.ige.ses.vo.ses.JGBLaufVO jgbLaufVO )
      throws java.rmi.RemoteException;

   /**
    * Alle Datensätze der Tabelle STAKO_KONTROLLE selektieren
    * @return ArrayList von StakoKontrolleVO's
    */
   public java.util.ArrayList findStakoKontrolle(  )
      throws java.rmi.RemoteException;

   /**
    * Einen Datensätze der Tabelle STAKO_KONTROLLE selektieren
    * @param stakoKontrolleId Verarbeitungsnummer
    * @return StakoKontrolleVO
    */
   public ch.ige.ses.vo.ses.StakoKontrolleVO getStakoKontrolle( int stakoKontrolleId )
      throws java.rmi.RemoteException;

   /**
    * Einen Datensätze der Tabelle STAKO_KONTROLLE updaten
    * @param stakoKontrolleVO Daten des Laufes
    * @return Anzahl veränderter Datensätze
    */
   public int setStakoKontrolle( ch.ige.ses.vo.ses.StakoKontrolleVO stakoKontrolleVO )
      throws java.rmi.RemoteException;

   /**
    * Alle Datensätze der Tabelle Trace selektieren die den Selektionskriterien entsprechen
    * @param traceSelKritVO enthält Selektionskriterien
    * @return ArrayList von TraceVOs
    */
   public java.util.ArrayList findTraces( ch.ige.ses.vo.ses.TraceSelKritVO traceSelKritVO )
      throws java.rmi.RemoteException;

   /**
    * Löscht alle Datensaetze die aelter als die übergebene Anzahl Tage sind
    * @param days Anzahl Tage
    * @return Anzahl gelöschte Rows
    */
   public int deleteTraces( int days )
      throws java.rmi.RemoteException;

   /**
    * Gibt die Fehlerliste eines Jahresgebühren Laufes als String zurück
    * @param jgbLaufId Lauf-Id eines Jahresgebühren-Laufes
    * @return Fehlerliste als String
    */
   public java.lang.String getProtokoll( int jgbLaufId )
      throws java.rmi.RemoteException;

   /**
    * Gibt die Statistik eines Jahresgebühren Laufes als String zurück Falls eine Neuberechnung gewünscht wird oder noch keine Statistikberechnung für diesen Lauf durchgeführt wurde, wird eine Berechnung ausgelöst und diese in der SES-DB gespeichert. Ansonsten wird die letzte Berechnung zurückgegeben
    * @param jgbLaufId Lauf-Id eines Jahresgebühren-Laufes
    * @param newcalc true -> Neuberechnung durchführen
    * @return Statistik als String
    */
   public java.lang.String getStatistik( int jgbLaufId,boolean newcalc )
      throws java.rmi.RemoteException;

   /**
    * Aktualisiert bei der JGB Verarbeitung den Status druck auf BAGIS von 3 (bereit zum Druck JGB) auf 1 (bereit zum Druck), sobald der Datensatz von BAGIS nach SES übertragen wurde.
    * @param vo Rechnungsdaten
    * @throws Exception Unerwarteter Fehler
    */
   public void setBfakturStatusDruck( ch.ige.ses.vo.bagis.SAPRechnungVO vo )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Alle Datensätze der Tabelle AMV_Lauf selektieren
    * @return ArrayList von AmvLaufVOs
    */
   public java.util.ArrayList findAmvLauf(  )
      throws java.rmi.RemoteException;

   /**
    * Einen Datensätze der Tabelle AMV_Lauf selektieren
    * @param amvLaufNr Lauf-Nummer
    * @return AmvLaufVO
    */
   public ch.ige.ses.vo.ses.AmvLaufVO getAmvLauf( java.lang.String amvLaufNr )
      throws java.rmi.RemoteException;

   /**
    * Einen Datensätze der Tabelle AMV_Lauf selektieren
    * @param amvLaufId Lauf-Nummer
    * @return AmvLaufVO
    */
   public ch.ige.ses.vo.ses.AmvLaufVO getAmvLauf( int amvLaufId )
      throws java.rmi.RemoteException;

   /**
    * Selektiert alle Einträge der Tabelle AMV_RECHNUNG die den Selektionskriterien entsprechen
    * @param amvRechnungSelKritVO ValueObject mit Selektionskriterien
    * @return ArrayList von AmvRechnungVOs
    */
   public java.util.ArrayList findAmvRechnungen( ch.ige.ses.vo.ses.AmvRechnungSelKritVO amvRechnungSelKritVO )
      throws java.rmi.RemoteException;

   /**
    * Holt alle Daten einer Amv-Rechnung aus der Tabllen AMV_RECHNUNG
    * @param amvLaufId PK AmvLauf
    * @param rechnungCd PK Rechnungstyp
    * @param bfaktId PK Rechnungsnummer
    * @return AmvRechnungVO mit Rechnungs-Informationen
    */
   public ch.ige.ses.vo.ses.AmvRechnungVO getAmvRechnung( int amvLaufId,int rechnungCd,int bfaktId )
      throws java.rmi.RemoteException;

   /**
    * Selektiert pro Verarbeitungsstatus die summierte Anzahl Rechnungsempfänger
    * @param amvLaufId Lauf Id
    * @param rechnungCd Erinnerungstyp
    * @return Map beinhaltet summierten Rechnungsempfänger pro Verarbeitungsstatus
    */
   public java.util.Map getStatCounters( int amvLaufId,int rechnungCd )
      throws java.rmi.RemoteException;

}
