package ch.ige.ses.server.monitor.test;

import java.util.*;

import org.apache.log4j.BasicConfigurator;

import junit.framework.*;

import ch.ige.ses.server.monitor.*;
import ch.ige.ses.vo.ses.*;
import ch.ige.util.*;
import ch.ige.ses.vo.bagis.*;


/**
 * Testcase MonitorCtrlBean
 * <p>
 * Copyright (c) 2001-2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author A.Rueegsegger
 * @version $Id: MonitorCtrlBeanTest.java,v 1.14 2007/01/10 08:57:41 iten Exp $
 */
public class MonitorCtrlBeanTest extends TestCase
{
  //
  // fields
  //
  private MonitorCtrlHome monitorCtrlHome = null;
  private MonitorCtrl     monitorCtrl = null;

  //---------------------------------------------------------------------------
  // constructor
  //---------------------------------------------------------------------------

  public MonitorCtrlBeanTest(String parName)
  {
    super (parName);
    
    // init log4j
    BasicConfigurator.configure();    
  }

  //---------------------------------------------------------------------------
  // init / clean-up
  //---------------------------------------------------------------------------

  public static Test suite()
  {
    return new TestSuite(MonitorCtrlBeanTest.class);
  }

  protected void setUp()
  {
    getFacade();
  }

  protected void tearDown()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // tests
  //---------------------------------------------------------------------------

  public void testDummy()
  {
    /** TODO junit - testfälle junit tauglich machen */
    assertEquals(true,true);
  }


  public void _testUpdateStatusVerarbeitung()
  {
    System.out.println("TEST Update Status");

    final int COUNTER = 1;
    int anzahlRechEmpf = 4;
    SAPRechnungVO[] sapRechnungVO = new SAPRechnungVO[COUNTER];

    try
    {
      ArrayList al_old = monitorCtrl.findStatusVerarbList(670, "E");

      for (int i = 0; i < COUNTER; i++)
      {
        sapRechnungVO[i] = (SAPRechnungVO)al_old.get(i);
        sapRechnungVO[i].bfakt_id = 10411299;
      }

      JGBLaufVO jgbLaufVO_old = monitorCtrl.getJGBLauf("2003050201");

      // Methodentest
      int i = monitorCtrl.updateStatusVerarbeitung(sapRechnungVO);
      System.out.println("Anzahl Updates: " + i);

      ArrayList al_new = monitorCtrl.findStatusVerarbList(670, "E");
      JGBLaufVO jgbLaufVO_new = monitorCtrl.getJGBLauf("2003050201");

      assertEquals(al_new.size(), al_old.size() - COUNTER);
      assertEquals(jgbLaufVO_new.anzahlBfakturAnSap, jgbLaufVO_old.anzahlBfakturAnSap - COUNTER);
      assertEquals(jgbLaufVO_new.anzahlBfakturAnSapNok, jgbLaufVO_old.anzahlBfakturAnSapNok - COUNTER);
      assertEquals(jgbLaufVO_new.anzahlBfakturAnSapOk, jgbLaufVO_old.anzahlBfakturAnSapOk);
      assertEquals(jgbLaufVO_new.anzahlBfaktjgbAnSap, jgbLaufVO_old.anzahlBfaktjgbAnSap - anzahlRechEmpf);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  //---------------------------------------------------------------------------
  // private methods
  //---------------------------------------------------------------------------

  private void getFacade()
  {
    try
    {
      if (monitorCtrlHome == null)
      {
        monitorCtrlHome =  (MonitorCtrlHome)
             ServiceLocator.getInstance().getHome(MonitorCtrlHome.JNDI_NAME, MonitorCtrlHome.class);
      }
      if (monitorCtrl == null)
      {
        monitorCtrl = monitorCtrlHome.create();
      }
    }
    catch (Exception ex)
    {
      fail(ex.toString());
    }
  }

} // end class

