package ch.ige.ses.server.sapctrl;

import javax.ejb.EJBException;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.apache.log4j.Logger;

/**
 * Helper class for Bean Interface Lookup within other EJB's.
 * <p>
 * Copyright (c) 2007, Eidgenössisches Institut für Geistiges Eigentum
 * 
 * @author T. Iten
 * @version $Id: SapInboundCtrlLookup.java,v 1.1 2007/01/03 14:28:28 iten Exp $
 */
public class SapInboundCtrlLookup
{
  //
  // const
  //
  private static final Logger LOG = Logger.getLogger( SapInboundCtrlLookup.class );

  //
  // fields
  //
  private SapInboundCtrlLocalHome localHomeInterface = null;

  private SapInboundCtrlLocal localInterface = null;

  // ---------------------------------------------------------------------------
  // constructors
  // ---------------------------------------------------------------------------

  /**
   * create instance
   */
  public SapInboundCtrlLookup()
  {
    // lazy bone
  }

  // ---------------------------------------------------------------------------
  // methods
  // ---------------------------------------------------------------------------

  /**
   * get local interface with lazy loading
   * 
   * @return SapInboundCtrlLocal
   */
  public SapInboundCtrlLocal getLocalInterface()
  {
    try
    {
      if ( localInterface == null )
      {
        Context ctx = new InitialContext();
        Object ref = ctx.lookup( SapInboundCtrlLocalHome.COMP_NAME );

        localHomeInterface = (SapInboundCtrlLocalHome) ref;
        localInterface = localHomeInterface.create();
      }

      return localInterface;
    }
    catch ( Exception ex )
    {
      localHomeInterface = null;
      localInterface = null;

      LOG.error( "getLocalInterface - Exception: " + ex.getMessage() );
      throw new EJBException( ex );
    }
  }

} // end class

