package ch.ige.ses.util;

import java.util.*;
import ch.ige.ses.vo.ses.*;
import ch.ige.ses.vo.bagis.*;


/**
 * <p>Ist für den Aufbau der Mappings key - values zuständig.
 * Alle zusammengehörenden Einträge werden in einer HashMap abgelegt</p>
 * <p>key: Datenbank-Wert</p>
 * <p>value: Definiton des Datenbank-Wertes</p>
 * <p>Copyright: Copyright (c) 2001-2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author T.Iten, A.Rüegsegger
 * @version $Id: DBValues.java,v 1.28 2006/12/11 12:43:32 iten Exp $
 */

public class DBValues
{

  public static DBValuesMap sprachCd = new DBValuesMap();
  public static DBValuesMap druckArt = new DBValuesMap();
  public static DBValuesMap statusZahlg = new DBValuesMap();
  public static DBValuesMap lageinh = new DBValuesMap();
  public static DBValuesMap absageGrund = new DBValuesMap();
  public static DBValuesMap dataTypeCd = new DBValuesMap();
  public static DBValuesMap errorStat = new DBValuesMap();
  public static DBValuesMap sapStat = new DBValuesMap();
  public static DBValuesMap sesStat = new DBValuesMap();
  public static DBValuesMap statusVerarbeitung = new DBValuesMap();
  public static DBValuesMap druckperi = new DBValuesMap();
  public static DBValuesMap listenart = new DBValuesMap();
  public static DBValuesMap employeeNotify = new DBValuesMap();
  public static DBValuesMap employeeMsgType = new DBValuesMap();
  public static DBValuesMap statusDruck = new DBValuesMap();
  public static DBValuesMap modus = new DBValuesMap();
  public static DBValuesMap stakoStat = new DBValuesMap();
  public static DBValuesMap herkunftStat = new DBValuesMap();
  public static DBValuesMap amvLaufStat = new DBValuesMap();
  public static DBValuesMap amvRechnungStat = new DBValuesMap();
  public static DBValuesMap amvRechnungCd = new DBValuesMap();

  static
  {
    sprachCd.put("D", "Deutsch");
    sprachCd.put("F", "Französisch");
    sprachCd.put("E", "Englisch");
    sprachCd.put("I", "Italienisch");
    sprachCd.put("USA", "Englisch(USA)");

    statusVerarbeitung.put(SAPRechnungVO.STATUS_VERARBEITUNG_NEW, "Neu");
    statusVerarbeitung.put(SAPRechnungVO.STATUS_VERARBEITUNG_SAP, "An Sap übertragen");
    statusVerarbeitung.put(SAPRechnungVO.STATUS_VERARBEITUNG_PRINTED, "Gedruckt");
    statusVerarbeitung.put(SAPRechnungVO.STATUS_VERARBEITUNG_ERROR, "Error");

    lageinh.put("ANZ", "Anzahl");
    lageinh.put("15'", "15 Min");
    lageinh.put("STD", "Stunden");
    lageinh.put("STK", "Stück");

    // TABELLE BFAKTJGB_SES
    druckperi.put("0", "Einzelne Empfänger");
    druckperi.put("1", "Druckperiode 1");
    druckperi.put("2", "Druckperiode 2");
    druckperi.put("3", "Blum");
    druckperi.put("4", "Druckperiode 4");
    druckperi.put("5", "Stundungen und IGE Adressen");
    druckperi.put("6", "Druckperiode 6");
    druckperi.put("7", "Druckperiode 7");
    druckperi.put("8", "Druckperiode 8");
    druckperi.put("9", "Postfach IGE");

    listenart.put("0", "kein Bordereau");
    listenart.put("1", "PTT Liste zum Zahlungsauftrag");
    listenart.put("2", "Belastaungsauftrag Kontokorrent");
    listenart.put("5", "kein Schreiben, PTT Liste zum Zahlungsauftrag");
    listenart.put("6", "kein Schreiben, Belastaungsauftrag Kontokorrent");
    listenart.put("7", "kein Schreiben");

    // TABELLE JGB_LAUF
    sesStat.put(new Integer(JGBLaufVO.SES_STAT_STARTED).toString(),     "gestartet");
    sesStat.put(new Integer(JGBLaufVO.SES_STAT_REQUEST_STOP).toString(),"abbrechen markiert");
    sesStat.put(new Integer(JGBLaufVO.SES_STAT_STOPPED).toString(),     "abgebrochen");
    sesStat.put(new Integer(JGBLaufVO.SES_STAT_FINISHED).toString(),    "beendet");

    sapStat.put(new Integer(JGBLaufVO.SAP_STAT_NOT_STARTED).toString(), "noch nicht gestartet");
    sapStat.put(new Integer(JGBLaufVO.SAP_STAT_STARTED).toString(),     "gestartet");
    sapStat.put(new Integer(JGBLaufVO.SAP_STAT_STARTED_LAST).toString(),"gestartet letzter Job");
    sapStat.put(new Integer(JGBLaufVO.SAP_STAT_STOPPED).toString(),     "abgebrochen");
    sapStat.put(new Integer(JGBLaufVO.SAP_STAT_FINISHED).toString(),    "beendet");

    // Tabelle STAKO_KONTROLLE
    stakoStat.put(new Integer(StakoKontrolleVO.STATUS_VERARBEITUNG_STARTED).toString(), "gestartet");
    stakoStat.put(new Integer(StakoKontrolleVO.STATUS_VERARBEITUNG_CANCELLED).toString(), "abgebrochen");
    stakoStat.put(new Integer(StakoKontrolleVO.STATUS_VERARBEITUNG_FINISHED).toString(), "beendet");
    stakoStat.put(new Integer(StakoKontrolleVO.STATUS_VERARBEITUNG_FINISHED_WITH_ERRORS).toString(),"beendet mit Fehler");

    herkunftStat.put(new Integer(StakoKontrolleVO.STATUS_HERKUNFT_NOTHING_SAVED).toString(), "keine Herkunft");
    herkunftStat.put(new Integer(StakoKontrolleVO.STATUS_HERKUNFT_MITARBEITER_SAVED).toString(), "Herkunft MA/Ereignis");
    herkunftStat.put(new Integer(StakoKontrolleVO.STATUS_HERKUNFT_ALL_SAVED).toString(), "Beide Herkünfte");

    // TABELLE ERROR
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_NO_DATA).toString(),         "Keine Daten vorhanden");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_STRING).toString(),          "String");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_SAP_RECHNUNG_VO).toString(), "SAPRechnungVO");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_SAP_RECHNUNG_ANNULATION_VO).toString(), "SAPRechnungAnnullationVO");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_SAP_RECHNUNG_STATUS_LIST_VO).toString(), "SAPRechnungStatusListVO");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_SAP_JGB_JOB_VO).toString(),  "SAPJGBJobVO");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_SAP_VERS_ADR_VO).toString(),  "VersadrVO");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_SAP_ADR_STATUS_VO).toString(),  "SAPAdrStatusVO");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_STAKO_VO).toString(),  "StakoVO");
    dataTypeCd.put(new Integer(ErrorVO.DATA_TYPE_CD_SAP_STAKO_JOB_VO).toString(),  "StakoJobVO");

    errorStat.put(new Integer(ErrorVO.ERROR_STAT_PENDENT).toString(),   "Pendent");
    errorStat.put(new Integer(ErrorVO.ERROR_STAT_ERLEDIGT).toString(),  "Erledigt");
    errorStat.put(new Integer(ErrorVO.ERROR_STAT_ANNULIERT).toString(), "Annuliert");

    employeeNotify.put(new Integer(ErrorVO.EMPL_NOTIFY_KEINE).toString(),         "Keine");
    employeeNotify.put(new Integer(ErrorVO.EMPL_NOTIFY_PENDENT).toString(),       "Pendent");
    employeeNotify.put(new Integer(ErrorVO.EMPL_NOTIFY_BENACHRICHTIGT).toString(),"Benachrichtigt");

    employeeMsgType.put(new Integer(ErrorVO.EMPL_MSG_TYPE_DEFAULT).toString(),  "Default");
    employeeMsgType.put(new Integer(ErrorVO.EMPL_MSG_TYPE_MAX_EMPF).toString(), "Mehr als MAX_EMPFAENGER");
    employeeMsgType.put(new Integer(ErrorVO.EMPL_MSG_TYPE_RECHNUNG).toString(), "Rechnung");
    employeeMsgType.put(new Integer(ErrorVO.EMPL_MSG_TYPE_JGB).toString(),      "Jahresgebühr");
    employeeMsgType.put(new Integer(ErrorVO.EMPL_MSG_TYPE_ADR).toString(),      "Adresse");

    // VO
    absageGrund.put("9", "Annuliert");
    absageGrund.put("A", "Frist abgelaufen");

    statusZahlg.put("2", "Storniert");
    statusZahlg.put("4", "Bezahlt");
    statusZahlg.put("9", "Annulliert(manuell)");
    statusZahlg.put("A", "Frist abgelaufen(massnahme)");

    druckArt.put("1", "Sofort drucken");
    druckArt.put("2", "Batchdruck");
    druckArt.put("3", "Druck Patent JGB Rechnung");
    druckArt.put("4", "Druck Patent JGB Mahnung");
    druckArt.put("5", "Löschungsanzeige");

    statusDruck.put("9", "Gedruckt");

    modus.put(new Integer(SAPStakoJobVO.STAKO_MODUS_START).toString(), "Verarbeitung Start");
    modus.put(new Integer(SAPStakoJobVO.STAKO_MODUS_RESTART).toString(), "Verarbeitung Restart");
    modus.put(new Integer(SAPStakoJobVO.STAKO_MODUS_UPDATE).toString(), "Update Artikel");
    modus.put(new Integer(SAPStakoJobVO.STAKO_MODUS_NOUPDATE).toString(), "Stakoprozess");

    amvLaufStat.put(new Integer(AmvLaufVO.LAUF_STAT_STARTED).toString(), "Verarbeitung gestartet");
    amvLaufStat.put(new Integer(AmvLaufVO.LAUF_STAT_SELECTED).toString(), "Rechnungsnummern selektiert");
    amvLaufStat.put(new Integer(AmvLaufVO.LAUF_STAT_SENT).toString(), "Rechnungsdaten gesendet");
    amvLaufStat.put(new Integer(AmvLaufVO.LAUF_STAT_STOPPED).toString(), "Verarbeitung mit Fehler gestoppt");
    amvLaufStat.put(new Integer(AmvLaufVO.LAUF_STAT_FINISHED).toString(), "Verarbeitung erfolgreich beendet");

    amvRechnungStat.put(new Integer(AmvRechnungVO.RE_STAT_SELECTED).toString(), "Rechnungsnummer selektiert");
    amvRechnungStat.put(new Integer(AmvRechnungVO.RE_STAT_SENT).toString(), "Rechnungsdaten gesendet");
    amvRechnungStat.put(new Integer(AmvRechnungVO.RE_STAT_SAP_OK).toString(),  "Rechnung erfolgreich in SAP");
    amvRechnungStat.put(new Integer(AmvRechnungVO.RE_STAT_SAP_ERROR).toString(), "Rechnung mit Fehler");
    amvRechnungStat.put(new Integer(AmvRechnungVO.RE_STAT_SUPPRESS_E2).toString(), "Rechnung ignoriert");

    amvRechnungCd.put(new Integer(AmvRechnungVO.RE_CD_ERINNERUNG_1).toString(), "Erinnerung 1");
    amvRechnungCd.put(new Integer(AmvRechnungVO.RE_CD_ERINNERUNG_2).toString(), "Erinnerung 2");
  }
}


