package ch.ige.ses.util;

import javax.jms.*;

/**
 * Java Message Service - Common settings for sender and receiver
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: Jms.java,v 1.18 2006/12/29 09:05:47 iten Exp $
 */
public class Jms
{
  //---------------------------------------------------------------------------
  // const
  //---------------------------------------------------------------------------

  // factory & queue names
  public static final String  JNDI_JMS_QUEUE_FACTORY_NAME = "jms/IGEQueueConnectionFactory";
  public static final String  JMS_INBOUND_QUEUE_NAME      = "SES.sapInboundQueue";
  public static final String  JMS_ERROR_QUEUE_NAME        = "SES.errorQueue";
  public static final String  JMS_JGB_START_QUEUE_NAME    = "SES.jgbStartQueue";


  //---------------------------------------------------------------------------
  // jms properties
  //---------------------------------------------------------------------------

  // names
  public static final String  JMS_PROP_NAME_MSG_TYPE    = "MessageType";
  public static final String  JMS_PROP_NAME_MSG_DESC    = "MessageDescription";

  // message type - values
  public static final int     MSG_TYPE_NULL                 = 0;
  public static final int     MSG_TYPE_CTRL_STOP            = 1;
  public static final int     MSG_TYPE_CTRL_JGB_FINISH      = 2;
  public static final int     MSG_TYPE_CTRL_AMV_FINISH      = 3;
  public static final int     MSG_TYPE_SAP_RECHNUNG         = 100;
  public static final int     MSG_TYPE_SAP_ANNULLATION      = 101;
  public static final int     MSG_TYPE_SAP_JGB_JOB          = 102;
  public static final int     MSG_TYPE_SAP_CUST_CREATE      = 103;
  public static final int     MSG_TYPE_SAP_CUST_STATUS      = 104;
  public static final int     MSG_TYPE_SAP_BALANCE          = 105;
  public static final int     MSG_TYPE_SAP_MATERIAL         = 106;
  public static final int     MSG_TYPE_SAP_STAKO_JOB        = 107;
  public static final int     MSG_TYPE_SAP_ANNULLATION_LIST = 108;
  public static final int     MSG_TYPE_SAP_STAKO            = 109;
  public static final int     MSG_TYPE_SAP_CUST_CHECK       = 110;

  // message description - values
  public static final String  MSG_DESC_NULL                 = "null";
  public static final String  MSG_DESC_CTRL_STOP            = "CtrlStop";
  public static final String  MSG_DESC_CTRL_JGB_FINISH      = "CtrlJgbFinish";
  public static final String  MSG_DESC_CTRL_AMV_FINISH      = "CtrlAmvFinish";
  public static final String  MSG_DESC_SAP_RECHNUNG         = "SAPRechnungVO";
  public static final String  MSG_DESC_SAP_ANNULLATION      = "SAPRechnungAnnullationVO";
  public static final String  MSG_DESC_SAP_JGB_JOB          = "SAPJGBJobVO";
  public static final String  MSG_DESC_SAP_CUST_CREATE      = "VersadrVO (Customer create)";
  public static final String  MSG_DESC_SAP_CUST_STATUS      = "SAPAdrStatusVO (Customer status)";
  public static final String  MSG_DESC_SAP_BALANCE          = "SAPBalance  (AdressNr resp. KtoNr)";
  public static final String  MSG_DESC_SAP_MATERIAL         = "SAPMaterial (ArtikelNr)";
  public static final String  MSG_DESC_SAP_STAKO_JOB        = "SAPStakoJobVO";
  public static final String  MSG_DESC_SAP_ANNULLATION_LIST = "SAPRechnungAnnullationVOList";
  public static final String  MSG_DESC_SAP_STAKO            = "SAPStakoVO";
  public static final String  MSG_DESC_SAP_CUST_CHECK       = "VersadrCheckVO";

} // end class


