package ch.ige.ses.vo.ses;

import java.io.Serializable;
import java.sql.Date;

/**
 * Value Object für einen Eintrag der Tabelle AMV_LAUF
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * @author    T. Iten
 * @version   $Id: AmvLaufVO.java,v 1.6 2006/12/13 14:58:39 iten Exp $
 */
public class AmvLaufVO implements Serializable
{
  //
  // const
  //
  public static final int LAUF_STAT_STARTED    = 0;
  public static final int LAUF_STAT_SELECTED   = 1;
  public static final int LAUF_STAT_SENT       = 2;
  public static final int LAUF_STAT_STOPPED    = 3;
  public static final int LAUF_STAT_FINISHED   = 4;

  //
  // fields
  //
  public int    amvLaufId     = 0;
  public String laufNr        = "";
  public int    laufStat      = LAUF_STAT_STARTED;
  public Date   createdDat    = null;
  public Date   changedDat    = null;


  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public AmvLaufVO()
  {
    // lazy bone
  }

  public AmvLaufVO(String laufNr)
  {
    this.laufNr = laufNr;
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  amvLaufId   =  " + this.amvLaufId   + "\n");
    buf.append("  laufNr      =  " + this.laufNr      + "\n");
    buf.append("  laufStat    =  " + this.laufStat    + "\n");
    buf.append("  createdDat  =  " + this.createdDat  + "\n");
    buf.append("  changedDat  =  " + this.changedDat  + "\n");

    return buf.toString();
  }

  public String toStringCompact()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("amvLaufId="   + this.amvLaufId   + ", ");
    buf.append("laufNr="      + this.laufNr      + ", ");
    buf.append("laufStat="    + this.laufStat    + ", ");
    buf.append("createdDat="  + this.createdDat  + ", ");
    buf.append("changedDat="  + this.changedDat);

    return buf.toString();
  }

} // end class

