package ch.ige.ses.vo.ses;

import java.io.Serializable;
import java.sql.Date;

/**
 * SES Value Object für einen Jahresgebühr-Lauf
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author    A. Rueegsegger
 * @version   $Id: JGBLaufVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */

public class JGBLaufVO implements Serializable
{
  //
  // const
  //
  public static final int SES_STAT_STARTED      = 0;
  public static final int SES_STAT_REQUEST_STOP = 1;
  public static final int SES_STAT_STOPPED      = 2;
  public static final int SES_STAT_FINISHED     = 3;

  public static final int SAP_STAT_NOT_STARTED  = 0;
  public static final int SAP_STAT_STARTED      = 1;
  public static final int SAP_STAT_STARTED_LAST = 2;
  public static final int SAP_STAT_STOPPED      = 3;
  public static final int SAP_STAT_FINISHED     = 4;

  //
  // fields
  //
  public int    jgbLaufId               = 0;
  public String laufNr                  = "";
  public Date   verarbStart             = null;
  public Date   verarbEnde              = null;

  public int    sesStat                 = SES_STAT_STARTED;
  public int    anzahlBfakturGelesen    = 0;    // Anzahl Bfakturen gelesen auf Bagis
  public int    countBfakturToSap       = 0;    // Anzahl Bfakturen auf SES gespeichert
  public int    anzahlBfaktjgbGeneriert = 0;    // Anzahl Bfaktjgb auf SES gespeichert
  public int    minBfakturToSap         = 0;    // Letzte an SapInbound gesendete Bfaktur

  public int    sapStat                 = SAP_STAT_NOT_STARTED;
  public int    anzahlBfakturAnSap      = 0;    // Anzahl Bfakturen an SAP gesendet
  public int    anzahlBfakturAnSapOk    = 0;    // Anzahl erfolgreich gespeicherten Bfakturen in SAP
  public int    anzahlBfakturAnSapNok   = 0;    // Anzahl nicht erfolgreich gespeicherten Bfakturen in SAP
  public int    anzahlBfaktjgbAnSap     = 0;    // Anzahl Bfaktjgb an SAP gesendet

  public Date   createdDat              = null;
  public Date   changedDat              = null;


  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public JGBLaufVO()
  {
    // lazy bone
  }


  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  jgbLaufId               =  " + this.jgbLaufId               + "\n");
    buf.append("  laufNr                  =  " + this.laufNr                  + "\n");
    buf.append("  verarbStart             =  " + this.verarbStart             + "\n");
    buf.append("  verarbEnde              =  " + this.verarbEnde              + "\n");

    buf.append("  sesStat                 =  " + this.sesStat                 + "\n");
    buf.append("  anzahlBfakturGelesen    =  " + this.anzahlBfakturGelesen    + "\n");
    buf.append("  anzahlBfaktjgbGeneriert =  " + this.anzahlBfaktjgbGeneriert + "\n");
    buf.append("  minBfakturToSap         =  " + this.minBfakturToSap         + "\n");
    buf.append("  countBfakturToSap       =  " + this.countBfakturToSap       + "\n");

    buf.append("  sapStat                 =  " + this.sapStat                 + "\n");
    buf.append("  anzahlBfakturAnSap      =  " + this.anzahlBfakturAnSap      + "\n");
    buf.append("  anzahlBfakturAnSapOk    =  " + this.anzahlBfakturAnSapOk    + "\n");
    buf.append("  anzahlBfakturAnSapNok   =  " + this.anzahlBfakturAnSapNok   + "\n");
    buf.append("  anzahlBfaktjgbAnSap     =  " + this.anzahlBfaktjgbAnSap     + "\n");

    buf.append("  createdDat              =  " + this.createdDat              + "\n");
    buf.append("  changedDat              =  " + this.changedDat              + "\n");
    return buf.toString();
  }
}

