package ch.ige.wdltool.ejb.impl;

import java.sql.SQLException;
import java.util.List;

import ch.ige.wdltool.dao.ClassDAO;
import ch.ige.wdltool.vo.ClassVO;

/**
 * Implements services for WDL classes.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: ClassImpl.java,v 1.2 2008/01/18 12:08:09 lewis_lee Exp $
 */
public class ClassImpl extends BaseServicesImpl<ClassDAO, ClassVO, Integer>
{
  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#getObjectName()
  @Override
  protected String getObjectName()
  {
    return "class";
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#getDAOClass()
  @Override
  protected Class<ClassDAO> getDAOClass()
  {
    return ClassDAO.class;
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#findAll(ch.ige.dbutils.dao.DAO)
  @Override
  protected List<ClassVO> findAll( ClassDAO dao ) throws SQLException
  {
    return dao.findAll();
  }
}
