package ch.ige.wdltool.validator;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.hibernate.validator.ValidatorClass;

/**
 * Checks that a text doesn't contain multiple blanks (spaces).
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: NoMultipleBlanks.java,v 1.1 2007/11/30 09:30:55 lewis_lee Exp $
 */
@ValidatorClass( NoMultipleBlanksValidator.class )
@Target( ElementType.METHOD )
@Retention( RetentionPolicy.RUNTIME )
@Documented
public @interface NoMultipleBlanks
{
  /**
   * The error message to show
   */
  String message() default "{validator.multipleBlanks}";
}
