package ch.ige.wdltool.validator;

import org.hibernate.validator.Validator;

/**
 * Validates a text: It must not contain multiple blanks.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id $
 */
public class NoMultipleBlanksValidator implements Validator<NoMultipleBlanks>
{
  // @see org.hibernate.validator.Validator#initialize(java.lang.annotation.Annotation)
  @SuppressWarnings( "unused" )
  public void initialize( NoMultipleBlanks parameters )
  {
    // Nothing to do
  }

  //part of the property constraint contract
  public boolean isValid( Object value )
  {
    if ( value == null )
    {
      return true;
    }
    if ( !( value instanceof String ) )
    {
      return false;
    }
    String text = (String) value;
    if ( text.contains( "  " ) )
    {
      return false;
    }
    else
    {
      return true;
    }
  }
}
