package ch.ige.wdltool.vo;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.dbutils.vo.IdentifiableVO;

/**
 * Represents a Nice class with a class number.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: ClassVO.java,v 1.5 2007/08/15 13:09:10 lewis_lee Exp $
 */
public class ClassVO extends AbstractVO implements IdentifiableVO<Integer>
{
  /**
   * The Nice class number
   */
  private Integer classId;
  
  /**
   * The lowest existing class number
   */
  public static final Integer LOWEST_CLASS_NUMBER = 1;
  
  /**
   * The highest existing class number
   */
  public static final Integer HIGHEST_CLASS_NUMBER = 45;
  
  /**
   * The number of existing class numbers
   */
  public static final Integer NUMBER_OF_CLASS_NUMBERS = HIGHEST_CLASS_NUMBER - LOWEST_CLASS_NUMBER + 1;

  // @see ch.ige.dbutils.vo.IdentifiableVO#getIdentifier()
  public Integer getIdentifier()
  {
    return this.classId;
  }

  // @see ch.ige.dbutils.vo.IdentifiableVO#setIdentifier(java.io.Serializable)
  public void setIdentifier( Integer id )
  {
    this.classId = id;
  }

  /**
   * Gets the class number.
   * @return the class number
   */
  public Integer getClassNumber()
  {
    return getIdentifier();
  }

  /**
   * Sets the class number.
   * @param classNumber The class number to set
   */
  public void setClassNumber( Integer classNumber )
  {
    setIdentifier( classNumber );
  }
}
