package ch.ige.wdltool.vo;

import java.util.List;

import ch.ige.dbutils.sql.SQLStatement;

/**
 * Used to replicate terms to the external WDL database.
 * TODO: is also used for stopwords -> refactor to generic name
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   heinzer
 * @version  $Id: TermReplicationVO.java,v 1.2 2009/03/05 08:13:03 adanlessossi Exp $
 */
public class TermReplicationVO
{
  /**
   * The insert statement to use.
   */
  private SQLStatement<Integer> insertStatement;

  /**
   * The parameters used to insert the terms.
   */
  private List<Object[]> termParameters;

  /**
   * Public constructor.
   * @param insertStatement
   * @param termParameters
   */
  public TermReplicationVO( SQLStatement<Integer> insertStatement, List<Object[]> termParameters )
  {
    this.insertStatement = insertStatement;
    this.termParameters = termParameters;
  }

  /**
   * Gets the insert statement.
   * @return The insert statement - this can have parameters, see <code>getTermParameters()</code>
   */
  public SQLStatement<Integer> getInsertStatement()
  {
    return this.insertStatement;
  }

  /**
   * Gets the list of insert statement parameters.
   * For every term to replicate there can be serveral parameters to use with the insert statement. 
   * @return The list of insert statement parameters for all terms.
   */
  public List<Object[]> getTermParameters()
  {
    return this.termParameters;
  }

}
