package ch.ige.wdltool.vo;

import junit.framework.TestCase;
import ch.ige.wdltool.dao.IpiTermCandidateDAOTest;
import ch.ige.wdltool.dao.IpiTermDAOTest;
import ch.ige.wdltool.dao.NegativeIpiTermDAOTest;
import ch.ige.wdltool.dao.NiceTermDAOTest;

/**
 * The advanced features of the term vo are tested here.
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   heinzer
 * @version  $Id: TermVOTest.java,v 1.1 2008/04/29 16:38:12 heinzer Exp $
 */
public class TermVOTest extends TestCase
{
  /**
   * Public constructor.
   * @param name The test's name
   */
  public TermVOTest( String name )
  {
    super( name );
  }

  /**
   * Tests {@link ch.ige.wdltool.vo.AbstractTermVO#AbstractTermVO(AbstractTermVO)}.
   * @throws Exception if the test fails
   */
  public void testCopyingConstructor() throws Exception
  {
    NiceTermDAOTest niceTermDAOTest = new NiceTermDAOTest( "dummy" );
    NiceTermVO niceTerm = niceTermDAOTest.getSerializableVO();
    NiceTermVO copiedNiceTerm = new NiceTermVO( niceTerm );
    assertTrue( "Checking result of deep copy", niceTermDAOTest.assertVOEqual( niceTerm, copiedNiceTerm ) );

    niceTerm = niceTermDAOTest.getSerializableVO();
    niceTerm.setNiceTermGroupNumber( 222222 );
    copiedNiceTerm = new NiceTermVO( niceTerm );
    assertTrue( "Checking result of deep copy with term group number", niceTermDAOTest.assertVOEqual( niceTerm, copiedNiceTerm ) );

    IpiTermDAOTest ipiTermDAOTest = new IpiTermDAOTest( "dummy" );
    IpiTermVO ipiTerm = ipiTermDAOTest.getSerializableVO();
    IpiTermVO copiedIpiTerm = new IpiTermVO( ipiTerm );
    assertTrue( "Checking result of deep copy", ipiTermDAOTest.assertVOEqual( ipiTerm, copiedIpiTerm ) );

    ipiTerm = ipiTermDAOTest.getSerializableVO();
    ipiTerm.setIpiTermGroupNumber( 987 );
    copiedIpiTerm = new IpiTermVO( ipiTerm );
    assertTrue( "Checking result of deep copy with term group number", ipiTermDAOTest.assertVOEqual( ipiTerm, copiedIpiTerm ) );

    IpiTermCandidateDAOTest ipiTermCandidateDAOTest = new IpiTermCandidateDAOTest( "dummy" );
    IpiTermCandidateVO ipiTermCandidate = ipiTermCandidateDAOTest.getSerializableVO();
    IpiTermCandidateVO copiedIpiTermCandidate = new IpiTermCandidateVO( ipiTermCandidate );
    assertTrue( "Checking result of deep copy", ipiTermCandidateDAOTest.assertVOEqual( ipiTermCandidate, copiedIpiTermCandidate ) );

    NegativeIpiTermDAOTest negativeIpiTermDAOTest = new NegativeIpiTermDAOTest( "dummy" );
    NegativeIpiTermVO negativeIpiTerm = negativeIpiTermDAOTest.getSerializableVO();
    NegativeIpiTermVO copiedNegativeIpiTerm = new NegativeIpiTermVO( negativeIpiTerm );
    assertTrue( "Checking result of deep copy", negativeIpiTermDAOTest.assertVOEqual( negativeIpiTerm, copiedNegativeIpiTerm ) );

  }
}